<?php

switch( $_GET['action'] ) {

/** SERVER/INFORMATION */

case 'info':

if( !$GLOBALS['me']->is_admin ) die;

$csrf = \site\utils::str_random(10);

echo '<div class="title">

<h2>' . $LANG['feed_information_title'] . '</h2>';

echo '</div>';

include 'includes/feed.php';

echo '<div class="form-table">';

try {

$feed = new feed();

$info = $feed->getServer;

echo '<div class="row"><span>' . $LANG['form_status'] . ':</span><div>OK</div></div>
<div class="row"><span>' . $LANG['form_name'] . ':</span><div>' . htmlspecialchars( $info['name'] ) . '</div></div>
<div class="row"><span>' . $LANG['settings_form_feedauth'] . ':</span><div>' . htmlspecialchars( $feed->auth_type ) . '</div></div>
<div class="row"><span>' . $LANG['form_timezone'] . ':</span><div>' . htmlspecialchars( $feed->timezone ) . '</div></div>';
if( isset( $info['DESCRIPTION'] ) ) {
  echo '<div class="row"><span>' . $LANG['form_description'] . ':</span><div>' . htmlspecialchars( $info['DESCRIPTION'] ) . '</div></div>';
}
if( isset( $info['URL'] ) ) {
  echo '<div class="row"><span>' . $LANG['form_website'] . ':</span><div><a href="' . htmlspecialchars( $info['URL'] ) . '" target="_blank">' . htmlspecialchars( $info['URL'] ) . '</a></div></div>';
}
if( isset( $info['CONTACT'] ) ) {
  echo '<div class="row"><span>' . $LANG['form_contact'] . ':</span><div><a href="?route=users.php&action=sendmail&email=' . htmlspecialchars( $info['CONTACT'] ) . '">' . htmlspecialchars( $info['CONTACT'] ) . '</div></div>';
}

}

catch( Exception $e ) {

  echo '<div class="row"><span>' . $LANG['form_status'] . ':</span><div>' . $e->getMessage() . '</div></div>';

}

break;

/** IMPORT COUPONS */

case 'import':

if( !ab_to( array( 'feed' => 'import' ) ) ) die;

echo '<div class="title">

<h2>' . $LANG['feed_istores_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">
<a href="?route=feed.php&amp;action=stores" class="btn">' . $LANG['stores'] . '</a>
<a href="?route=feed.php&amp;action=coupons" class="btn">' . $LANG['coupons'] . '</a>
<a href="?route=feed.php&amp;action=products" class="btn">' . $LANG['products'] . '</a>
</div>';

if( !empty( $LANG['feed_istores_subtitle'] ) ) {
  echo '<span>' . $LANG['feed_istores_subtitle'] . '</span>';
}

echo '</div>';

if( ( $feeds = \query\main::stores( array( 'show' => 'feed' ) ) ) === 0 ) {

echo '<div class="a-error">' . $LANG['feed_importe1']. '</div>';

} else {

echo '<div class="a-alert">' . sprintf( $LANG['feed_importnr_stores'], $feeds ) . '</div>';

echo '<div class="form-table">

<form action="#" method="GET" autocomplete="off">

<input type="hidden" name="route" value="feed.php" />
<input type="hidden" name="action" value="import2" />
<div class="row"><span>' . $LANG['feed_form_addfrom'] . ':</span><div><input type="date" name="date[]" value="' . date( 'Y-m-d', ( $lcheck = \query\main::get_option( 'lfeed_check' ) ) ) . '" style="display: inline-block; width: 80%" /><input type="time" name="date[]" value="' . date( 'H:i', $lcheck ) . '" style="display: inline-block; width: 20%" /></div></div>
<div class="row"><span>' . $LANG['feed_form_import'] . ':</span><div>
<input type="checkbox" name="import_coupons" value="1" id="import_coupons" checked /><label for="import_coupons" style="display: block;"><span></span> ' . $LANG['coupons'] . '</label>
<input type="checkbox" name="import_ecoupons" value="1" id="import_ecoupons"' . ( \query\main::get_option( 'feed_iexpc' ) ? ' checked' : '' ) . ' /> <label for="import_ecoupons" style="display: block;"><span></span> ' . $LANG['msg_feed_cpnpref_impexp'] . '</label>
<input type="checkbox" name="import_products" value="1" id="import_products" checked /><label for="import_products" style="display: block;"><span></span> ' . $LANG['products'] . '</label>
<input type="checkbox" name="import_eproducts" value="1" id="import_eproducts"' . ( \query\main::get_option( 'feed_iexpp' ) ? ' checked' : '' ) . ' /> <label for="import_eproducts" style="display: block;"><span></span> ' . $LANG['msg_feed_ppnpref_impexp'] . '</label>
</div></div>
<button class="btn">' . $LANG['feed_icoupons_button'] . '</button>

</form>

</div>';

}

break;

/** IMPORT COUPONS&PRODUCTS AUTOMATICALLY */

case 'import2':

if( !ab_to( array( 'feed' => 'import' ) ) ) die;

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['token'] ) && check_csrf( $_POST['token'], 'feed_import_csrf' ) ) {

include 'includes/feed.php';

try {

  $feed = new feed( \query\main::get_option( 'feedserver_ID' ), \query\main::get_option( 'feedserver_secret' ) );

  $ids = array();
  foreach( \query\main::while_stores( array( 'max' => 0, 'show' => 'feed' ) ) as $store ) {
    $ids[] = $store->feedID;
  }

  $ca = $cae = $cu = $cue = $pa = $pae = $pu = $pue = 0;

  if( !empty( $ids ) ) {

  $last_check = \query\main::get_option( 'lfeed_check' );

  /*

  CHECK FOR UPDATES FIRST

  */

  if( (boolean) \query\main::get_option( 'feed_moddt' ) ) {

  /*

  UPDATE COUPONS

  */

  try {

    $coupons = $feed->coupons( $options = array( 'store' => implode( ',', array_values( $ids ) ), 'update' => \site\utils::timeconvert( date( 'Y-m-d H:i:s', $last_check ), $feed->timezone ) ) );

    if( !empty( $coupons['Info']['Results'] ) ) {

    for( $cp = 1; $cp <= $coupons['Info']['Results']; $cp++ ) {

    if( $cp != 1 ) {
      $coupons = $feed->coupons( array_merge( array( 'page' => $cp ), $options ) );
    }

    foreach( $coupons['List'] as $coupon ) {

    if( ( $couponi = admin_query::coupon_imported( $coupon['ID'] ) ) ) {

    if( actions::edit_item2( $couponi->ID,
    array(
    'printable' => $coupon['is_printable'],
    'available_online' => $coupon['is_avbl_online'],
    'name' => $coupon['Title'],
    'link' => ( filter_var( $coupon['URL'], FILTER_VALIDATE_URL ) ? $coupon['URL'] : '' ),
    'code' => $coupon['Code'],
    'source' => $coupon['Source'],
    'description' => $coupon['Description'],
    'tags' => $coupon['Tags'],
    'start' => $coupon['Start_Date'],
    'end' => $coupon['End_Date']
    ) ) ) {
      $cu++;
    } else {
      $cue++;
    }

    }

    }

    usleep( 200000 ); // put a break after every page

    }

    }

  }

  catch( Exception $e ) { }

  /*

  UPDATE PRODUCTS

  */

  try {

    $products = $feed->products( $options = array( 'store' => implode( ',', array_values( $ids ) ), 'update' => \site\utils::timeconvert( date( 'Y-m-d H:i:s', $last_check ), $feed->timezone ) ) );

    if( !empty( $products['Info']['Results'] ) ) {

    for( $cp = 1; $cp <= $products['Info']['Pages']; $cp++ ) {

    if( $cp != 1 ) {
      $products = $feed->products( array_merge( array( 'page' => $cp ), $options ) );
    }

    foreach( $products['List'] as $product ) {

    if( ( $producti = admin_query::product_imported( $product['ID'] ) ) ) {

    if( actions::edit_product2( $producti->ID,
    array(
    'name' => $product['Title'],
    'price' => $product['Price'],
    'old_price' =>$product ['Old_Price'],
    'currency' => strtoupper( $product['Currency'] ),
    'link' => ( filter_var( $product['URL'], FILTER_VALIDATE_URL ) ? $product['URL'] : '' ),
    'description' => $product['Description'],
    'tags' => $product['Tags'],
    'start' => $product['Start_Date'],
    'end' => $product['End_Date']
    ) ) ) {
      $pu++;
    } else {
      $pue++;
    }

    }

    }

    usleep( 200000 ); // put a break after every page

    }

    }

  }

  catch( Exception $e ) { }

  }

  /*

  IMPORT COUPONS

  */

  if( isset( $_GET['import_coupons'] ) ) {

  try {

    $coupons = $feed->coupons( $options = array( 'per_page' => 30, 'store' => implode( ',', array_values( $ids ) ), 'view' => (!isset( $_GET['import_ecoupons'] ) ? 'active' : ''), 'date' => \site\utils::timeconvert( implode( $_GET['date'], ' ' ), $feed->timezone ) ) );

    if( !empty( $coupons['Info']['Results'] ) ) {

    for( $cp = 1; $cp <= $coupons['Info']['Pages']; $cp++ ) {

    if( $cp != 1 ) {
      $coupons = $feed->coupons( array_merge( array( 'page' => $cp ), $options ) );
    }

    foreach( $coupons['List'] as $coupon ) {

    if( !admin_query::coupon_imported( $coupon['ID'] ) ) {

    if( ( $store = admin_query::store_imported( $coupon['Store_ID'] ) ) &&
    actions::add_item(
    array(
    'feedID' => $coupon['ID'],
    'store' => $store->ID,
    'category' => $store->catID,
    'popular' => 0,
    'exclusive' => 0,
    'printable' => $coupon['is_printable'],
    'available_online' => $coupon['is_avbl_online'],
    'name' => $coupon['Title'],
    'link' => ( filter_var( $coupon['URL'], FILTER_VALIDATE_URL ) ? $coupon['URL'] : '' ),
    'code' => $coupon['Code'],
    'source' => $coupon['Source'],
    'description' => $coupon['Description'],
    'tags' => $coupon['Tags'],
    'cashback' => 0,
    'start' => $coupon['Start_Date'],
    'end' => $coupon['End_Date'],
    'image' => array(),
    'votes' => 0,
    'votes_average' => 0,
    'verified' => 0,
    'last_verif' => '',
    'publish' => 1,
    'meta_title' => '',
    'meta_keywords' => '',
    'meta_desc' => ''
    ) ) ) {
      $ca++;
    } else {
      $cae++;
    }

    }

    }

    usleep( 200000 ); // put a break after every page

    }

    }

  }

  catch( Exception $e ) { }

  }

  /*

  IMPORT PRODUCTS

  */

  if( isset( $_GET['import_products'] ) ) {

  try {

    $products = $feed->products( $options = array( 'store' => implode( ',', array_values( $ids ) ), 'view' => (!isset( $_GET['import_eproducts'] ) ? 'active' : ''), 'date' => \site\utils::timeconvert( implode( $_GET['date'], ' ' ), $feed->timezone ) ) );

    if( !empty( $products['Info']['Results'] ) ) {

    $impimg = (boolean) \query\main::get_option( 'feed_uppics' );

    for( $cp = 1; $cp <= $products['Info']['Pages']; $cp++ ) {

    if( $cp != 1 ) {
      $products = $feed->products( array_merge( array( 'page' => $cp ), $options ) );
    }

    foreach( $products['List'] as $product ) {

    if( !admin_query::product_imported( $product['ID'] ) ) {

    if( ( $store = admin_query::store_imported( $product['Store_ID'] ) ) &&
    actions::add_product(
    array(
    'feedID' => $product['ID'],
    'store' => $store->ID,
    'category' => $store->catID,
    'popular' => 0,
    'name' => $product['Title'],
    'price' => $product['Price'],
    'old_price' => $product['Old_Price'],
    'currency' => strtoupper( $product['Currency'] ),
    'link' => ( filter_var( $product['URL'], FILTER_VALIDATE_URL ) ? $product['URL'] : '' ),
    'description' => $product['Description'],
    'tags' => $product['Tags'],
    'cashback' => 0,
    'start' => $product['Start_Date'],
    'end' => $product['End_Date'],
    'publish' => 1,
    'import_image' => $impimg,
    'image_url' => $product['Image'],
    'image' => '',
    'meta_title' => '',
    'meta_keywords' => '',
    'meta_desc' => ''
    ) ) ) {
      $pa++;
    } else {
      $pae++;
    }

    }

    }

    usleep( 200000 ); // put a break after every page

    }

    }

  }

  catch( Exception $e ) { }

  }

  actions::set_option( array( 'lfeed_check' => time() ) ); // update time for last feed check

  echo '<div class="a-message">' . $LANG['msg_feed_finished'] . '</div>';

  echo '<ul class="announce-box">
  <li>' . $LANG['feed_coupons_sucimp'] . ':<b>' . $ca . '</b> <span>' . $LANG['form_error'] . ': ' . $cae . '</span></li>
  <li>' . $LANG['feed_products_sucimp'] . ':<b>' . $pa . '</b> <span>' . $LANG['form_error'] . ': ' . $pae . '</span></li>
  <li>' . $LANG['feed_coupons_sucupt'] . ':<b>' . $cu . '</b> <span>' . $LANG['form_error'] . ': ' . $cue . '</span></li>
  <li>' . $LANG['feed_products_sucupt'] . ':<b>' . $pu . '</b> <span>' . $LANG['form_error'] . ': ' . $pue . '</span></li>
  </ul>';

  }

}

catch ( Exception $e ) {
  echo '<div class="a-error">' . $e->getMessage() . '</div>';
}

}

$csrf = $_SESSION['feed_import_csrf'] = \site\utils::str_random(10);

if( $_SERVER['REQUEST_METHOD'] != 'POST' ) {

echo '<script>
window.onload = function() {
setTimeout(function(){
  document.forms[\'import_now\'].submit();
}, 1000);
}
</script>';

echo '<div style="text-align: center;">
  <h2>' . $LANG['feed_import_dleave'] . '</h2>
</div>

<form id="import_now" action="#" method="POST">
  <input type="hidden" name="token" value="' . $csrf . '" />
</form>';

} else {
  echo '<a href="#" class="btn" onclick="window.history.go(-2)">' . $LANG['back'] . '</a>';
}

break;

/** IMPORT COUPONS */

case 'import_coupons':

if( !ab_to( array( 'feed' => 'import' ) ) ) die;

if( empty( $_POST['id'] ) || !is_array( $_POST['id'] ) ) {
  echo '<div class="a-error">' . $LANG['msg_feed_seltoimp'] . '</div>';
} else {

if( isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'feed_import_csrf' ) ) {

$suc = $err = 0;

echo '<div class="a-message">' . $LANG['msg_feed_finished'] . '</div>';

foreach( $_POST['id'] as $coupon ) {

  $coupon = json_decode( urldecode( $coupon ), true );

  $ID = key( $coupon );
  $coupon = $coupon[$ID];

  if( isset( $coupon['store'] ) && isset( $_POST['category'] ) && isset( $coupon['Title'] ) && isset( $coupon['is_printable'] ) && isset( $coupon['is_avbl_online'] ) && isset( $coupon['Code'] ) && isset( $coupon['Source'] ) && isset( $coupon['URL'] ) && isset( $coupon['Description'] ) && isset( $coupon['Tags'] ) && isset( $coupon['Start_Date'] ) && isset( $coupon['End_Date'] ) )
  if( \query\main::store_exists( $coupon['store'] ) && actions::add_item(
  array(
  'feedID' => $ID,
  'store' => $coupon['store'],
  'category' => $_POST['category'],
  'popular' => 0,
  'exclusive' => 0,
  'printable' => $coupon['is_printable'],
  'available_online' => $coupon['is_avbl_online'],
  'name' => $coupon['Title'],
  'link' => ( filter_var( $coupon['URL'], FILTER_VALIDATE_URL ) ? $coupon['URL'] : '' ),
  'code' => $coupon['Code'],
  'source' => $coupon['Source'],
  'description' => $coupon['Description'],
  'tags' => $coupon['Tags'],
  'cashback' => 0,
  'start' => $coupon['Start_Date'],
  'end' => $coupon['End_Date'],
  'image' => array(),
  'votes' => 0,
  'votes_average' => 0,
  'verified' => 0,
  'last_verif' => '',
  'publish' => 1,
  'meta_title' => '',
  'meta_keywords' => '',
  'meta_desc' => ''
  ) ) ) {
    $suc++;
  } else {
    $err++;
  }

}

echo '<ul class="announce-box">
<li>' . $LANG['feed_coupons_sucimp'] . ':<b>' . $suc . '</b><span>' . $LANG['form_error'] . ': ' . $err . '</span></li>
</ul>';

}

}

echo '<a href="#" class="btn" onclick="window.history.go(-1)">' . $LANG['back'] . '</a>';

break;

/** IMPORT PRODUCTS */

case 'import_products':

if( !ab_to( array( 'feed' => 'import' ) ) ) die;

if( empty( $_POST['id'] ) || !is_array( $_POST['id'] ) ) {
  echo '<div class="a-error">' . $LANG['msg_feed_seltoimp'] . '</div>';
} else {

if( isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'feed_import_csrf' ) ) {

$suc = $err = 0;

echo '<div class="a-message">' . $LANG['msg_feed_finished'] . '</div>';

foreach( $_POST['id'] as $product ) {

  $product = json_decode( urldecode( $product ), true );

  $ID = key( $product );
  $product = $product[$ID];

  $impimg = (boolean) \query\main::get_option( 'feed_uppics' );

  if( isset( $product['store'] ) && isset( $_POST['category'] ) && isset( $product['Title'] ) && isset( $product['URL'] ) && isset( $product['Description'] ) && isset( $product['Tags'] ) && isset( $product['Image'] ) && isset( $product['Start_Date'] ) && isset( $product['End_Date'] ) )
  if( \query\main::store_exists( $product['store'] ) && actions::add_product(
  array(
  'feedID' => $ID,
  'store' => $product['store'],
  'category' => $_POST['category'],
  'popular' => 0,
  'name' => $product['Title'],
  'price' => $product['Price'],
  'old_price' => $product['Old_Price'],
  'currency' => strtoupper( $product['Currency'] ),
  'link' => ( filter_var( $product['URL'], FILTER_VALIDATE_URL ) ? $product['URL'] : '' ),
  'description' => $product['Description'],
  'tags' => $product['Tags'],
  'cashback' => 0,
  'start' => $product['Start_Date'],
  'end' => $product['End_Date'],
  'publish' => 1,
  'import_image' => $impimg,
  'image_url' => $product['Image'],
  'image' => '',
  'meta_title' => '',
  'meta_keywords' => '',
  'meta_desc' => ''
  ) ) ) {
    $suc++;
  } else {
    $err++;
  }

}

echo '<ul class="announce-box">
<li>' . $LANG['feed_products_sucimp'] . ':<b>' . $suc . '</b><span>' . $LANG['form_error'] . ': ' . $err . '</span></li>
</ul>';

}

}

echo '<a href="#" class="btn" onclick="window.history.go(-1)">' . $LANG['back'] . '</a>';

break;

/** IMPORT STORES */

case 'import_stores':

if( !ab_to( array( 'feed' => 'import' ) ) ) die;

if( empty( $_POST['id'] ) || !is_array( $_POST['id'] ) ) {
  echo '<div class="a-error">' . $LANG['msg_feed_seltoimp'] . '</div>';
} else {

if( isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'feed_import_csrf' ) ) {

$sa = $sae = $ca = $cae = $pa = $pae = 0;

$impimg = (boolean) \query\main::get_option( 'feed_uppics' );

echo '<div class="a-message">' . $LANG['msg_feed_finished'] . '</div>';

foreach( $_POST['id'] as $store ) {

  $store = json_decode( urldecode( $store ), true );

  $ID = key( $store );
  $store = $store[$ID];

  if( isset( $_POST['category'] ) && isset( $store['Name'] ) && isset( $store['is_physical'] ) && isset( $store['URL'] ) && isset( $store['Description'] ) && isset( $store['Tags'] ) && isset( $store['Image'] ) )

  if( $storeID = actions::add_store(
  array(
  'feedID' => $ID,
  'user' => $GLOBALS['me']->ID,
  'category' => $_POST['category'],
  'name' => $store['Name'],
  'type' => $store['is_physical'],
  'url' => $store['URL'],
  'description' => $store['Description'],
  'tags' => $store['Tags'],
  'hours' => ( !empty( $store['Hours'] ) ? @serialize( $store['Hours'] ) : '' ),
  'sellonline' => $store['Sell_Online'],
  'popular' => 0,
  'publish' => 1,
  'import_logo' => $impimg,
  'logo_url' => $store['Image'],
  'logo' => '',
  'phone' => $store['Phone'],
  'meta_title' => '',
  'meta_keywords' => '',
  'meta_desc' => ''
  ) ) ) {

  if( isset( $store['Locations'] ) && is_array( $store['Locations'] ) ) {
    foreach( $store['Locations'] as $location ) {
      actions::add_store_location( array_merge( array( 'Store' => $storeID ), $location ) );
    }
  }

if( isset( $_POST['coupons'] ) || isset( $_POST['products'] ) ) {

include_once 'includes/feed.php';

try {

  if( !isset( $feed ) ) {
    $feed = new feed( \query\main::get_option( 'feedserver_ID' ), \query\main::get_option( 'feedserver_secret' ) );
  }

  /*

  IMPORT COUPONS

  */

  if( isset( $_POST['coupons'] ) ) {

  try {

    $coupons = $feed->coupons( $options = array( 'per_page' => 30, 'store' => $ID, 'view' => (!(boolean) \query\main::get_option( 'feed_iexpc' ) ? 'active' : '') ) );

    if( !empty( $coupons['Info']['Results'] ) ) {

    for( $cp = 1; $cp <= $coupons['Info']['Pages']; $cp++ ) {

    if( $cp != 1 ) {
      $coupons = $feed->coupons( array_merge( array( 'page' => $cp ), $options ) );
    }

    foreach( $coupons['List'] as $coupon ) {

    if( !admin_query::coupon_imported( $coupon['ID'] ) ) {

    if( ( $store = admin_query::store_imported( $coupon['Store_ID'] ) ) &&
    actions::add_item(
    array(
    'feedID' => $coupon['ID'],
    'store' => $store->ID,
    'category' => $store->catID,
    'popular' => 0,
    'exclusive' => 0,
    'printable' => $coupon['is_printable'],
    'available_online' => $coupon['is_avbl_online'],
    'name' => $coupon['Title'],
    'link' => ( filter_var( $coupon['URL'], FILTER_VALIDATE_URL ) ? $coupon['URL'] : '' ),
    'code' => $coupon['Code'],
    'source' => $coupon['Source'],
    'description' => $coupon['Description'],
    'tags' => $coupon['Tags'],
    'cashback' => 0,
    'start' => $coupon['Start_Date'],
    'end' => $coupon['End_Date'],
    'image' => array(),
    'votes' => 0,
    'votes_average' => 0,
    'verified' => 0,
    'last_verif' => '',
    'publish' => 1,
    'meta_title' => '',
    'meta_keywords' => '',
    'meta_desc' => ''
    ) ) ) {
      $ca++;
    } else {
      $cae++;
    }

    }

    }

    usleep( 200000 ); // put a break after every page

    }

    }

  }

  catch( Exception $e ) { }

  }

  /*

  IMPORT PRODUCTS

  */

  if( isset( $_POST['products'] ) ) {

  try {

    $products = $feed->products( $options = array( 'store' => $ID, 'view' => (!(boolean) \query\main::get_option( 'feed_iexpp' ) ? 'active' : '') ) );

    if( !empty( $products['Info']['Results'] ) ) {

    for( $cp = 1; $cp <= $products['Info']['Pages']; $cp++ ) {

    if( $cp != 1 ) {
      $products = $feed->products( array_merge( array( 'page' => $cp ), $options ) );
    }

    foreach( $products['List'] as $product ) {

    if( !admin_query::product_imported( $product['ID'] ) ) {

    if( ( $store = admin_query::store_imported( $product['Store_ID'] ) ) &&
    actions::add_product(
    array(
    'feedID' => $product['ID'],
    'store' => $store->ID,
    'category' => $store->catID,
    'popular' => 0,
    'name' => $product['Title'],
    'price' => $product['Price'],
    'old_price' => $product['Old_Price'],
    'currency' => strtoupper( $product['Currency'] ),
    'link' => ( filter_var( $product['URL'], FILTER_VALIDATE_URL ) ? $product['URL'] : '' ),
    'description' => $product['Description'],
    'tags' => $product['Tags'],
    'cashback' => 0,
    'start' => $product['Start_Date'],
    'end' => $product['End_Date'],
    'publish' => 1,
    'import_image' => $impimg,
    'image_url' => $product['Image'],
    'image' => '',
    'meta_title' => '',
    'meta_keywords' => '',
    'meta_desc' => ''
    ) ) ) {
      $pa++;
    } else {
      $pae++;
    }

    }

    }

    usleep( 200000 ); // put a break after every page

    }

    }

  }

  catch( Exception $e ) { }

  }

}

catch( Exception $e ) { }

}

    $sa++;
  } else {
    $sae++;
  }

}

echo '<ul class="announce-box">
<li>' . $LANG['feed_stores_sucimp'] . ':<b>' . $sa . '</b><span>' . $LANG['form_error'] . ': ' . $sae . '</span></li>
<li>' . $LANG['feed_coupons_sucimp'] . ':<b>' . $ca . '</b><span>' . $LANG['form_error'] . ': ' . $cae . '</span></li>
<li>' . $LANG['feed_products_sucimp'] . ':<b>' . $pa . '</b><span>' . $LANG['form_error'] . ': ' . $pae . '</span></li>
</ul>';

}

}

echo '<a href="#" class="btn" onclick="window.history.go(-1)">' . $LANG['back'] . '</a>';

break;

/** PREVIEW COUPON */

case 'preview_coupon':

if( !ab_to( array( 'feed' => 'import' ) ) ) die;

if( isset( $_GET['id'] ) ) {

include 'includes/feed.php';

try {

  $feed = new feed( \query\main::get_option( 'feedserver_ID' ), \query\main::get_option( 'feedserver_secret' ) );

  try {

    $coupon = $feed->coupon( $_GET['id'] );

    if( $store_imported = admin_query::store_imported( $coupon['Store_ID'] ) ) {
    // Store ID
    $coupon['store'] = $store_imported->ID;
    // Product ID
    $ID = $_GET['id'];
    }

  }

  catch( Exception $e ) { }

}

catch( Exception $e ) { }

} else if( isset( $_GET['coupon'] ) ) {

  $coupon = json_decode( urldecode( $_GET['coupon'] ), true );
  if( !empty( $coupon ) ) {
  // Product ID
  $ID = key( $coupon );

  $coupon = \site\utils::array_map_recursive( 'htmlspecialchars', current( $coupon ) );
  }

}

if( !isset( $ID ) ) echo '<div class="a-error">' . $LANG['invalid_id'] . '</div>';

else {

$imported = admin_query::coupon_imported( $ID );

echo '<div class="title">

<h2>' . $LANG['feed_picoupon_title'] . '</h2>

<div style="float:right;margin: 0 2px 0 0;">

<div class="options">
<a href="#" class="btn">' . $LANG['options'] . '</a>
<ul>
<li><a href="#" class="more_fields">' . $LANG['more'] . '</a></li>
</ul>
</div>

<a href="?route=feed.php&amp;action=coupons" class="btn">' . $LANG['coupons_view'] . '</a>
</div>';

if( !empty( $LANG['feed_picoupon_subtitle'] ) ) {
  echo '<span>' . $LANG['feed_picoupon_subtitle'] . '</span>';
}

echo '</div>';

if( $coupon['store_is_physical'] ) {
if( $coupon['is_printable'] ) {
if( empty( $coupon['Source'] ) ) $type = 1;
else $type = 2;
} else $type = 0;
} else $type = 0;

$start_date = $coupon['Start_Date'];
$end_date = $coupon['End_Date'];

if( $imported ) {
  echo '<div class="a-alert">' . $LANG['msg_feed_cimported'] . '</div>';
} else {

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['coupon'] ) && is_array( $_POST['coupon'] ) ) {

$coupon = \site\utils::array_map_recursive( 'htmlspecialchars', $_POST['coupon'] );

if( \query\main::store_exists( $coupon['store'] ) ) {

$store_info = \query\main::store_infos( $coupon['store'] );

$coupon['store_sell_online'] = $store_info->sellonline;
$coupon['store_is_physical'] = $store_info->is_physical;
$coupon['is_avbl_online'] = $store_info->sellonline ? 1 : 0;
$coupon['is_printable'] = $store_info->is_physical ? 1 : 0;

$type = (int) $_POST['coupon_type'];

if( $type !== 0 && !$coupon['store_is_physical'] ) {
  $type = 0;
}

if( $type !== 0 && $coupon['store_is_physical'] ) {
  $coupon['is_avbl_online'] = 0;
}

if( $type === 0 && $coupon['store_is_physical'] && !isset( $_POST['coupon_use_online'] ) ) {
  $coupon['is_avbl_online'] = 0;
}

if( $type === 2 && !isset( $coupon['online_source'] ) ) {
  $coupon['Source'] = '';
}

if( isset( $coupon['ownlink'] ) ) {
  $coupon['URL'] = '';
}

} else {

$coupon['store_sell_online'] = 1;
$coupon['store_is_physical'] = 0;
$coupon['is_avbl_online'] = 1;
$coupon['is_printable'] = 0;
$type = 0;

}

$start_date = implode( $coupon['start'], ',' );
$end_date = implode( $coupon['end'], ',' );

if( isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'feed_import_csrf' ) ) {

  if( isset( $coupon['store'] ) && isset( $coupon['category'] ) && isset( $coupon['Title'] ) && isset( $coupon['Code'] ) && isset( $coupon['URL'] ) && isset( $coupon['Description'] ) && isset( $coupon['Tags'] ) && isset( $_FILES['source_file'] ) && isset( $coupon['votes'] ) && isset( $coupon['votes_average'] ) && isset( $coupon['lverified'] ) && isset( $coupon['meta_title'] ) && isset( $coupon['meta_keywords'] ) && isset( $coupon['meta_desc'] ) )
  if( actions::add_item(
  array(
  'feedID' => $ID,
  'store' => $coupon['store'],
  'category' => $coupon['category'],
  'popular' => ( isset( $coupon['popular'] ) ? 1 : 0 ),
  'exclusive' => ( isset( $coupon['exclusive'] ) ? 1 : 0 ),
  'printable' => ( in_array( $type, array( 1, 2 ) ) ? 1 : 0 ),
  'available_online' => ( !$coupon['store_is_physical'] ? 1 : ( $coupon['store_sell_online'] && isset( $_POST['coupon_use_online'] ) ? 1 : 0 ) ),
  'name' => $coupon['Title'],
  'link' => ( !isset( $coupon['ownlink'] ) && isset( $coupon['URL'] ) && filter_var( $coupon['URL'], FILTER_VALIDATE_URL ) ? $coupon['URL'] : '' ),
  'code' => ( !$coupon['store_is_physical'] ? $coupon['Code'] : ( $coupon['store_sell_online'] && isset( $_POST['coupon_use_online'] ) && $type === 0 ? $coupon['Code'] : '' ) ),
  'source' => ( $type === 2 ? ( isset( $coupon['online_source'] ) ? $coupon['Source'] : ( isset( $_FILES['source_file']['size'] ) && (int) $_FILES['source_file']['size'] > 0 ? $_FILES['source_file'] : '' ) ) : '' ),
  'description' => $coupon['Description'],
  'tags' => $coupon['Tags'],
  'cashback' => $coupon['reward_points'],
  'start' => $start_date,
  'end' => $end_date,
  'import_image' => ( isset( $coupon['import_image'] ) ? true : false ),
  'image_url' => $coupon['Image'],
  'image' => $_FILES['image'],
  'votes' => $coupon['votes'],
  'votes_average' => $coupon['votes_average'],
  'verified' => ( isset( $coupon['verified'] ) ? 1 : 0 ),
  'last_verif' => implode( $coupon['lverified'], ',' ),
  'publish' => ( isset( $coupon['publish'] ) ? 1 : 0 ),
  'meta_title' => $coupon['meta_title'],
  'meta_keywords' => $coupon['meta_keywords'],
  'meta_desc' => $coupon['meta_desc']
  ) ) )

  echo '<div class="a-success">' . $LANG['msg_added'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

}

}

if( !isset( $store['Image'] ) ) {
  $store['Image'] = '';
}

$csrf = $_SESSION['feed_import_csrf'] = \site\utils::str_random(10);

echo '<div class="form-table">

<form action="#" method="POST" enctype="multipart/form-data" autocomplete="off">

<div class="row"><span>' . $LANG['form_store_id'] . ':</span><div data-search="store" data-set-class="coupon"><input type="text" name="coupon[store]" value="' . ( $storeID = ( isset( $coupon['store'] ) ? (int) $coupon['store'] : '' ) ). '" required /><a href="#" class="downarr"></a>';
if( empty( $storeID ) || !\query\main::store_exists( $storeID ) ) {
  echo '<span id="idinfo"></span>';
} else if( isset( $store_info ) ) {
  echo '<span id="idinfo">' . $store_info->name . ' (ID: ' . $store_info->ID . ')</span>';
} else {
  $store_info = \query\main::store_infos( $storeID );
  echo '<span id="idinfo">' . $store_info->name . ' (ID: ' . $store_info->ID . ')</span>';
}
echo '</div></div>

<div class="row"><span>' . $LANG['form_category'] . ':</span>
<div><select name="coupon[category]">';
foreach( \query\main::group_categories( array( 'max' => 0 ) ) as $cat ) {
  echo '<optgroup label="' . $cat['infos']->name . '">';
  echo '<option value="' . $cat['infos']->ID . '">' . $cat['infos']->name . '</option>';
  if( isset( $cat['subcats'] ) ) {
    foreach( $cat['subcats'] as $subcat ) {
      echo '<option value="' . $subcat->ID . '">' . $subcat->name . '</option>';
    }
  }
  echo '</optgroup>';
}
echo '</select></div></div>

<div class="row"><span>' . $LANG['form_name'] . ':</span><div><input type="text" name="coupon[Title]" value="' . ( isset( $coupon['Title'] ) ? $coupon['Title'] : '' ) . '" /></div></div>
<div class="row coupon_type"' . ( !$coupon['store_is_physical'] ? ' style="display: none;"' : '' ) . '><span>' . $LANG['form_type'] . ':</span><div><select name="coupon_type" data-sell_online="' . ( $coupon['store_sell_online'] ? 'true' : 'false' ) . '">';
foreach( array( 0 => $LANG['dealnrprint'], 1 => $LANG['printhtml'], 2 => $LANG['printsource'] ) as $type_id => $type_name ) {
  echo '<option value="' . $type_id . '"' . ( $type === $type_id ? ' selected' : '' ) . '>' . $type_name . '</option>';
}
echo '</select></div></div>

<div class="row"' . ( $type !== 2 || !$coupon['store_is_physical'] ? ' style="display:none;"' : '' ) . '><span>' . $LANG['form_source'] . ':</span><div>
<input type="file" name="source_file" value=""' . ( !empty( $coupon['Source'] ) ? ' style="display:none;"' : '' ) . ' />
<input type="text" name="coupon[Source]" placeholder="http://" value="' . $coupon['Source'] . '"' . ( empty( $coupon['Source'] ) ? ' style="display: none;"' : '' ) . ' />
<input type="checkbox" name="coupon[online_source]" id="switch-ft"' . ( !empty( $coupon['Source'] ) ? ' checked' : '' ) . ' /> <label for="switch-ft"><span></span> ' . $LANG['msg_useexternal'] . '</label>
</div></div>

<div class="row"' . ( $type !== 0 || !$coupon['store_is_physical'] || ( $coupon['store_is_physical'] && !$coupon['store_sell_online'] ) ? ' style="display: none;"' : '' ) . '><span>' . $LANG['form_avabonline'] . ':</span><div><input type="checkbox" name="coupon_use_online" id="cuo" value="1"' . ( $coupon['store_sell_online'] && $coupon['is_avbl_online'] ? ' checked' : '' ) . ' /> <label for="cuo"><span></span> ' . $LANG['coupons_avabonline'] . '</label></div></div>
<div class="row"' . ( $type !== 0 || ( $coupon['store_is_physical'] && !$coupon['store_sell_online'] ) || !$coupon['is_avbl_online'] ? ' style="display: none;"' : '' ) . '><span>' . $LANG['form_code'] . ':</span><div><input type="text" name="coupon[Code]" value="' . ( isset( $coupon['Code'] ) ? $coupon['Code'] : '' ) . '" /></div></div>
<div class="row"' . ( $type !== 0 || ( $coupon['store_is_physical'] && !$coupon['store_sell_online'] ) || !$coupon['is_avbl_online'] ? ' style="display: none;"' : '' ) . '><span>' . $LANG['form_coupon_url'] . ':</span><div><input type="checkbox" name="coupon[ownlink]" id="ownlink" value="1"' . ( empty( $coupon['URL'] ) ? ' checked' : '' ) . ' /> <label for="ownlink"><span></span>' . $LANG['coupons_use_link'] . '</label> <br />
<input type="text" name="coupon[URL]" value="' . ( !empty( $coupon['URL']) ? $coupon['URL'] : 'http://' ) . '"' . ( empty( $coupon['URL'] ) ? ' style="display: none;"' : '' ) . ' />
</div></div>
<div class="row"><span>' . $LANG['form_description'] . ':</span><div><textarea name="coupon[Description]">' . ( isset( $coupon['Description'] ) ? $coupon['Description'] : '' ) . '</textarea></div></div>
<div class="row"><span>' . $LANG['form_tags'] . ':</span><div><input type="text" name="coupon[Tags]" value="' . ( isset( $coupon['Tags'] ) ? $coupon['Tags'] : '' ) . '" /></div></div>
<div class="row more_field" style="display:none;"><span>' . $LANG['form_reward_points'] . ' <span class="info"><span>' . $LANG['coupons_form_ireward_points'] . '</span></span>:</span><div><input type="numer" name="coupon[reward_points]" value="' . ( isset( $coupon['reward_points'] ) ? $coupon['reward_points'] : 0 ) . '" /></div></div>

<div class="row"><span>' . $LANG['form_logo'] . ':</span><div>';

if( !empty( $couponore['Image'] ) ) {

echo '<div style="display:table;margin-bottom:2px;"><img src="' . $coupon['Image'] . '" class="avt" alt="" style="display:table-cell;width:100px;height:50px;margin:0 20px 5px 0;" />
<div style="display:table-cell;vertical-align:middle;margin-left:25px;"><input type="checkbox" name="store[import_logo]" value="1" id="impimg"' . ( \query\main::get_option('feed_uppics') ? ' checked' : '' ) . ' /> <label for="impimg"><span></span> ' . $LANG['msg_feed_upload_timg'] . '</label></div>
</div>';

}

echo '<input type="file" name="logo" />
</div> </div>

<div class="row"><span>' . $LANG['verified'] . ':</span><div><input type="checkbox" name="coupon[verified]" id="row-verified" /> <label for="row-verified"><span></span> ' . $LANG['msg_setcouponverif'] . '</label></div></div>
<div class="row" style="display:none;"><span>' . $LANG['last_verification'] . ':</span><div><input type="date" name="coupon[lverified][date]" value="' . date( 'Y-m-d' ) . '" style="display:inline-block;width:80%" /><input type="time" name="coupon[lverified][hour]" value="' . date( 'H:i' ) . '" style="display:inline-block;width:20%" /></div></div>
<div class="row more_field" style="display:none;"><span>' . $LANG['votes'] . ':</span><div><input type="number" name="coupon[votes]" value="0" /></div></div>
<div class="row more_field" style="display:none;"><span>' . $LANG['votes_average'] . ':</span><div><input type="text" name="coupon[votes_average]" value="0" /></div></div>
<div class="row"><span>' . $LANG['form_start_date'] . ':</span><div><input type="date" name="coupon[start][date]" value="' . date( 'Y-m-d', strtotime( $start_date ) ) . '" style="display: inline-block; width: 80%" /><input type="time" name="coupon[start][hour]" value="' . date( 'H:i', strtotime( $start_date ) ) . '" style="display: inline-block; width: 20%" /></div></div>
<div class="row"><span>' . $LANG['form_end_date'] . ':</span><div><input type="date" name="coupon[end][date]" value="' . date( 'Y-m-d', strtotime( $end_date ) ) . '" style="display: inline-block; width: 80%" /><input type="time" name="coupon[end][hour]" value="' . date( 'H:i', strtotime( $end_date ) ) . '" style="display: inline-block; width: 20%" /></div></div>
<div class="row"><span>' . $LANG['form_addto'] . ':</span><div>
<input type="checkbox" name="coupon[popular]" id="popular" /> <label for="popular"><span></span> ' . $LANG['coupons_addpopular'] . '</label> <br />
<input type="checkbox" name="coupon[exclusive]" id="exclusive" /> <label for="exclusive"><span></span> ' . $LANG['coupons_addexclusive'] . '</label></div></div>
<div class="row"><span>' . $LANG['form_publish'] . ':</span><div><input type="checkbox" name="coupon[publish]" id="publish" checked /> <label for="publish"><span></span> ' . $LANG['msg_pubcoupon'] . '</label></div></div>

<div id="modify_mt" style="display: none; margin-top: 20px;">

<div class="title">
  <h2>' . $LANG['pages_title_meta'] . '</h2>
</div>

<div class="row"><span>' . $LANG['settings_form_metatitle'] . ' <span class="info"><span>' . sprintf( $LANG['settings_form_imetatitle'], '%MONTH%, %YEAR%' ) . '</span></span>:</span><div><input type="text" name="coupon[meta_title]" value="' . ( isset( $coupon['meta_title'] ) ? $coupon['meta_title'] : '' ) . '" /></div></div>
<div class="row"><span>' . $LANG['settings_form_metakeywords'] . ' <span class="info"><span>' . sprintf( $LANG['settings_form_imetatitle'], '%MONTH%, %YEAR%' ) . '</span></span>:</span><div><textarea name="coupon[meta_keywords]">' . ( isset( $coupon['meta_keywords'] ) ? $coupon['meta_keywords'] : '' ) . '</textarea></div></div>
<div class="row"><span>' . $LANG['settings_form_metadesc'] . ' <span class="info"><span>' . sprintf( $LANG['settings_form_imetatitle'], '%MONTH%, %YEAR%' ) . '</span></span>:</span><div><textarea name="coupon[meta_desc]">' . ( isset( $coupon['meta_desc'] ) ? $coupon['meta_desc'] : '' ) . '</textarea></div></div>

</div>

<input type="hidden" name="csrf" value="' . $csrf . '" />
<div class="twocols"><div>
<button class="btn"' . ( $imported ? ' disabled' : '' ) . '>' . $LANG['import'] . '</button></div>
<div>
<a href="#" class="btn" id="modify_mt_but">' . $LANG['pages_editmt_button'] . '</a>
</div>

</form>

</div>';

}

break;

/** PREVIEW PRODUCT */

case 'preview_product':

if( !ab_to( array( 'feed' => 'import' ) ) ) die;

if( isset( $_GET['id'] ) ) {

include 'includes/feed.php';

try {

  $feed = new feed( \query\main::get_option( 'feedserver_ID' ), \query\main::get_option( 'feedserver_secret' ) );

  try {

    $product = $feed->product( $_GET['id'] );

    if( $store_imported = admin_query::store_imported( $product['Store_ID'] ) ) {
    // Store ID
    $product['store'] = $store_imported->ID;
    // Product ID
    $ID = $_GET['id'];
    }

  }

  catch( Exception $e ) { }

}

catch( Exception $e ) { }

} else if( isset( $_GET['product'] ) ) {

  $product = json_decode( urldecode( $_GET['product'] ), true );

  // Product ID
  $ID = key( $product );

  $product = \site\utils::array_map_recursive( 'htmlspecialchars', current( $product ) );

}

if( !isset( $ID ) ) echo '<div class="a-error">' . $LANG['invalid_id'] . '</div>';

else {

$imported = admin_query::product_imported( $ID );

echo '<div class="title">

<h2>' . $LANG['feed_piproduct_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">
<a href="?route=feed.php&amp;action=products" class="btn">' . $LANG['products_view'] . '</a>
</div>';

if( !empty( $LANG['feed_piproduct_subtitle'] ) ) {
  echo '<span>' . $LANG['feed_piproduct_subtitle'] . '</span>';
}

echo '</div>';

$start_date = $product['Start_Date'];
$end_date = $product['End_Date'];

if( $imported ) {
  echo '<div class="a-alert">' . $LANG['msg_feed_pimported'] . '</div>';
} else {

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['product'] ) && is_array( $_POST['product'] ) ) {

$product = \site\utils::array_map_recursive( 'htmlspecialchars', $_POST['product'] );

if( isset( $product['ownlink'] ) ) {
  $product['URL'] = '';
}

if( isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'feed_import_csrf' ) ) {

  if( isset( $product['store'] ) && isset( $product['category'] ) && isset( $product['Title'] ) && isset( $product['URL'] ) && isset( $product['Description'] ) && isset( $product['Tags'] ) && isset( $_FILES['image'] ) && isset( $product['Image'] ) && isset( $product['meta_title'] ) && isset( $product['meta_keywords'] ) && isset( $product['meta_desc'] ) )
  if( actions::add_product(
  array(
  'feedID' => $ID,
  'store' => $product['store'],
  'category' => $product['category'],
  'popular' => ( isset( $product['popular'] ) ? 1 : 0 ),
  'name' => $product['Title'],
  'price' => $product['Price'],
  'old_price' => $product['Old_Price'],
  'currency' => strtoupper( $product['Currency'] ),
  'link' => ( !isset( $product['ownlink'] ) && isset( $product['URL'] ) && filter_var( $product['URL'], FILTER_VALIDATE_URL ) ? $product['URL'] : '' ),
  'description' => $product['Description'],
  'tags' => $product['Tags'],
  'cashback' => $product['reward_points'],
  'start' => implode( $product['start'], ' ' ),
  'end' => implode( $product['end'], ' ' ),
  'publish' => ( isset( $product['publish'] ) ? 1 : 0 ),
  'import_image' => ( isset( $store['import_image'] ) ? true : false ),
  'image_url' => $product['Image'],
  'image' => $_FILES['image'],
  'meta_title' => $product['meta_title'],
  'meta_keywords' => $product['meta_keywords'],
  'meta_desc' => $product['meta_desc']
  ) ) )

  echo '<div class="a-success">' . $LANG['msg_added'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

$start_date = implode( $product['start'], ' ' );
$end_date = implode( $product['end'], ' ' );

}

}

if( !isset( $product['Image'] ) ) {
  $product['Image'] = '';
}

$csrf = $_SESSION['feed_import_csrf'] = \site\utils::str_random(10);

echo '<div class="form-table">

<form action="#" method="POST" enctype="multipart/form-data" autocomplete="off">

<div class="row"><span>' . $LANG['form_store_id'] . ':</span><div data-search="store"><input type="text" name="product[store]" value="' . ( $storeID = ( isset( $product['store'] ) ? (int) $product['store'] : '' ) ). '" required /><a href="#" class="downarr"></a>';
if( empty( $storeID ) || !\query\main::store_exists( $storeID ) ) {
  echo '<span id="idinfo"></span>';
} else {
  $store_info = \query\main::store_infos( $storeID );
  echo '<span id="idinfo">' . $store_info->name . ' (ID: ' . $store_info->ID . ')</span>';
}
echo '</div></div>

<div class="row"><span>' . $LANG['form_category'] . ':</span>
<div><select name="product[category]">';
foreach( \query\main::group_categories( array( 'max' => 0 ) ) as $cat ) {
  echo '<optgroup label="' . $cat['infos']->name . '">';
  echo '<option value="' . $cat['infos']->ID . '">' . $cat['infos']->name . '</option>';
  if( isset( $cat['subcats'] ) ) {
    foreach( $cat['subcats'] as $subcat ) {
      echo '<option value="' . $subcat->ID . '">' . $subcat->name . '</option>';
    }
  }
  echo '</optgroup>';
}
echo '</select></div></div>

<div class="row"><span>' . $LANG['form_name'] . ':</span><div><input type="text" name="product[Title]" value="' . ( isset( $product['Title'] ) ? $product['Title'] : '' ) . '" /></div></div>
<div class="row"><span>' . $LANG['form_price'] . ':</span><div><input type="text" name="product[Price]" value="' . ( empty( $product['Price'] ) ? '' : \site\utils::money_format( $product['Price'] ) ) . '" placeholder="' . \site\utils::money_format( 0.00 ) . '" /></div></div>
<div class="row"><span>' . $LANG['form_old_price'] . ':</span><div><input type="text" name="product[Old_Price]" value="' . ( empty( $product['Old_Price'] ) ? '' : \site\utils::money_format( $product['Old_Price'] ) ) . '" placeholder="' . \site\utils::money_format( 0.00 ) . '" /></div></div>
<div class="row"><span>' . $LANG['form_currency'] . ':</span><div><input type="text" name="product[Currency]" value="' . ( isset( $product['Currency'] ) ? $product['Currency'] : '' ) . '" /></div></div>
<div class="row"><span>' . $LANG['form_product_url'] . ':</span><div><input type="checkbox" name="product[ownlink]" value="1" id="ownlink"' . ( empty( $product['URL'] ) ? ' checked' : '' ) . ' /> <label for="ownlink"><span></span> ' . $LANG['products_use_link'] . '</label> <br />
<input type="text" name="product[URL]" value="' . ( !empty( $product['URL'] ) ? $product['URL'] : 'http://' ) . '"' . ( empty( $product['URL'] ) ? ' style="display: none;"' : '' ) . ' />
</div></div>
<div class="row"><span>' . $LANG['form_description'] . ':</span><div><textarea name="product[Description]">' . ( isset( $product['Description'] ) ? $product['Description'] : '' ) . '</textarea></div></div>
<div class="row"><span>' . $LANG['form_tags'] . ':</span><div><input type="text" name="product[Tags]" value="' . ( isset( $product['Tags'] ) ? $product['Tags'] : '' ) . '" /></div></div>

<div class="row"><span>' . $LANG['form_image'] . ':</span>
<div>';

if( !empty( $product['Image'] ) ) {

echo '<div style="display: table; margin-bottom: 2px;"><img src="' . $product['Image'] . '" class="avt" alt="" style="display: table-cell; width: 80px; height: 80px; margin: 0 20px 5px 0;" />
<div style="display: table-cell; vertical-align: middle; margin-left: 25px;"><input type="checkbox" name="product[import_image]" value="1" id="impimg"' . ( \query\main::get_option('feed_uppics') ? ' checked' : '' ) . ' /> <label for="impimg"><span></span> ' . $LANG['msg_feed_upload_timg'] . '</label></div>
</div>';

}

echo '<input type="file" name="image" />
</div>
</div>

<div class="row more_field"><span>' . $LANG['form_reward_points'] . ' <span class="info"><span>' . $LANG['products_form_ireward_points'] . '</span></span>:</span><div><input type="numer" name="product[reward_points]" value="' . ( isset( $product['reward_points'] ) ? $product['reward_points'] : 0 ) . '" /></div></div>
<div class="row"><span>' . $LANG['form_start_date'] . ':</span><div><input type="date" name="product[start][date]" value="' . date( 'Y-m-d', strtotime( $start_date ) ) . '" style="display: inline-block; width: 80%" /><input type="time" name="product[start][hour]" value="' . date( 'H:i', strtotime( $start_date ) ) . '" style="display: inline-block; width: 20%" /></div></div>
<div class="row"><span>' . $LANG['form_end_date'] . ':</span><div><input type="date" name="product[end][date]" value="' . date( 'Y-m-d', strtotime( $end_date ) ) . '" style="display: inline-block; width: 80%" /><input type="time" name="product[end][hour]" value="' . date( 'H:i', strtotime( $end_date ) ) . '" style="display: inline-block; width: 20%" /></div></div>
<div class="row"><span>' . $LANG['form_addto'] . ':</span><div>
<input type="checkbox" name="product[popular]" id="popular" /> <label for="popular"><span></span> ' . $LANG['products_addpopular'] . '</label></div></div>
<div class="row"><span>' . $LANG['form_publish'] . ':</span><div><input type="checkbox" name="product[publish]" id="publish" checked /> <label for="publish"><span></span> ' . $LANG['msg_pubproduct'] . '</label></div></div>

<div id="modify_mt" style="display: none; margin-top: 20px;">

<div class="title">
  <h2>' . $LANG['pages_title_meta'] . '</h2>
</div>

<div class="row"><span>' . $LANG['settings_form_metatitle'] . ' <span class="info"><span>' . sprintf( $LANG['settings_form_imetatitle'], '%MONTH%, %YEAR%' ) . '</span></span>:</span><div><input type="text" name="product[meta_title]" value="' . ( isset( $product['meta_title'] ) ? $product['meta_title'] : '' ) . '" /></div></div>
<div class="row"><span>' . $LANG['settings_form_metakeywords'] . ' <span class="info"><span>' . sprintf( $LANG['settings_form_imetatitle'], '%MONTH%, %YEAR%' ) . '</span></span>:</span><div><textarea name="product[meta_keywords]">' . ( isset( $product['meta_keywords'] ) ? $product['meta_keywords'] : '' ) . '</textarea></div></div>
<div class="row"><span>' . $LANG['settings_form_metadesc'] . ' <span class="info"><span>' . sprintf( $LANG['settings_form_imetatitle'], '%MONTH%, %YEAR%' ) . '</span></span>:</span><div><textarea name="product[meta_desc]">' . ( isset( $product['meta_desc'] ) ? $product['meta_desc'] : '' ) . '</textarea></div></div>

</div>

<input type="hidden" name="csrf" value="' . $csrf . '" />
<input type="hidden" name="feedID" value="' . $ID . '" />
<input type="hidden" name="product[Image]" value="' . $product['Image'] . '" />

<div class="twocols"><div>
<button class="btn"' . ( $imported ? ' disabled' : '' ) . '>' . $LANG['import'] . '</button></div>
<div>
<a href="#" class="btn" id="modify_mt_but">' . $LANG['pages_editmt_button'] . '</a>
</div>

</form>

</div>';

}

break;

/** PREVIEW STORE */

case 'preview_store':

if( !ab_to( array( 'feed' => 'import' ) ) ) die;

if( isset( $_GET['id'] ) ) {

include 'includes/feed.php';

try {

  $feed = new feed( \query\main::get_option( 'feedserver_ID' ), \query\main::get_option( 'feedserver_secret' ) );

  try {

    $store = $feed->store( $_GET['id'] );

    // Store ID
    $ID = $_GET['id'];

  }

  catch( Exception $e ) { }

}

catch( Exception $e ) { }

} else if( isset( $_GET['store'] ) ) {

  $store = json_decode( urldecode( $_GET['store'] ), true );

  if( !empty( $store ) ) {
  // Store ID
  $ID = key( $store );

  $store = \site\utils::array_map_recursive( 'htmlspecialchars', current( $store ) );
  }

}

if( !isset( $ID ) ) echo '<div class="a-error">' . $LANG['invalid_id'] . '</div>';

else {

$imported = admin_query::store_imported( $ID );

echo '<div class="title">

<h2>' . $LANG['feed_pistore_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">
<a href="?route=feed.php&amp;action=list" class="btn">' . $LANG['stores_view'] . '</a>
</div>';

if( !empty( $LANG['feed_pistore_subtitle'] ) ) {
  echo '<span>' . $LANG['feed_pistore_subtitle'] . '</span>';
}

echo '</div>';

$locations = isset( $store['Locations'] ) ? $store['Locations'] : array();

if( $imported ) {
  echo '<div class="a-alert">' . $LANG['msg_feed_simported'] . '</div>';
} else {

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['store'] ) && is_array( $_POST['store'] ) ) {

$store = \site\utils::array_map_recursive( 'htmlspecialchars', $_POST['store'] );

if( isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'feed_import_csrf' ) ) {

  if( isset( $store['user'] ) && isset( $store['category'] ) && isset( $store['Name'] ) && isset( $_POST['store_type'] ) && isset( $store['URL'] ) && isset( $store['Description'] ) && isset( $store['Tags'] ) && isset( $_FILES['logo'] ) && isset( $store['Image'] ) && isset( $store['meta_title'] ) && isset( $store['meta_keywords'] ) && isset( $store['meta_desc'] ) )
  if( $storeID = actions::add_store(
  array(
  'feedID' => $ID,
  'user' => $store['user'],
  'category' => $store['category'],
  'name' => $store['Name'],
  'type' => $_POST['store_type'],
  'url' => $store['URL'],
  'description' => $store['Description'],
  'tags' => $store['Tags'],
  'hours' => ( isset( $store['view_hours'] ) ? array() : $store['Hours'] ),
  'sellonline' => ( isset( $store['Sell_Online'] ) ? 1 : 0 ),
  'popular' => ( isset( $store['popular'] ) ? 1 : 0 ),
  'publish' => ( isset( $store['publish'] ) ? 1 : 0 ),
  'import_logo' => ( isset( $store['import_logo'] ) ? true : false ),
  'logo_url' => $store['Image'],
  'logo' => $_FILES['logo'],
  'phone' => $store['Phone'],
  'meta_title' => $store['meta_title'],
  'meta_keywords' => $store['meta_keywords'],
  'meta_desc' => $store['meta_desc']
  ) ) ) {

if( isset( $_POST['locations'] ) && is_array( $_POST['locations'] ) ) {
  foreach( $_POST['locations'] as $location ) {
    actions::add_store_location( array_merge( array( 'Store' => $storeID ), (array) json_decode( $location ) ) );
  }
}
  echo '<div class="a-success">' . $LANG['msg_added'] . '</div>';
  } else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

$store['is_physical'] = isset( $_POST['store_type'] ) ? (boolean) $_POST['store_type'] : 0;

}

}

if( !isset( $store['Image'] ) ) {
  $store['Image'] = '';
}

$csrf = $_SESSION['feed_import_csrf'] = \site\utils::str_random(10);

echo '<div class="form-table">

<form action="#" method="POST" enctype="multipart/form-data" autocomplete="off">

<div class="row"><span>' . $LANG['form_user_id'] . ':</span><div data-search="user"><input type="text" name="store[user]" value="' . ( $userID = ( isset( $store['user'] ) ? (int) $store['user'] : $GLOBALS['me']->ID ) ) . '" required /><a href="#" class="downarr"></a>';
if( empty( $userID ) || !\query\main::user_exists( $userID ) ) {
  echo '<span id="idinfo"></span>';
} else if( $userID === $GLOBALS['me']->ID ){
  echo '<span id="idinfo">' . $GLOBALS['me']->Name . ' (ID: ' . $GLOBALS['me']->ID . ')</span>';
} else {
  $user_info = \query\main::user_infos( $userID );
  echo '<span id="idinfo">' . $user_info->name . ' (ID: ' . $user_info->ID . ')</span>';
}
echo '</div></div>

<div class="row"><span>' . $LANG['form_category'] . ':</span>
<div><select name="store[category]">';
foreach( \query\main::group_categories( array( 'max' => 0 ) ) as $cat ) {
  echo '<optgroup label="' . $cat['infos']->name . '">';
  echo '<option value="' . $cat['infos']->ID . '">' . $cat['infos']->name . '</option>';
  if( isset( $cat['subcats'] ) ) {
    foreach( $cat['subcats'] as $subcat ) {
      echo '<option value="' . $subcat->ID . '">' . $subcat->name . '</option>';
    }
  }
  echo '</optgroup>';
}
echo '</select></div></div>

<div class="row"><span>' . $LANG['form_name'] . ':</span><div><input type="text" name="store[Name]" value="' . ( isset( $store['Name'] ) ? $store['Name'] : '' ) . '" required /></div></div>

<div class="row"><span>' . $LANG['form_type'] . ':</span>
<div><select name="store_type">';
$types = array();
$types[0] = $LANG['onlinestore'];
$types[1] = $LANG['physicalstore'];
foreach( $types as $type_id => $type_msg ) {
  echo '<option value="' . $type_id . '"' . ( $type_id == 1 && !$store['is_physical'] ? '' : ' selected' ) . '>' . $type_msg . '</option>';
}

echo '</select>';
if( $store['is_physical'] ) echo '<span class="a-error" style="display: none; margin: 5px 0 0 0; width: 100%; box-sizing: border-box;">' . $LANG['msg_strcaseonline'] . '</span>';
echo '</div></div>

<div class="row"' . ( !$store['is_physical'] ? ' style="display: none;"' : '' ) . '><span>' . $LANG['form_locations'] . ':</span>
<div class="locations-info">';

if( !$store['is_physical'] ) {
  echo '<div class="a-message">' . $LANG['msg_physicalfirst'] . '</div>';
} else {

if( count( $locations ) > 0 ) {

echo '<ul>';
foreach( $locations as $k => $loc ) {
  echo "<li><input type=\"checkbox\" name=\"locations[$k]\" id=\"locations[$k]\" value='" . json_encode( $loc ) . "' checked /><label for=\"locations[$k]\"><span></span> " . implode( array_diff_key( $loc, array( 'ID' => '', 'Lat' => '', 'Lng' => '' ) ), ', ' ) . "</label></li>";
}
echo '</ul>';

} else {
  echo '<div class="a-message">' . $LANG['msg_no_locations'] . '</div>';
}

}

echo '</div></div>

<div class="row"' . ( !$store['is_physical'] ? ' style="display: none;"' : '' ) . '><span>' . $LANG['form_hours'] . ':</span>
<div class="hours-info"> <input name="store[view_hours]" type="checkbox" id="hours-bi"' . ( empty( $store['Hours'] ) || ( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['store']['view_hours'] ) ) ? ' checked' : '' ) . '/> <label for="hours-bi"><span></span> ' . $LANG['msg_blankinfo'] . '</label>
<ul' . ( empty( $store['Hours'] ) || ( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['store']['view_hours'] ) ) ? ' style="display: none;"' : '' ) . '>';
$hours = array( '01:00', '01:15', '01:30', '01:45', '02:00', '02:15', '02:30', '02:45', '03:00', '03:15', '03:30', '03:45', '04:00', '04:15', '04:30', '04:45',
                '05:00', '05:15', '05:30', '05:45', '06:00', '06:15', '06:30', '06:45', '07:00', '07:15', '07:30', '07:45', '08:00', '08:15', '08:30', '08:45',
                '09:00', '09:15', '09:30', '09:45', '10:00', '10:15', '10:30', '11:45', '12:00', '12:15', '12:30', '12:45', '13:00', '13:15', '13:30', '13:45',
                '14:00', '14:15', '14:30', '14:45', '15:00', '15:15', '15:30', '15:45', '16:00', '16:15', '16:30', '16:45', '17:00', '17:15', '17:30', '17:45',
                '18:00', '18:15', '18:30', '18:45', '19:00', '19:15', '19:30', '19:45', '20:00', '20:15', '20:30', '20:45', '21:00', '21:15', '21:30', '21:45',
                '22:00', '22:15', '22:30', '22:45', '23:00', '23:15', '23:30', '23:45', '24:00', '24:15', '24:30', '24:45');

foreach( \site\utils::days_of_week() as $k => $v ) {
  echo '<li>

  <span><input name="store[Hours][' . $k . '][opened]" type="checkbox" value="yes" id="day_' . $k . '"' . ( isset( $store['Hours'][$k]['opened'] ) ? ' checked' : '' ) . ' /> <label for="day_' . $k . '"><span></span> ' . $v . '</label></span>';

  echo '<span>
  <select name="store[Hours][' . $k . '][from]">';
  foreach( $hours as $no ) {
    echo '<option value="' . $no . '"' . ( isset( $store['Hours'][$k]['from'] ) && $store['Hours'][$k]['from'] == $no ? ' selected' : '' ) . '>' . $no . '</option>';
  }
  echo '</select>
  - <select name="store[Hours][' . $k . '][to]">';
  foreach( $hours as $no ) {
    echo '<option value="' . $no . '"' . ( isset( $store['Hours'][$k]['to'] ) && $store['Hours'][$k]['to'] == $no ? ' selected' : '' ) . '>' . $no . '</option>';
  }
  echo '</select>

  </span>

  </li>';
}
echo '</ul></div></div>

<div class="row"' . ( !$store['is_physical'] ? ' style="display:none;"' : '' ) . '><span>' . $LANG['form_sell_online'] . ':</span><div class="sell_online_cb"><input type="checkbox" id="sellonline" name="store[Sell_Online]" value="1"' . ( isset( $store['Sell_Online'] ) ? ' checked' : '' ) . ' /> <label for="sellonline"><span></span> <b>' . $LANG['yes'] . '</b><b>' . $LANG['no'] . '</b></label></div></div>

<div class="row"><span>' . $LANG['form_store_url'] . ':</span><div><input type="text" name="store[URL]" value="' . ( isset( $store['URL'] ) ? $store['URL'] : '' ) . '" /></div></div>
<div class="row"><span>' . $LANG['form_description'] . ':</span><div><textarea name="store[Description]">' . ( isset( $store['Description'] ) ? $store['Description'] : '' ) . '</textarea></div></div>
<div class="row"><span>' . $LANG['form_tags'] . ':</span><div><input type="text" name="store[Tags]" value="' . ( isset( $store['Tags'] ) ? $store['Tags'] : '' ) . '" /></div></div>

<div class="row"><span>' . $LANG['form_logo'] . ':</span><div>';

if( !empty( $store['Image'] ) ) {

echo '<div style="display:table;margin-bottom:2px;"><img src="' . $store['Image'] . '" class="avt" alt="" style="display:table-cell;width:100px;height:50px;margin: 0 20px 5px 0;" />
<div style="display:table-cell;vertical-align:middle; margin-left: 25px;"><input type="checkbox" name="store[import_logo]" value="1" id="impimg"' . ( \query\main::get_option('feed_uppics') ? ' checked' : '' ) . ' /> <label for="impimg"><span></span> ' . $LANG['msg_feed_upload_timg'] . '</label></div>
</div>';

}

echo '<input type="file" name="logo" />
</div> </div>

<div class="row"><span>' . $LANG['phone_no'] . ':</span><div><input type="text" name="store[Phone]" value="' . ( isset( $store['Phone'] ) ? $store['Phone'] : '' ) . '" /></div></div>
<div class="row"><span>' . $LANG['form_addto'] . ':</span><div><input type="checkbox" name="store[popular]" id="popular" /> <label for="popular"><span></span> ' . $LANG['coupons_addpopular'] . '</label></div></div>
<div class="row"><span>' . $LANG['form_publish'] . ':</span><div><input type="checkbox" name="store[publish]" id="publish" checked /> <label for="publish"><span></span> ' . $LANG['msg_pubstore'] . '</label></div></div>

<div id="modify_mt" style="display: none; margin-top: 20px;">

<div class="title">
  <h2>' . $LANG['pages_title_meta'] . '</h2>
</div>

<div class="row"><span>' . $LANG['settings_form_metatitle'] . ' <span class="info"><span>' . sprintf( $LANG['settings_form_imetatitle'], '%MONTH%, %YEAR%' ) . '</span></span>:</span><div><input type="text" name="store[meta_title]" value="' . ( isset( $store['meta_title'] ) ? $store['meta_title'] : '' ) . '" /></div></div>
<div class="row"><span>' . $LANG['settings_form_metakeywords'] . ' <span class="info"><span>' . sprintf( $LANG['settings_form_imetatitle'], '%MONTH%, %YEAR%' ) . '</span></span>:</span><div><textarea name="store[meta_keywords]">' . ( isset( $store['meta_keywords'] ) ? $store['meta_keywords'] : '' ) . '</textarea></div></div>
<div class="row"><span>' . $LANG['settings_form_metadesc'] . ' <span class="info"><span>' . sprintf( $LANG['settings_form_imetatitle'], '%MONTH%, %YEAR%' ) . '</span></span>:</span><div><textarea name="store[meta_desc]">' . ( isset( $store['meta_desc'] ) ? $store['meta_desc'] : '' ) . '</textarea></div></div>

</div>

<input type="hidden" name="csrf" value="' . $csrf . '" />
<input type="hidden" name="feedID" value="' . $ID . '" />
<input type="hidden" name="store[Image]" value="' . $store['Image'] . '" />

<div class="twocols"><div>
<button class="btn"' . ( $imported ? ' disabled' : '' ) . '>' . $LANG['import'] . '</button></div>
<div>
<a href="#" class="btn" id="modify_mt_but">' . $LANG['pages_editmt_button'] . '</a>
</div>

</form>

</div>';

}

break;

/** LIST OF FEED COUPONS */

case 'coupons':

if( !ab_to( array( 'feed' => 'view' ) ) ) die;

include 'includes/feed.php';

try {

  $feed = new feed( \query\main::get_option( 'feedserver_ID' ), \query\main::get_option( 'feedserver_secret' ) );
  $feed->exportAs( 'object' );

  try {

    $coupons = $feed->coupons( array( 'page' => (isset( $_GET['page'] ) ? $_GET['page'] : 1), 'per_page' => 10, 'orderby' => (isset( $_GET['orderby'] ) ? $_GET['orderby'] : 'date desc'), 'store' => (isset( $_GET['store'] ) ? $_GET['store'] : ''), 'category' => (isset( $_GET['category'] ) ? $_GET['category'] : ''), 'search' => (isset( $_GET['search'] ) ? $_GET['search'] : '') ) );

    echo '<div class="title">

    <h2>' . $LANG['coupons_title'] . '</h2>

    <div style="float:right; margin: 0 2px 0 0;">';
    if( ab_to( array( 'feed' => 'import' ) ) ) echo '<a href="?route=feed.php&amp;action=import" class="btn">' . $LANG['feed_icoupons'] . '</a>';
    echo '</div>';

    if( !empty( $LANG['feed_coupons_subtitle'] ) ) {
      echo '<span>' . $LANG['feed_coupons_subtitle'] . '</span>';
    }

    echo '</div>';

    $csrf = $_SESSION['feed_import_csrf'] = \site\utils::str_random(10);

    echo '<div class="page-toolbar">

    <form action="#" method="GET" autocomplete="off">
    <input type="hidden" name="route" value="feed.php" />
    <input type="hidden" name="action" value="coupons" />

    ' . $LANG['order_by'] . ':
    <select name="orderby">';
    foreach( array( 'date' => $LANG['order_date'], 'date desc' => $LANG['order_date_desc'], 'update' => $LANG['order_last_update'], 'update desc' => $LANG['order_last_update_desc'], 'name' => $LANG['order_name'], 'name desc' => $LANG['order_name_desc'] ) as $k => $v )echo '<option value="' . $k . '"' . (isset( $_GET['orderby'] ) && urldecode( $_GET['orderby'] ) == $k || !isset( $_GET['orderby'] ) && $k == 'date desc' ? ' selected' : '') . '>' . $v . '</option>';
    echo '</select> ';

    try {

      $category = $feed->categories();

      echo '<select name="category">
      <option value="">' . $LANG['all_categories'] . '</option>';
      foreach( $category['List'] as $k => $v ) {

        echo '<optgroup label="' . $v->Name . '">';
        echo '<option value="' . $k . '"' . ( isset( $_GET['category'] ) && $_GET['category'] == $k ? ' selected' : '' ) . '>' . $v->Name . '</option>';
        if( isset( $v->Subcategories ) ) {
          foreach( $v->Subcategories as $k1 => $v1 ) {
            echo '<option value="' . $k1 . '"' . ( isset( $_GET['category'] ) && $_GET['category'] == $k1 ? ' selected' : '' ) . '>' . $v1->Name . '</option>';
          }
        }
        echo '</optgroup>';
      }
      echo '</select>';

    }

    catch( Exception $e ) { }

    if( isset( $_GET['search'] ) ) {
    echo '<input type="hidden" name="search" value="' . htmlspecialchars( $_GET['search'] ) . '" />';
    }

    echo ' <button class="btn">' . $LANG['view'] . '</button>

    </form>

    <form action="#" method="GET" autocomplete="off">
    <input type="hidden" name="route" value="feed.php" />
    <input type="hidden" name="action" value="coupons" />';

    if( isset( $_GET['orderby'] ) ) {
    echo '<input type="hidden" name="orderby" value="' . htmlspecialchars( $_GET['orderby'] ) . '" />';
    }

    if( isset( $_GET['category'] ) ) {
    echo '<input type="hidden" name="category" value="' . htmlspecialchars( $_GET['category'] ) . '" />';
    }

    echo '<input type="search" name="search" value="' . (isset( $_GET['search'] ) ? htmlspecialchars( $_GET['search'] ) : '') . '" placeholder="' . $LANG['coupons_search_input'] . '" />
    <button class="btn">' . $LANG['search'] . '</button>
    </form>

    </div>';

    echo '<div class="results">' . ( (int) $coupons['Info']->Results === 1 ? sprintf( $LANG['result'], $coupons['Info']->Results ) : sprintf( $LANG['results'], $coupons['Info']->Results ) );
    if( !empty( $_GET['store'] ) || !empty( $_GET['category'] ) || !empty( $_GET['search'] ) ) echo ' / <a href="?route=feed.php&amp;action=coupons">' . $LANG['reset_view'] . '</a>';
    echo '</div>';

    if( $coupons['Info']->Results ) {

    echo '<form action="?route=feed.php&amp;action=import_coupons" method="POST">

    <ul class="elements-list">

    <li class="head"><input type="checkbox" id="selectall" data-checkall /> <label for="selectall"><span></span></label> ' . $LANG['name'] . '</li>';

    $feed_im  = ab_to( array( 'feed' => 'import' ) );

    if( $feed_im ) {

    echo '<div class="bulk_options">';

    echo $LANG['category'] . ':
    <select name="category">';
    foreach( \query\main::group_categories( array( 'max' => 0 ) ) as $cat ) {
      echo '<optgroup label="' . $cat['infos']->name . '">';
      echo '<option value="' . $cat['infos']->ID . '">' . $cat['infos']->name . '</option>';
      if( isset( $cat['subcats'] ) ) {
        foreach( $cat['subcats'] as $subcat ) {
          echo '<option value="' . $subcat->ID . '">' . $subcat->name . '</option>';
        }
      }
      echo '</optgroup>';
    }
    echo '</select>

    <button class="btn">' . $LANG['import_all'] . '</button>';
    echo '</div>';

    }

    foreach( $coupons['List'] as $item ) {

      $imported = admin_query::coupon_imported( $item->ID );
      $store_imported = admin_query::store_imported( $item->Store_ID );

      $jsdt = array();

      if( !$imported && $store_imported ) {

      $jsdt[$item->ID]['store'] = $store_imported->ID;
      $jsdt[$item->ID]['Title'] = $item->Title;
      $jsdt[$item->ID]['URL'] = $item->URL;
      $jsdt[$item->ID]['Code'] = $item->Code;
      $jsdt[$item->ID]['Tags'] = $item->Tags;
      $jsdt[$item->ID]['Image'] = $item->Image;
      $jsdt[$item->ID]['Description'] = $item->Description;
      $jsdt[$item->ID]['Start_Date'] = $item->Start_Date;
      $jsdt[$item->ID]['End_Date'] = $item->End_Date;
      $jsdt[$item->ID]['is_printable'] = $item->is_printable;
      $jsdt[$item->ID]['is_avbl_online'] = $item->is_avbl_online;
      $jsdt[$item->ID]['Source'] = $item->Source;
      $jsdt[$item->ID]['is_local_source'] = $item->is_local_source;
      $jsdt[$item->ID]['Store_ID'] = $item->Store_ID;
      $jsdt[$item->ID]['store_is_physical'] = $item->store_is_physical;
      $jsdt[$item->ID]['store_sell_online'] = $item->store_sell_online;
      //$jsdt[$item->ID]['Store_Name'] = $item->Store_Name;

      }

      echo '<li>
      <div>

      <input type="checkbox" name="id[' . $item->ID . ']" id="id[' . $item->ID . ']" value="' . ( $cdata = urlencode( json_encode( $jsdt ) ) ) . '"' . ( $imported || !$store_imported ? ' disabled' : '' ) . '/> <label for="id[' . $item->ID . ']"><span></span></label>

      <img src="' . \query\main::store_avatar( ( !empty( $item->Image ) ? $item->Image : $item->Store_Image ) ) . '" alt="" style="width:80px;" />

      <div class="info-div"><h2>' . ( $imported ? '<span class="msg-alert" title="' . $LANG['added_through_feed_msg'] . '">' . $LANG['added_through_feed'] . '</span> ' : '' ) . ( $item->is_active ? '<span class="msg-success">' . $LANG['active'] . '</span> ' : '<span class="msg-error">' . $LANG['expired'] . '</span> ' ) . $item->Title . '</h2>
      ' . ( !$store_imported ? '<span class="msg-error">' . $LANG['notadded_through_feed'] . '</span> ' : '' ) . '<a href="?route=feed.php&amp;action=coupons&amp;store=' . $item->Store_ID . '">' . $item->Store_Name . '</a>' . ( !$store_imported ? ' / <a href="?route=feed.php&amp;action=preview_store&amp;id=' . $item->Store_ID . '">' . $LANG['preview_import'] . '</a>' : '' ) . '</div>

      </div>

      <div style="clear:both;"></div>

      <div class="options">';
      if( !$imported && $store_imported && $feed_im ) {
        echo '<a href="?route=feed.php&amp;action=preview_coupon&amp;coupon=' . $cdata . '">' . $LANG['preview_import'] . '</a>';
      }

      if( !empty( $item->Description ) ) {
        echo '<a href="javascript:void(0)" onclick="$(this).show_next( { element: \'div\' } ); return false;">' . $LANG['description'] . '</a>';
        echo '<div style="display: none; margin: 10px 0; font-size: 12px;">' . nl2br( $item->Description ) . '</div>';
      }

      echo '</div>
      </li>';

    }

    echo '</ul>

    <input type="hidden" name="csrf" value="' . $csrf . '" />

    </form>';

    if( ( $pages = ceil( $coupons['Info']->Results / 10 ) ) > 1 ) {

    $page = isset( $_GET['page'] ) && (int) $_GET['page'] > 0 ? (int) $_GET['page'] : 1;
    $page = $page > $pages ? $pages : $page;

    echo '<div class="pagination">';

    if( $page > 1 )echo '<a href="' . \site\utils::update_uri( '', array( 'page' => $page - 1 ) ) . '" class="btn">' . $LANG['prev_page'] . '</a>';
    if( $page < $pages )echo '<a href="' . \site\utils::update_uri( '', array( 'page' => $page + 1 ) ) . '" class="btn">' . $LANG['next_page'] . '</a>';

    if( $pages > 1 ) {
    echo '<div class="pag_goto">' . sprintf( $LANG['pageofpages'], $page, $pages ) . '
    <form action="#" method="GET">';
    foreach( $_GET as $gk => $gv ) if( $gk !== 'page' ) echo '<input type="hidden" name="' . htmlspecialchars( $gk ) . '" value="' . htmlspecialchars( $gv ) . '" />';
    echo '<input type="number" name="page" min="1" max="' . $pages . '" size="5" value="' . $page . '" />
    <button class="btn">' . $LANG['go'] . '</button>
    </form>
    </div>';
    }

    echo '</div>';

    }

    } else echo '<div class="a-alert">' . $LANG['no_coupons_yet'] . '</div>';

  }

  catch ( Exception $e ){
    echo '<div class="a-alert">' . $e->getMessage() . '</div>';
  }

}

catch ( Exception $e ) {
  echo '<div class="a-error">' . $e->getMessage() . '</div>';
}

break;

/** LIST OF FEED PRODUCTS */

case 'products':

if( !ab_to( array( 'feed' => 'view' ) ) ) die;

include 'includes/feed.php';

try {

  $feed = new feed( \query\main::get_option( 'feedserver_ID' ), \query\main::get_option( 'feedserver_secret' ) );
  $feed->exportAs( 'object' );

  try {

    $products = $feed->products( array( 'page' => (isset( $_GET['page'] ) ? $_GET['page'] : 1), 'per_page' => 10, 'orderby' => (isset( $_GET['orderby'] ) ? $_GET['orderby'] : 'date desc'), 'store' => (isset( $_GET['store'] ) ? $_GET['store'] : ''), 'category' => (isset( $_GET['category'] ) ? $_GET['category'] : ''), 'search' => (isset( $_GET['search'] ) ? $_GET['search'] : '') ) );

    echo '<div class="title">

    <h2>' . $LANG['products_title'] . '</h2>

    <div style="float:right; margin: 0 2px 0 0;">';
    if( ab_to( array( 'feed' => 'import' ) ) ) echo '<a href="?route=feed.php&amp;action=import" class="btn">' . $LANG['feed_icoupons'] . '</a>';
    echo '</div>';

    if( !empty( $LANG['feed_products_subtitle'] ) ) {
      echo '<span>' . $LANG['feed_products_subtitle'] . '</span>';
    }

    echo '</div>';

    $csrf = $_SESSION['feed_import_csrf'] = \site\utils::str_random(10);

    echo '<div class="page-toolbar">

    <form action="#" method="GET" autocomplete="off">
    <input type="hidden" name="route" value="feed.php" />
    <input type="hidden" name="action" value="products" />

    ' . $LANG['order_by'] . ':
    <select name="orderby">';
    foreach( array( 'date' => $LANG['order_date'], 'date desc' => $LANG['order_date_desc'], 'update' => $LANG['order_last_update'], 'update desc' => $LANG['order_last_update_desc'], 'name' => $LANG['order_name'], 'name desc' => $LANG['order_name_desc'] ) as $k => $v )echo '<option value="' . $k . '"' . (isset( $_GET['orderby'] ) && urldecode( $_GET['orderby'] ) == $k || !isset( $_GET['orderby'] ) && $k == 'date desc' ? ' selected' : '') . '>' . $v . '</option>';
    echo '</select> ';

    try {

      $category = $feed->categories();

      echo '<select name="category">
      <option value="">' . $LANG['all_categories'] . '</option>';
      foreach( $category['List'] as $k => $v ) {

        echo '<optgroup label="' . $v->Name . '">';
        echo '<option value="' . $k . '"' . ( isset( $_GET['category'] ) && $_GET['category'] == $k ? ' selected' : '' ) . '>' . $v->Name . '</option>';
        if( isset( $v->Subcategories ) ) {
          foreach( $v->Subcategories as $k1 => $v1 ) {
            echo '<option value="' . $k1 . '"' . ( isset( $_GET['category'] ) && $_GET['category'] == $k1 ? ' selected' : '' ) . '>' . $v1->Name . '</option>';
          }
        }
        echo '</optgroup>';
      }
      echo '</select>';

    }

    catch( Exception $e ) { }

    if( isset( $_GET['search'] ) ) {
    echo '<input type="hidden" name="search" value="' . htmlspecialchars( $_GET['search'] ) . '" />';
    }

    echo ' <button class="btn">' . $LANG['view'] . '</button>

    </form>

    <form action="#" method="GET" autocomplete="off">
    <input type="hidden" name="route" value="feed.php" />
    <input type="hidden" name="action" value="products" />';

    if( isset( $_GET['orderby'] ) ) {
    echo '<input type="hidden" name="orderby" value="' . htmlspecialchars( $_GET['orderby'] ) . '" />';
    }

    if( isset( $_GET['category'] ) ) {
    echo '<input type="hidden" name="category" value="' . htmlspecialchars( $_GET['category'] ) . '" />';
    }

    echo '<input type="search" name="search" value="' . (isset( $_GET['search'] ) ? htmlspecialchars( $_GET['search'] ) : '') . '" placeholder="' . $LANG['products_search_input'] . '" />
    <button class="btn">' . $LANG['search'] . '</button>
    </form>

    </div>';

    echo '<div class="results">' . ( (int) $products['Info']->Results === 1 ? sprintf( $LANG['result'], $products['Info']->Results ) : sprintf( $LANG['results'], $products['Info']->Results ) );
    if( !empty( $_GET['store'] ) || !empty( $_GET['category'] ) || !empty( $_GET['search'] ) ) echo ' / <a href="?route=feed.php&amp;action=products">' . $LANG['reset_view'] . '</a>';
    echo '</div>';

    if( $products['Info']->Results ) {

    echo '<form action="?route=feed.php&amp;action=import_products" method="POST">

    <ul class="elements-list">

    <li class="head"><input type="checkbox" id="selectall" data-checkall /> <label for="selectall"><span></span></label> ' . $LANG['name'] . '</li>';

    $feed_im  = ab_to( array( 'feed' => 'import' ) );

    if( $feed_im ) {

    echo '<div class="bulk_options">';

    echo $LANG['category'] . ':
    <select name="category">';
    foreach( \query\main::group_categories( array( 'max' => 0 ) ) as $cat ) {
      echo '<optgroup label="' . $cat['infos']->name . '">';
      echo '<option value="' . $cat['infos']->ID . '">' . $cat['infos']->name . '</option>';
      if( isset( $cat['subcats'] ) ) {
        foreach( $cat['subcats'] as $subcat ) {
          echo '<option value="' . $subcat->ID . '">' . $subcat->name . '</option>';
        }
      }
      echo '</optgroup>';
    }
    echo '</select>

    <button class="btn">' . $LANG['import_all'] . '</button>';
    echo '</div>';

    }

    foreach( $products['List'] as $item ) {

      $imported = admin_query::product_imported( $item->ID );
      $store_imported = admin_query::store_imported( $item->Store_ID );

      $jsdt = array();

      if( !$imported && $store_imported ) {

      $jsdt[$item->ID]['store'] = $store_imported->ID;
      $jsdt[$item->ID]['Title'] = $item->Title;
      $jsdt[$item->ID]['URL'] = $item->URL;
      $jsdt[$item->ID]['Price'] = $item->Price;
      $jsdt[$item->ID]['Old_Price'] = $item->Old_Price;
      $jsdt[$item->ID]['Currency'] = $item->Currency;
      $jsdt[$item->ID]['Tags'] = $item->Tags;
      $jsdt[$item->ID]['Description'] = $item->Description;
      $jsdt[$item->ID]['Image'] = $item->Image;
      $jsdt[$item->ID]['Start_Date'] = $item->Start_Date;
      $jsdt[$item->ID]['End_Date'] = $item->End_Date;
      $jsdt[$item->ID]['Store_ID'] = $item->Store_ID;
      //$jsdt[$item->ID]['Store_Name'] = $item->Store_Name;

      }

      echo '<li>
      <div>

      <input type="checkbox" name="id[' . $item->ID . ']" id="id[' . $item->ID . ']" value="' . ( $cdata = urlencode( json_encode( $jsdt ) ) ) . '"' . ( $imported || !$store_imported ? ' disabled' : '' ) . '/> <label for="id[' . $item->ID . ']"><span></span></label>

      <img src="' . \query\main::product_avatar( $item->Image ) . '" alt="" style="height: 50px; width: 50px;" />

      <div class="info-div"><h2>' . ( $imported ? '<span class="msg-alert" title="' . $LANG['added_through_feed_msg'] . '">' . $LANG['added_through_feed'] . '</span> ' : '' ) . ( $item->is_active ? '<span class="msg-success">' . $LANG['active'] . '</span> ' : '<span class="msg-error">' . $LANG['expired'] . '</span> ' ) . $item->Title . '</h2>
      ' . ( !$store_imported ? '<span class="msg-error">' . $LANG['notadded_through_feed'] . '</span> ' : '' ) . '<a href="?route=feed.php&amp;action=products&amp;store=' . $item->Store_ID . '">' . $item->Store_Name . '</a>' . ( !$store_imported ? ' / <a href="?route=feed.php&amp;action=preview_store&amp;id=' . $item->Store_ID . '">' . $LANG['preview_import'] . '</a>' : '' ) . '</div>

      </div>

      <div style="clear:both;"></div>

      <div class="options">';
      if( !$imported && $store_imported && $feed_im ) {
        echo '<a href="?route=feed.php&amp;action=preview_product&amp;product=' . $cdata . '">' . $LANG['preview_import'] . '</a>';
      }

      if( !empty( $item->Description ) ) {
      echo '<a href="javascript:void(0)" onclick="$(this).show_next( { element: \'div\' } ); return false;">' . $LANG['description'] . '</a>';
      echo '<div style="display: none; margin: 10px 0; font-size: 12px;">' . nl2br( $item->Description ) . '</div>';
      }

      echo '</div>
      </li>';

    }

    echo '</ul>

    <input type="hidden" name="csrf" value="' . $csrf . '" />

    </form>';

    if( ( $pages = ceil( $products['Info']->Results / 10 ) ) > 1 ) {

    $page = isset( $_GET['page'] ) && (int) $_GET['page'] > 0 ? (int) $_GET['page'] : 1;
    $page = $page > $pages ? $pages : $page;

    echo '<div class="pagination">';

    if( $page > 1 )echo '<a href="' . \site\utils::update_uri( '', array( 'page' => $page - 1 ) ) . '" class="btn">' . $LANG['prev_page'] . '</a>';
    if( $page < $pages )echo '<a href="' . \site\utils::update_uri( '', array( 'page' => $page + 1 ) ) . '" class="btn">' . $LANG['next_page'] . '</a>';

    if( $pages > 1 ) {
    echo '<div class="pag_goto">' . sprintf( $LANG['pageofpages'], $page, $pages ) . '
    <form action="#" method="GET">';
    foreach( $_GET as $gk => $gv ) if( $gk !== 'page' ) echo '<input type="hidden" name="' . htmlspecialchars( $gk ) . '" value="' . htmlspecialchars( $gv ) . '" />';
    echo '<input type="number" name="page" min="1" max="' . $pages . '" size="5" value="' . $page . '" />
    <button class="btn">' . $LANG['go'] . '</button>
    </form>
    </div>';
    }

    echo '</div>';

    }

    } else echo '<div class="a-alert">' . $LANG['no_products_yet'] . '</div>';

  }

  catch ( Exception $e ){
    echo '<div class="a-alert">' . $e->getMessage() . '</div>';
  }

}

catch ( Exception $e ) {
  echo '<div class="a-error">' . $e->getMessage() . '</div>';
}

break;

/** LIST OF FEED STORES */

default:

if( !ab_to( array( 'feed' => 'view' ) ) ) die;

include 'includes/feed.php';

try {

  $feed = new feed( \query\main::get_option( 'feedserver_ID' ), \query\main::get_option( 'feedserver_secret' ) );
  $feed->exportAs( 'object' );

  try {

    $stores = $feed->stores( array( 'orderby' => (isset( $_GET['orderby'] ) ? $_GET['orderby'] : 'date desc'), 'page' => (isset( $_GET['page'] ) ? $_GET['page'] : 1), 'per_page' => 10, 'category' => (isset( $_GET['category'] ) ? $_GET['category'] : ''), 'search' => (isset( $_GET['search'] ) ? $_GET['search'] : '') ) );

    echo '<div class="title">

    <h2>' . $LANG['stores_title'] . '</h2>';

    if( !empty( $LANG['feed_stores_subtitle'] ) ) {
      echo '<span>' . $LANG['feed_stores_subtitle'] . '</span>';
    }

    echo '</div>';

    $csrf = $_SESSION['feed_import_csrf'] = \site\utils::str_random(10);

    echo '<div class="page-toolbar">

    <form action="#" method="GET" autocomplete="off">
    <input type="hidden" name="route" value="feed.php" />
    <input type="hidden" name="action" value="list" />

    ' . $LANG['order_by'] . ':
    <select name="orderby">';
    foreach( array( 'date' => $LANG['order_date'], 'date desc' => $LANG['order_date_desc'], 'update' => $LANG['order_last_update'], 'update desc' => $LANG['order_last_update_desc'], 'name' => $LANG['order_name'], 'name desc' => $LANG['order_name_desc'] ) as $k => $v )echo '<option value="' . $k . '"' . (isset( $_GET['orderby'] ) && urldecode( $_GET['orderby'] ) == $k || !isset( $_GET['orderby'] ) && $k == 'date desc' ? ' selected' : '') . '>' . $v . '</option>';
    echo '</select> ';

    try {

      $category = $feed->categories();

      echo '<select name="category">
      <option value="">' . $LANG['all_categories'] . '</option>';
      foreach( $category['List'] as $k => $v ) {

        echo '<optgroup label="' . $v->Name . '">';
        echo '<option value="' . $k . '"' . ( isset( $_GET['category'] ) && $_GET['category'] == $k ? ' selected' : '' ) . '>' . $v->Name . '</option>';
        if( isset( $v->Subcategories ) ) {
          foreach( $v->Subcategories as $k1 => $v1 ) {
            echo '<option value="' . $k1 . '"' . ( isset( $_GET['category'] ) && $_GET['category'] == $k1 ? ' selected' : '' ) . '>' . $v1->Name . '</option>';
          }
        }
        echo '</optgroup>';
      }
      echo '</select>';

    }

    catch( Exception $e ) { }

    if( isset( $_GET['search'] ) ) {
    echo '<input type="hidden" name="search" value="' . htmlspecialchars( $_GET['search'] ) . '" />';
    }

    echo ' <button class="btn">' . $LANG['view'] . '</button>

    </form>

    <form action="#" method="GET" autocomplete="off">
    <input type="hidden" name="route" value="feed.php" />
    <input type="hidden" name="action" value="list" />';

    if( isset( $_GET['orderby'] ) ) {
    echo '<input type="hidden" name="orderby" value="' . htmlspecialchars( $_GET['orderby'] ) . '" />';
    }

    if( isset( $_GET['category'] ) ) {
    echo '<input type="hidden" name="category" value="' . htmlspecialchars( $_GET['category'] ) . '" />';
    }

    echo '<input type="search" name="search" value="' . (isset( $_GET['search'] ) ? htmlspecialchars( $_GET['search'] ) : '') . '" placeholder="' . $LANG['stores_search_input'] . '" />
    <button class="btn">' . $LANG['search'] . '</button>
    </form>

    </div>';

    echo '<div class="results">' . ( (int) $stores['Info']->Results === 1 ? sprintf( $LANG['result'], $stores['Info']->Results ) : sprintf( $LANG['results'], $stores['Info']->Results ) );
    if( !empty( $_GET['category'] ) || !empty( $_GET['search'] ) ) echo ' / <a href="?route=feed.php&amp;action=list">' . $LANG['reset_view'] . '</a>';
    echo '</div>';

    if( $stores['Info']->Results ) {

    echo '<form action="?route=feed.php&amp;action=import_stores" method="POST">

    <ul class="elements-list">

    <li class="head"><input type="checkbox" id="selectall" data-checkall /> <label for="selectall"><span></span></label> ' . $LANG['name'] . '</li>';

    $feed_im  = ab_to( array( 'feed' => 'import' ) );

    if( $feed_im ) {

    echo '<div class="bulk_options">';

    echo $LANG['category'] . ':
    <select name="category">';
    foreach( \query\main::group_categories( array( 'max' => 0 ) ) as $cat ) {
      echo '<optgroup label="' . $cat['infos']->name . '">';
      echo '<option value="' . $cat['infos']->ID . '">' . $cat['infos']->name . '</option>';
      if( isset( $cat['subcats'] ) ) {
        foreach( $cat['subcats'] as $subcat ) {
          echo '<option value="' . $subcat->ID . '">' . $subcat->name . '</option>';
        }
      }
      echo '</optgroup>';
    }
    echo '</select>

    <input type="checkbox" name="coupons" value="1" id="import_t_coupons" checked /> <label for="import_t_coupons"><span></span> ' . $LANG['feed_icouponstoo'] . '</label>
    <input type="checkbox" name="products" value="1" id="import_t_products" checked /> <label for="import_t_products"><span></span> ' . $LANG['feed_iproductstoo'] . '</label>

    <button class="btn">' . $LANG['import_all'] . '</button>';

    echo '</div>';

    }

    foreach( $stores['List'] as $item ) {

      $imported = admin_query::store_imported( $item->ID );

      $jsdt = array();

      if( !$imported ) {

      $jsdt[$item->ID]['Name'] = $item->Name;
      $jsdt[$item->ID]['URL'] = $item->URL;
      $jsdt[$item->ID]['Tags'] = $item->Tags;
      $jsdt[$item->ID]['Description'] = $item->Description;
      $jsdt[$item->ID]['Image'] = $item->Image;
      $jsdt[$item->ID]['Phone'] = $item->Phone;
      $jsdt[$item->ID]['is_physical'] = $item->is_physical;
      $jsdt[$item->ID]['Hours'] = $item->Hours;
      $jsdt[$item->ID]['Sell_Online'] = $item->Sell_Online;
      foreach( $item->Locations as $location ) {
      $jsdt[$item->ID]['Locations'][] = (array) get_object_vars( $location );
      }

      }

      echo '<li>
      <div>

      <input type="checkbox" name="id[' . $item->ID . ']" id="id[' . $item->ID . ']" value="' . ( $cdata = urlencode( json_encode( $jsdt ) ) ) . '"' . ( $imported ? ' disabled' : '' ) . ' /> <label for="id[' . $item->ID . ']"><span></span></label>

      <img src="' . \query\main::store_avatar( $item->Image ) . '" alt="" style="width: 80px;" />

      <div class="info-div"><h2>' . ( $imported ? '<span class="msg-alert" title="' . $LANG['added_through_feed_msg'] . '">' . $LANG['added_through_feed'] . '</span> ' : '' ) . $item->Name . '</h2>
      ' . ( empty( $item->Coupons ) ? $LANG['no_coupons_store'] : '<a href="?route=feed.php&amp;action=coupons&amp;store=' . $item->ID . '">' . sprintf( $LANG['nr_coupons_store'], $item->Coupons ) . '</a>' ) . '
      <br />
      ' . ( empty( $item->Products ) ? $LANG['no_products_store'] : '<a href="?route=feed.php&amp;action=products&amp;store=' . $item->ID . '">' . sprintf( $LANG['nr_products_store'], $item->Products ) . '</a>' ) . '

      </div>

      </div>

      <div style="clear:both;"></div>

      <div class="options">';
      if( !$imported && $feed_im ) {
        echo '<a href="?route=feed.php&amp;action=preview_store&amp;store=' . $cdata . '">' . $LANG['preview_import'] . '</a>';
      }

      if( !empty( $item->Description ) ) {
        echo '<a href="javascript:void(0)" onclick="$(this).show_next( { element: \'div\' } ); return false;">' . $LANG['description'] . '</a>';
        echo '<div style="display: none; margin: 10px 0; font-size: 12px;">' . nl2br( $item->Description ) . '</div>';
      }

      echo '</div>
      </li>';

    }

    echo '</ul>

    <input type="hidden" name="csrf" value="' . $csrf . '" />

    </form>';

    if( ( $pages = ceil( $stores['Info']->Results / 10 ) ) > 1 ) {

    $page = isset( $_GET['page'] ) && (int) $_GET['page'] > 0 ? (int) $_GET['page'] : 1;
    $page = $page > $pages ? $pages : $page;

    echo '<div class="pagination">';

    if( $page > 1 )echo '<a href="' . \site\utils::update_uri( '', array( 'page' => $page - 1 ) ) . '" class="btn">' . $LANG['prev_page'] . '</a>';
    if( $page < $pages )echo '<a href="' . \site\utils::update_uri( '', array( 'page' => $page + 1 ) ) . '" class="btn">' . $LANG['next_page'] . '</a>';

    if( $pages > 1 ) {
    echo '<div class="pag_goto">' . sprintf( $LANG['pageofpages'], $page, $pages ) . '
    <form action="#" method="GET">';
    foreach( $_GET as $gk => $gv ) if( $gk !== 'page' ) echo '<input type="hidden" name="' . htmlspecialchars( $gk ) . '" value="' . htmlspecialchars( $gv ) . '" />';
    echo '<input type="number" name="page" min="1" max="' . $pages . '" size="5" value="' . $page . '" />
    <button class="btn">' . $LANG['go'] . '</button>
    </form>
    </div>';
    }

    echo '</div>';

    }

    } else echo '<div class="a-alert">' . $LANG['no_stores_yet'] . '</div>';

  }

  catch ( Exception $e ) {
    echo '<div class="a-alert">' . $e->getMessage() . '</div>';
  }

}

catch ( Exception $e ) {
  echo '<div class="a-error">' . $e->getMessage() . '</div>';
}

break;

}