<?php

namespace query;

/** */

class main {

/*

GET NUMBER OF STORES

*/

public static function stores( $categories = array() ) {
  return self::have_stores( $categories, array( 'only_count' => '' ) );
}

/*

GET NUMBER OF CATEGORIES

*/

public static function categories( $categories = array() ) {
  return self::have_categories( $categories, array( 'only_count' => '' ) );
}

/*

GET NUMBER OF COUPONS

*/

public static function coupons( $categories = array() ) {
  return self::have_items( $categories, '', array( 'only_count' => '' ) );
}

/*

GET NUMBER OF PRODUCTS

*/

public static function products( $categories = array() ) {
  return self::have_products( $categories, '', array( 'only_count' => '' ) );
}

/*

GET NUMBER OF PAGES

*/

public static function pages( $categories = array() ) {
  return self::have_pages( $categories, array( 'only_count' => '' ) );
}

/*

GET NUMBER OF USERS

*/

public static function users( $categories = array() ) {
  return self::have_users( $categories, array( 'only_count' => '' ) );
}

/*

GET NUMBER OF REVIEWS

*/

public static function reviews( $categories = array() ) {
  return self::have_reviews( $categories, '', array( 'only_count' => '' ) );
}

/*

GET NUMBER OF REWARDS

*/

public static function rewards( $categories = array() ) {
  return self::have_rewards( $categories, array( 'only_count' => '' ) );
}

/*

GET NUMBER OF CLAIM REWARD REQUESTS

*/

public static function rewards_reqs( $categories = array() ) {
  return self::have_rewards_reqs( $categories, array( 'only_count' => '' ) );
}

/*

GET NUMBER OF FAVORITE STORES

*/

public static function favorites( $categories = array() ) {
  return self::have_favorites( $categories, array( 'only_count' => '' ) );
}

/*

GET OPTIONS

*/

public static function get_option( $option = '' ) {

global $db;

  $cache = new \cache\main;

  if( $show_from_cache = $cache->check( 'options_' . $option ) ) {

    return $show_from_cache;

  } else {

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT option_value FROM " . DB_TABLE_PREFIX . "options WHERE option_name = ?");
  $stmt->bind_param( "s", $option );
  $stmt->execute();
  $stmt->bind_result( $value );
  $stmt->fetch();
  $stmt->close();

  if( $value == '' ) {
    return '';
  }

  $cache->add( 'options_' . $option, $value );

  return $value;

  }

}

/*

SHOW USER PLUGINS

*/

public static function user_plugins( $scope = '', $view = '' ) {

global $db;

  $where = array();

  /*

  WHERE / ORDER BY

  */

    if( !empty( $scope ) ) {
      $where[] = 'scope = "' . \site\utils::dbp( $scope ) . '"';
    }

    switch( $view ) {
      case 'all': break;
      case 'menu': $where[] = 'menu = 1 AND visible > 0'; break;
      default:  $where[] = 'visible > 0'; break;
    }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT id, user, name, image, scope, main, menu, menu_icon, subadmin_view, extend_vars, visible, date FROM " . DB_TABLE_PREFIX . "plugins" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $user, $name, $image, $scope, $main, $menu, $menu_icon, $subadmin_view, $vars, $visible, $date );

  $data = array();
  while( $stmt->fetch() ) {
    $data[] = (object) array( 'ID' => $id, 'user' => $user, 'name' => htmlspecialchars( $name ), 'image' => htmlspecialchars( $image ), 'scope' => htmlspecialchars( $scope ), 'main_file' => htmlspecialchars( $main ), 'menu_icon' => $menu_icon, 'subadmin_view' => (boolean) $subadmin_view, 'vars' => @unserialize( $vars ), 'in_menu' => (boolean) $menu, 'is_active' => ( $visible !== 0 ? true : false ), 'date' => $date );
  }

  $stmt->close();

  return $data;

}

/*

SHOW USER AVATAR

*/

public static function user_avatar( $text ) {

  if( filter_var( $text, FILTER_VALIDATE_URL ) ) {
    return $text;
  } else if( empty( $text ) ) {
    return $GLOBALS['siteURL'] . DEFAULT_IMAGES_LOC . '/' . \query\main::get_option( 'default_user_avatar' );
  }
  return $GLOBALS['siteURL'] . $text;

}

/*

SHOW STORE AVATAR

*/

public static function store_avatar( $text ) {

  if( filter_var( $text, FILTER_VALIDATE_URL ) ) {
    return $text;
  } else if( empty( $text ) ) {
    return $GLOBALS['siteURL'] . DEFAULT_IMAGES_LOC . '/' . \query\main::get_option( 'default_store_avatar' );
  }
  return $GLOBALS['siteURL'] . $text;

}

/*

SHOW PRODUCT AVATAR

*/

public static function product_avatar( $text ) {

  if( filter_var( $text, FILTER_VALIDATE_URL ) ) {
    return $text;
  } else if( empty( $text ) ) {
    return $GLOBALS['siteURL'] . DEFAULT_IMAGES_LOC . '/product_avatar_aa.png';
  }
  return $GLOBALS['siteURL'] . $text;

}

/*

SHOW REWARD AVATAR

*/

public static function reward_avatar( $text ) {

  if( filter_var( $text, FILTER_VALIDATE_URL ) ) {
    return $text;
  } else if( empty( $text ) ) {
    return $GLOBALS['siteURL'] . DEFAULT_IMAGES_LOC . '/' . \query\main::get_option( 'default_reward_avatar' );
  }
  return $GLOBALS['siteURL'] . $text;

}

/*

SHOW THEME AVATAR

*/

public static function theme_avatar( $text ) {

  if( empty( $text ) ) {
    return $GLOBALS['siteURL'] . DEFAULT_IMAGES_LOC . '/theme_aa.png';
  }
  return $GLOBALS['siteURL'] . $text;

}

/*

SHOW PAYMENT PLAN AVATAR

*/

public static function payment_plan_avatar( $text ) {

  if( empty( $text ) ) {
    return $GLOBALS['siteURL'] . DEFAULT_IMAGES_LOC . '/payplan_aa.png';
  }
  return $GLOBALS['siteURL'] . $text;

}

/*

CHECK IF CATEGORY EXIST

*/

public static function category_exists( $id = 0 ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "categories WHERE id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

GET INFORMATION ABOUT CATEGORY

*/

public static function category_infos( $id = 0, $special = array() ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT id, subcategory, user, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = c.user), name, description, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "stores WHERE category = c.id), url_title, meta_title, meta_keywords, meta_desc, date FROM " . DB_TABLE_PREFIX . "categories c WHERE id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $id, $subcategory, $user, $user_name, $name, $description, $stores, $url_title, $meta_title, $meta_keywords, $meta_desc, $date );
  $stmt->fetch();
  $stmt->close();

  $url_tit = !empty( $url_title ) ? $url_title : $name;
  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_categories' );
  }

  return (object)array( 'ID' => $id, 'subcatID' => $subcategory, 'user' => $user, 'user_name' => htmlspecialchars( $user_name ), 'name' => htmlspecialchars( $name ), 'description' => \site\smilies::BBcode( $description, $usebb ), 'stores' => $stores, 'meta_title' => htmlspecialchars( $meta_title ), 'meta_keywords' => htmlspecialchars( $meta_keywords ), 'meta_description' => htmlspecialchars( $meta_desc ), 'date' => $date, 'is_subcat' => ( $subcategory !== 0 ? true : false ), 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( defined( 'SEO_LINKS' ) && SEO_LINKS ? \site\utils::make_seo_link( \query\main::get_option( 'seo_link_category' ), $url_tit, $id, \query\main::get_option( 'extension' ) ) : $GLOBALS['siteURL'] . '?cat=' . $id ) );

}

/*

CHECK IF WIDGET EXIST

*/

public static function widget_exists( $id = 0 ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "widgets WHERE id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

GET INFORMATION ABOUT WIDGET

*/

public static function widget_infos( $id = 0 ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT id, user, widget_id, title, stop, type, orderby, position, text, html, mobile_view, date FROM " . DB_TABLE_PREFIX . "widgets WHERE id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $id, $user, $widget, $title, $stop, $type, $orderby, $position, $text, $html, $mobile_view, $date );
  $stmt->fetch();
  $stmt->close();

  return (object)array( 'id' => $id, 'user' => $user, 'widget_id' => $widget, 'title' => htmlspecialchars( $title ), 'limit' => $stop, 'type' => $type, 'orderby' => $orderby, 'position' => $position, 'text' => htmlspecialchars( $text ), 'html' => (boolean) $html, 'mobile_view' => (boolean) $mobile_view, 'date' => $date );

}

/*

SHOW WIDGETS

*/

public static function show_widgets( $id, $dir = '' ) {

global $db;

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT id, widget_id, location, title, stop, type, orderby, text, html, mobile_view FROM " . DB_TABLE_PREFIX . "widgets WHERE theme = ? AND sidebar = ? ORDER BY position, last_update DESC");
  $theme = \query\main::get_option( 'theme' );
  $zone = trim( $id );
  $stmt->bind_param( "ss", $theme, $zone );
  $stmt->execute();
  $stmt->bind_result( $id, $widget, $location, $title, $limit, $type, $orderby, $text, $html, $mobile_view );

  $data = array();
  while( $stmt->fetch() ) {
    if( file_exists( $dir . WIGETS_LOCATION . '/' . $location ) ) {
      $data[] = array( 'ID' => $id, 'widget_id' => $widget, 'title' => htmlspecialchars( $title ), 'limit' => $limit, 'type' => $type, 'orderby' => $orderby, 'content' => ( $html ? $text : htmlspecialchars( $text ) ), 'mobile_view' => (boolean) $mobile_view, 'file' => WIGETS_LOCATION . '/' . $location );
    }
  }

  $stmt->close();

  return $data;

}

/*

CHECK IF USER EXIST

*/

public static function user_exists( $id = 0 ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "users WHERE id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

GET INFORMATION ABOUT USER

*/

public static function user_infos( $id = 0 ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT name, email, avatar, points, credits, ipaddr, privileges, erole, subscriber, last_login, last_action, visits, valid, ban, refid, date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE user = u.id), (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "stores WHERE user = u.id), (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "coupons WHERE user = u.id), (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "products WHERE user = u.id) FROM " . DB_TABLE_PREFIX . "users u WHERE id = ?" );
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $name, $email, $avatar, $points, $credits, $ip, $privileges, $erole, $subscriber, $last_login, $last_action, $visits, $valid, $ban, $refid, $date, $reviews, $stores, $coupons, $products );
  $stmt->fetch();
  $stmt->close();

  return (object)array( 'ID' => $id, 'name' => htmlspecialchars( $name ), 'email' => htmlspecialchars( $email ), 'avatar' => htmlspecialchars( $avatar ), 'points' => $points, 'credits' => $credits, 'IP' => htmlspecialchars( $ip ), 'privileges' => $privileges, 'erole' => @unserialize( $erole ), 'is_subscribed' => (boolean) $subscriber, 'is_confirmed' => (boolean) $valid, 'is_banned' => (strtotime( $ban ) > time() ? true : false) , 'is_subadmin' => ( $privileges === 1 ? true : false ), 'is_admin' => ( $privileges > 1 ? true : false ), 'last_login' => $last_login, 'last_action' => $last_action, 'visits' => $visits, 'ban' => $ban, 'refid' => $refid, 'date' => $date, 'reviews' => $reviews, 'stores' => $stores, 'coupons' => $coupons, 'products' => $products );

}

/*

CHECK IF REVIEW EXIST

*/

public static function review_exists( $id = 0 ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

GET INFORMATION<i></i> ABOUT REVIEW

*/

public static function review_infos( $id = 0, $special = array() ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT r.id, r.user, r.store, s.name, s.link, s.url_title, r.text, r.stars, r.valid, r.lastupdate_by, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = r.lastupdate_by), r.lastupdate, r.date, u.name, u.avatar FROM " . DB_TABLE_PREFIX . "reviews r LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = r.store) LEFT JOIN " . DB_TABLE_PREFIX . "users u ON (u.id = r.user) WHERE r.id = ?" );
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $id, $user, $store, $store_name, $store_url, $url_title, $text, $stars, $valid, $lastupdate_by, $lastupdate_by_name, $last_update, $date, $user_name, $user_avatar );
  $stmt->fetch();
  $stmt->close();

  $store_url_tit = !empty( $url_title ) ? $url_title : $store_name;
  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_reviews' );
  }

  return (object) array( 'ID' => $id, 'userID' => $user, 'storeID' => $store, 'user_name' => htmlspecialchars( $user_name ), 'store_name' => htmlspecialchars( $store_name ), 'store_url' => $store_url, 'text' => \site\smilies::BBcode( $text, $usebb ), 'stars' => $stars, 'valid' => (boolean) $valid, 'date' => $date, 'lastupdate_by' => $lastupdate_by, 'lastupdate_by_name' => htmlspecialchars( $lastupdate_by_name ), 'last_update' => $last_update, 'user_avatar' => htmlspecialchars( $user_avatar ), 'store_link' => ( defined( 'SEO_LINKS' ) && SEO_LINKS ? \site\utils::make_seo_link( \query\main::get_option( 'seo_link_store' ), $store_url_tit, $store, \query\main::get_option( 'extension' ) ) : $GLOBALS['siteURL'] . '?store=' . $store ) );

}

/*

CHECK IF PAGE EXIST

*/

public static function page_exists( $id = 0, $special = array() ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $where = array();

  if( isset( $special['user_view'] ) ) {
    $where[] = 'visible > 0';
  }

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "pages WHERE id = ?" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

GET INFORMATION ABOUT PAGE

*/

public static function page_infos( $id = 0, $special = array() ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();

  if( isset( $special['update_views'] ) ) {
    $stmt->prepare("UPDATE " . DB_TABLE_PREFIX . "pages SET views = views + 1 WHERE id = ?");
    $stmt->bind_param( "i", $id );
    $stmt->execute();
  }

  $stmt->prepare("SELECT user, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = p.user), name, text, visible, views, url_title, meta_title, meta_keywords, meta_desc, lastupdate_by, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = p.lastupdate_by), lastupdate, date FROM " . DB_TABLE_PREFIX . "pages p WHERE id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $user, $user_name, $name, $text, $visible, $views, $url_title, $meta_title, $meta_keywords, $meta_desc, $lastupdate_by, $lastupdate_by_name, $last_update, $date );
  $stmt->fetch();
  $stmt->close();

  $url_tit = !empty( $url_title ) ? $url_title : $name;
  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_pages' );
  }

  return (object) array( 'ID' => $id, 'user' => $user, 'name' => htmlspecialchars( $name ), 'user_name' => htmlspecialchars( $user_name ), 'text' => \site\smilies::BBcode( $text, $usebb ), 'visible' => (boolean) $visible, 'views' => $views, 'meta_title' => htmlspecialchars( $meta_title ), 'meta_keywords' => htmlspecialchars( $meta_keywords ), 'meta_description' => htmlspecialchars( $meta_desc ), 'lastupdate_by' => $lastupdate_by, 'lastupdate_by_name' => htmlspecialchars( $lastupdate_by_name ), 'last_update' => $last_update, 'date' => $date, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( defined( 'SEO_LINKS' ) && SEO_LINKS ? \site\utils::make_seo_link( '', $url_tit, $id, \query\main::get_option( 'extension' ) ) : $GLOBALS['siteURL'] . '?p=' . $id ) );

}

/*

CHECK IF COUPON EXIST

*/

public static function item_exists( $id = 0, $special = array() ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $where = array();

  if( isset( $special['user_view'] ) ) {
    $where[] = 'visible > 0';
  }

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT id FROM " . DB_TABLE_PREFIX . "coupons WHERE id = ?" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

GET INFORMATION ABOUT A COUPON

*/

public static function item_infos( $id = 0, $special = array() ) {

global $db, $GET;

/** make or not seo links */
$seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();

  if( isset( $special['update_views'] ) ) {
    $stmt->prepare("UPDATE " . DB_TABLE_PREFIX . "coupons SET views = views + 1 WHERE id = ?");
    $stmt->bind_param( "i", $id );
    $stmt->execute();
  }

  $stmt->prepare("SELECT c.id, c.feedID, c.user, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = c.user), c.store, c.category, c.popular, c.exclusive, c.printable, c.available_online, c.title, c.link, c.description, c.tags, c.image, c.code, c.source, c.visible, c.views, c.clicks, c.start, c.expiration, c.cashback, c.url_title, c.meta_title, c.meta_keywords, c.meta_desc, c.lastupdate_by, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = c.lastupdate_by), c.lastupdate, c.votes, c.votes_percent, c.verified, c.last_verif, c.paid_until, c.date, s.physical, s.category, s.name, s.link, s.image, s.phoneno, s.sellonline, s.url_title, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0), (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) FROM " . DB_TABLE_PREFIX . "coupons c LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = c.store) WHERE c.id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $user_name, $store, $cat, $popular, $exclusive, $printable, $avab_online, $title, $link, $description, $tags, $image, $code, $source, $visible, $views, $clicks, $start, $expiration, $cashback, $url_title, $meta_title, $meta_keywords, $meta_desc, $lastupdate_by, $lastupdate_by_name, $last_update, $votes, $votes_percent, $verified, $last_verif, $paid_until, $date, $store_type, $store_cat, $store_name, $store_link, $store_img, $store_phone, $store_sellonline, $store_url_title, $reviews, $stars );
  $stmt->fetch();
  $stmt->close();

  $url_tit = !empty( $url_title ) ? $url_title : $title;
  $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;
  $extension = \query\main::get_option( 'extension' );
  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_coupons' );
  }

  return (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'storeID' => $store, 'catID' => $cat, 'user_name' => htmlspecialchars( $user_name ), 'code' => htmlspecialchars( $code ), 'title' => htmlspecialchars( $title ), 'original_url' => $link, 'url' => ( preg_match( '/^http(s)?/i', $link )  ? htmlspecialchars( $link ) : htmlspecialchars( $store_link ) ), 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'image2' => ( !empty( $image ) ? ( !filter_var( $image, FILTER_VALIDATE_URL ) ? $GLOBALS['siteURL'] . htmlspecialchars( $image ) : htmlspecialchars( $image ) ) : '' ), 'source' => ( empty( $source ) ? '' : ( filter_var( $source, FILTER_VALIDATE_URL ) ? htmlspecialchars( $source ) : $GLOBALS['siteURL'] . htmlspecialchars( $source ) ) ), 'visible' => (boolean) $visible, 'views' => $views, 'clicks' => $clicks, 'start_date' => $start, 'is_coupon' => ( !empty( $code ) ? true : false ), 'is_deal' => ( empty( $code ) ? true: false ), 'is_running' => ( strtotime( $start ) < time() && strtotime( $expiration ) > time() ? true : false ), 'expiration_date' => $expiration, 'cashback' => $cashback, 'is_printable' => ( (boolean) $store_type ? (boolean) $printable : false ), 'is_available_online' => ( ! (boolean) $store_type || (boolean) $avab_online ? true : false ), 'is_local_source' => ( empty( $source ) || filter_var( $source, FILTER_VALIDATE_URL ) ? false : true ), 'meta_title' => htmlspecialchars( $meta_title ), 'meta_keywords' => htmlspecialchars( $meta_keywords ), 'meta_description' => htmlspecialchars( $meta_desc ), 'lastupdate_by' => $lastupdate_by, 'lastupdate_by_name' => htmlspecialchars( $lastupdate_by_name ), 'last_update' => $last_update, 'is_started' => ( strtotime( $start ) > time() ? false : true ), 'is_expired' => ( strtotime( $expiration ) > time() ? false : true ), 'is_popular' => (boolean) $popular, 'is_exclusive' => (boolean) $exclusive, 'is_verified' => (boolean) $verified, 'last_check' => $last_verif, 'votes' => $votes, 'votes_percent' => $votes_percent, 'paid_until' => $paid_until, 'date' => $date, 'store_is_physical' => (boolean) $store_type, 'store_img' => htmlspecialchars( $store_img ), 'storeID' => $store, 'store_catID' => $store_cat, 'store_name' => htmlspecialchars( $store_name ), 'store_url' => htmlspecialchars( $store_link ), 'store_phone_no' => htmlspecialchars( $store_phone ), 'store_sellonline' => (boolean) $store_sellonline, 'reviews' => $reviews, 'stars' => $stars, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( \query\main::get_option( 'seo_link_coupon' ), $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?id=' . $id ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( \query\main::get_option( 'seo_link_store' ), $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store ), 'store_reviews_link' => ( $seo_link ? \site\utils::make_seo_link( \query\main::get_option( 'seo_link_reviews' ), $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $store ) );

}

/*

CHECK IF PRODUCT EXIST

*/

public static function product_exists( $id = 0, $special = array() ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $where = array();

  if( isset( $special['user_view'] ) ) {
    $where[] = 'visible > 0';
  }

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT id FROM " . DB_TABLE_PREFIX . "products WHERE id = ?" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

GET INFORMATION ABOUT A PRODUCT

*/

public static function product_infos( $id = 0, $special = array() ) {

global $db, $GET;

/** make or not seo links */
$seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();

  if( isset( $special['update_views'] ) ) {
    $stmt->prepare("UPDATE " . DB_TABLE_PREFIX . "products SET views = views + 1 WHERE id = ?");
    $stmt->bind_param( "i", $id );
    $stmt->execute();
  }

  $stmt->prepare("SELECT p.id, p.feedID, p.user, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = p.user), p.store, p.category, p.popular, p.title, p.link, p.description, p.tags, p.image, p.price, p.old_price, p.currency, p.visible, p.views, p.start, p.expiration, p.cashback, p.url_title, p.meta_title, p.meta_keywords, p.meta_desc, p.lastupdate_by, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = p.lastupdate_by), p.lastupdate, p.paid_until, p.date, s.physical, s.image, s.id, s.name, s.link, s.category, s.sellonline, s.url_title, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0), (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) FROM " . DB_TABLE_PREFIX . "products p LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = p.store) WHERE p.id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $user_name, $store, $cat, $popular, $title, $link, $description, $tags, $image, $price, $old_price, $currency, $visible, $views, $start, $expiration, $cashback, $url_title, $meta_title, $meta_keywords, $meta_desc, $lastupdate_by, $lastupdate_by_name, $last_update, $paid_until, $date, $store_type, $store_img, $store_id, $store_name, $store_link, $store_cat, $store_sellonline, $store_url_title, $reviews, $stars );
  $stmt->fetch();
  $stmt->close();

  $url_tit = !empty( $url_title ) ? $url_title : $title;
  $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;
  $extension = \query\main::get_option( 'extension' );
  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_products' );
  }

  return (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'storeID' => $store, 'catID' => $cat, 'user_name' => htmlspecialchars( $user_name ), 'title' => htmlspecialchars( $title ), 'original_url' => $link, 'url' => ( preg_match( '/^http(s)?/i', $link ) ? htmlspecialchars( $link ) : htmlspecialchars( $store_link ) ), 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'price' => $price, 'old_price' => $old_price, 'currency' => htmlspecialchars( $currency ), 'visible' => (boolean) $visible, 'views' => $views, 'start_date' => $start, 'is_running' => ( strtotime( $start ) < time() && strtotime( $expiration ) > time() ? true : false ), 'expiration_date' => $expiration, 'cashback' => $cashback, 'is_available_online' => ( ! (boolean) $store_type || $store_sellonline ? true : false ), 'meta_title' => htmlspecialchars( $meta_title ), 'meta_description' => htmlspecialchars( $meta_desc ), 'meta_keywords' => htmlspecialchars( $meta_keywords ), 'lastupdate_by' => $lastupdate_by, 'lastupdate_by_name' => htmlspecialchars( $lastupdate_by_name ), 'last_update' => $last_update, 'is_started' => ( strtotime( $start ) > time() ? false : true ), 'is_expired' => ( strtotime( $expiration ) > time() ? false : true ), 'is_popular' => (boolean) $popular, 'paid_until' => $paid_until, 'date' => $date, 'store_is_physical' => (boolean) $store_type, 'store_img' => htmlspecialchars( $store_img ), 'storeID' => $store_id, 'store_catID' => $store_cat, 'store_name' => htmlspecialchars( $store_name ), 'store_url' => htmlspecialchars( $store_link ), 'reviews' => $reviews, 'stars' => $stars, 'store_sellonline' => (boolean) $store_sellonline, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( \query\main::get_option( 'seo_link_product' ), $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?product=' . $id ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( \query\main::get_option( 'seo_link_store' ), $store_url_tit, $store_id, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store_id ), 'store_reviews_link' => ( $seo_link ? \site\utils::make_seo_link( \query\main::get_option( 'seo_link_reviews' ), $store_url_tit, $store_id, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $store_id ) );

}

/*

CHECK IF STORE EXIST

*/

public static function store_exists( $id = 0, $special = array() ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $where = array();

  if( isset( $special['user_view'] ) ) {
    $where[] = 'visible > 0';
  }

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "stores WHERE id = ?" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

GET INFORMATION ABOUT A STORE

*/

public static function store_infos( $id = 0, $special = array() ) {

global $db, $GET;

/** make or not seo links */
$seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();

  if( isset( $special['update_views'] ) ) {
    $stmt->prepare("UPDATE " . DB_TABLE_PREFIX . "stores SET views = views + 1 WHERE id = ?");
    $stmt->bind_param( "i", $id );
    $stmt->execute();
  }

  $stmt->prepare("SELECT s.id, s.feedID, s.user, s.category, s.popular, s.physical, s.name, s.link, s.description, s.tags, s.image, s.hours, s.phoneno, s.sellonline, s.visible, s.views, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "coupons WHERE store = s.id AND visible > 0), s.url_title, s.meta_title, s.meta_keywords, s.meta_desc, s.lastupdate_by, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = s.lastupdate_by), s.lastupdate, s.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0), (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0), (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "products WHERE store = s.id AND visible > 0), u.name FROM " . DB_TABLE_PREFIX . "stores s LEFT JOIN " . DB_TABLE_PREFIX . "users u ON (u.id = s.user) WHERE s.id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $cat, $popular, $physical, $name, $link, $description, $tags, $image, $hours, $phone, $sellonline, $visible, $views, $coupons, $url_title, $meta_title, $meta_keywords, $meta_desc, $lastupdate_by, $lastupdate_by_name, $last_update, $date, $reviews, $stars, $products, $user_name);
  $stmt->fetch();
  $stmt->close();

  $url_tit = !empty( $url_title ) ? $url_title : $name;
  $extension = \query\main::get_option( 'extension' );
  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_stores' );
  }

  return (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'user_name' => htmlspecialchars( $user_name ), 'catID' => $cat, 'name' => htmlspecialchars( $name ), 'url' => htmlspecialchars( $link ), 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'hours' => @unserialize( $hours ),  'phone_no' => htmlspecialchars( $phone ), 'sellonline' => (boolean) ( !$physical ? 1 : $sellonline ), 'sellonline2' => (boolean) $sellonline, 'visible' => (boolean) $visible, 'views' => $views, 'coupons' => $coupons, 'date' => $date, 'reviews' => $reviews, 'stars' => $stars, 'products' => $products, 'meta_title' => htmlspecialchars( $meta_title ), 'meta_keywords' => htmlspecialchars( $meta_keywords ), 'meta_description' => htmlspecialchars( $meta_desc ), 'lastupdate_by' => $lastupdate_by, 'lastupdate_by_name' => htmlspecialchars( $lastupdate_by_name ), 'last_update' => $last_update, 'is_popular' => (boolean) $popular, 'is_physical' => (boolean) $physical, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( \query\main::get_option( 'seo_link_store' ), $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?store=' . $id ), 'reviews_link' => ( $seo_link ? \site\utils::make_seo_link( \query\main::get_option( 'seo_link_reviews' ), $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $id ) );

}

/*

CHECK IF A REWARD EXIST

*/

public static function reward_exists( $id = 0 ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $where = array();

  if( isset( $special['user_view'] ) ) {
    $where[] = 'visible > 0';
  }

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "rewards WHERE id = ?" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

GET INFORMATION ABOUT A REWARD

*/

public static function reward_infos( $id = 0 ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT id, user, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = r.user), points, title, description, image, fields, lastupdate_by, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = r.lastupdate_by), lastupdate, visible, date FROM " . DB_TABLE_PREFIX . "rewards r WHERE id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $id, $user, $user_name, $points, $title, $description, $image, $fields, $lastupdate_by, $lastupdate_by_name, $last_update, $visible, $date );
  $stmt->fetch();
  $stmt->close();

  return (object) array( 'ID' => $id, 'user' => $user, 'user_name' => htmlspecialchars( $user_name ), 'points' => $points, 'title' => htmlspecialchars( $title ), 'description' => htmlspecialchars( $description ), 'image' => htmlspecialchars( $image ), 'fields' => @unserialize( $fields ), 'lastupdate_by' => $lastupdate_by, 'lastupdate_by_name' => htmlspecialchars( $lastupdate_by_name ), 'last_update' => $last_update, 'visible' => (boolean) $visible, 'date' => $date );

}

/*

CHECK IF A REWARD REQUEST EXIST

*/

public static function reward_req_exists( $id = 0 ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "rewards_reqs WHERE id = ?");
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

GET INFORMATION ABOUT A REWARD REQUEST

*/

public static function reward_req_infos( $id = 0 ) {

global $db, $GET;

$id = empty( $id ) ? $GET['id'] : $id;

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT id, name, user, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = r.user), points, reward,  (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "rewards WHERE id = r.reward), fields, lastupdate_by, (SELECT name FROM " . DB_TABLE_PREFIX . "users WHERE id = r.lastupdate_by), lastupdate, claimed, date FROM " . DB_TABLE_PREFIX . "rewards_reqs r WHERE id = ?" );
  $stmt->bind_param( "i", $id );
  $stmt->execute();
  $stmt->bind_result( $id, $name, $user, $user_name, $points, $reward, $reward_exists, $fields, $lastupdate_by, $lastupdate_by_name, $last_update, $claimed, $date );
  $stmt->fetch();
  $stmt->close();

  return (object) array( 'ID' => $id, 'name' => htmlspecialchars( $name ), 'user' => $user, 'user_name' => htmlspecialchars( $user_name ), 'points' => $points, 'reward' => $reward, 'reward_exists' => ( $reward_exists > 0 ? true : false ), 'fields' => @unserialize( $fields ), 'lastupdate_by' => $lastupdate_by, 'lastupdate_by_name' => htmlspecialchars( $lastupdate_by_name ), 'last_update' => $last_update, 'claimed' => (boolean) $claimed, 'date' => $date );

}

/*

CHECK IF AN USE HAVE A STORE

*/

public static function have_store( $id, $user ) {

global $db;

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "stores WHERE id = ? AND user = ?");
  $stmt->bind_param( "ii", $id, $user );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( $count > 0 ) {
    return true;
  }

  return false;

}

/*

NUMBER OF CATEGORIES

*/

public static function have_categories( $category = array(), $special = array() ) {

global $db;

  $categories = \site\utils::validate_user_data( $category );

  $where = array();

  /*

  WHERE / ORDER BY

  */

  if( isset( $categories['show'] ) ) {
  $show = array_map( 'trim', explode( ',', strtolower( $categories['show'] ) ) );
  foreach( $show as $v ) {
    switch( $v ) {
      case 'cats': $where[] = 'subcategory = 0'; break;
      case 'subcats':  $where[] = 'subcategory > 0'; break;
    }
  }
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "categories" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( isset( $special['only_count'] ) ) {
    return $count;
  }


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

}

/*

FETCH THE CATEGORIES

*/

public static function while_categories( $category = array(), $special = array() ) {

global $db;

  /** make or not seo links */
  $seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;
  list( $seo_link_category, $extension ) = array( \query\main::get_option( 'seo_link_category' ), \query\main::get_option( 'extension' ) );

  $categories = \site\utils::validate_user_data( $category );

  $where = $orderby = $limit = array();

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0;

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  if( isset( $categories['orderby'] ) ) {
  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );
  foreach( $order as $v ) {
    switch( $v ) {
      case 'rand': $orderby[] = 'RAND()'; break;
      case 'name': $orderby[] = 'c.name'; break;
      case 'name desc': $orderby[] = 'c.name DESC'; break;
      case 'date': $orderby[] = 'c.date'; break;
      case 'date desc': $orderby[] = 'c.date DESC'; break;
    }
  }
  }

  if( isset( $categories['show'] ) ) {
  $show = array_map( 'trim', explode( ',', strtolower( $categories['show'] ) ) );
  foreach( $show as $v ) {
    switch( $v ) {
      case 'cats': $where[] = 'c.subcategory = 0'; break;
      case 'subcats':  $where[] = 'c.subcategory > 0'; break;
    }
  }
  }

  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_categories' );
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT c.id, c.subcategory, c.user, c.name, c.description, c.url_title, c.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "stores WHERE category = c.id) FROM " . DB_TABLE_PREFIX . "categories c" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $subcategory, $user, $name, $description, $url_title, $date, $stores );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $name;

    $data[] = (object) array( 'ID' => $id, 'subcatID' => $subcategory, 'user' => $user, 'name' => htmlspecialchars( $name ), 'description' => \site\smilies::BBcode( $description, $usebb ), 'date' => $date, 'stores' => $stores, 'is_subcat' => ( $subcategory !== 0 ? true : false ), 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_category, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?cat=' . $id ) );

  }

  $stmt->close();

  return $data;

}

/*

GET THE CATEGORIES

*/

public static function group_categories( $category = array() ) {

  $array = array();

  foreach( \query\main::while_categories( $category ) as $c ) {
    if( $c->is_subcat ) {
    $array['cat_' . $c->subcatID]['subcats'][] = $c;
    } else {
    $array['cat_' . $c->ID]['infos'] = $c;
    }
  }

  return $array;

}

/*

NUMBER OF USERS

*/

public static function have_users( $category = array(), $special = array() ) {

global $db;

  $categories = \site\utils::validate_user_data( $category );

  $where = array();

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(name, email, ipaddr) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['ip'] ) ) {
    $where[] = 'ipaddr = "' . \site\utils::dbp( $categories['ip'] ) . '"';
  }

  if( !empty( $categories['referrer'] ) ) {
    $where[] = 'refid = "' . (int) $categories['referrer'] . '"';
  }

  if( isset( $categories['show'] ) ) {
  $show = array_map( 'trim', explode( ',', strtolower( $categories['show'] ) ) );
  foreach( $show as $v ) {
    switch( $v ) {
      case 'members': $where[] = 'privileges = 0'; break;
      case 'subadmins':  $where[] = 'privileges = 1'; break;
      case 'admins':  $where[] = 'privileges >= 2'; break;
      case 'verified': $where[] = 'valid >= 1'; break;
      case 'notverified': $where[] = 'valid = 0'; break;
      case 'banned': $where[] = 'ban >= NOW()';
      case 'referred': $where[] = 'refid > 0'; break;
    }
  }
  }

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "users" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( isset( $special['only_count'] ) ) {
    return $count;
  }


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

}

/*

FETCH THE USERS

*/

public static function while_users( $category = array() ) {

global $db;

  $categories = \site\utils::validate_user_data( $category );

  $where = $orderby = $limit = array();

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0;

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(name, email, ipaddr) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['ip'] ) ) {
    $where[] = 'ipaddr = "' . \site\utils::dbp( $categories['ip'] ) . '"';
  }

  if( !empty( $categories['referrer'] ) ) {
    $where[] = 'refid = "' . (int) $categories['referrer'] . '"';
  }

  if( isset( $categories['show'] ) ) {
  $show = array_map( 'trim', explode( ',', strtolower( $categories['show'] ) ) );
  foreach( $show as $v ) {
    switch( $v ) {
      case 'members': $where[] = 'privileges = 0'; break;
      case 'subadmins':  $where[] = 'privileges = 1'; break;
      case 'admins':  $where[] = 'privileges >= 2'; break;
      case 'verified': $where[] = 'valid >= 1'; break;
      case 'notverified': $where[] = 'valid = 0'; break;
      case 'banned': $where[] = 'ban >= NOW()';
      case 'referred': $where[] = 'refid > 0'; break;
    }
  }
  }

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( isset( $categories['orderby'] ) ) {
  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );
  foreach( $order as $v ) {
    switch( $v ) {
      case 'rand': $orderby[] = 'RAND()'; break;
      case 'name': $orderby[] = 'name'; break;
      case 'name desc': $orderby[] = 'name DESC'; break;
      case 'date': $orderby[] = 'date'; break;
      case 'date desc': $orderby[] = 'date DESC'; break;
      case 'action': $orderby[] = 'last_action'; break;
      case 'action desc': $orderby[] = 'last_action DESC'; break;
      case 'points': $orderby[] = 'points'; break;
      case 'points desc': $orderby[] = 'points DESC'; break;
      case 'credits': $orderby[] = 'credits'; break;
      case 'credits desc': $orderby[] = 'credits DESC'; break;
      case 'visits': $orderby[] = 'visits'; break;
      case 'visits desc': $orderby[] = 'visits DESC'; break;
    }
  }
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT id, name, email, avatar, points, credits, ipaddr, privileges, subscriber, last_login, last_action, visits, valid, ban, refid, date FROM " . DB_TABLE_PREFIX . "users" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $name, $email, $avatar, $points, $credits, $ip, $privileges, $subscriber, $last_login, $last_action, $visits, $valid, $ban, $refid, $date );

  $data = array();
  while( $stmt->fetch() ) {
    $data[] = (object)array( 'ID' => $id, 'name' => htmlspecialchars( $name ), 'email' => htmlspecialchars( $email ), 'avatar' => htmlspecialchars( $avatar ), 'points' => $points, 'credits' => $credits, 'IP' => htmlspecialchars( $ip ), 'privileges' => $privileges, 'is_subscribed' => (boolean) $subscriber, 'is_confirmed' => (boolean) $valid, 'is_banned' => (strtotime( $ban ) > time() ? true : false) , 'is_subadmin' => ( $privileges === 1 ? true : false ), 'is_admin' => ( $privileges > 1 ? true : false ), 'last_login' => $last_login, 'last_action' => $last_action, 'visits' => $visits, 'ban' => $ban, 'refid' => $refid, 'date' => $date );
  }

  $stmt->close();

  return $data;

}

/*

NUMBER OF PAGES

*/

public static function have_pages( $category = array(), $special = array() ) {

global $db;

  $categories = \site\utils::validate_user_data( $category );

  $where = array();

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(name, text) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( isset( $categories['show'] ) ) {
    $show = strtolower( $categories['show'] );
    switch( $show ) {
      case 'all': break;
      default: $where[] = 'visible > 0'; break;
    }
  } else {
    $where[] = 'visible > 0';
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "pages" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( isset( $special['only_count'] ) ) {
    return $count;
  }


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

}

/*

FETCH THE PAGES

*/

public static function while_pages( $category = array() ) {

global $db;

  /** make or not seo links */
  $seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;
  $seo_link_page = \query\main::get_option( 'seo_link_page' );

  $categories = \site\utils::validate_user_data( $category );

  $where = $orderby = $limit = array();

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0;

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(name, text) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( isset( $categories['show'] ) ) {
    $show = strtolower( $categories['show'] );
    switch( $show ) {
      case 'all': break;
      default: $where[] = 'visible > 0'; break;
    }
  } else {
    $where[] = 'visible > 0';
  }

  if( isset( $categories['orderby'] ) ) {
  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );
  foreach( $order as $v ) {
    switch( $v ) {
      case 'rand': $orderby[] = 'RAND()'; break;
      case 'name': $orderby[] = 'name'; break;
      case 'name desc': $orderby[] = 'name DESC'; break;
      case 'update': $orderby[] = 'lastupdate'; break;
      case 'update desc': $orderby[] = 'lastupdate DESC'; break;
      case 'date': $orderby[] = 'date'; break;
      case 'date desc': $orderby[] = 'date DESC'; break;
      case 'views': $orderby[] = 'views'; break;
      case 'views desc': $orderby[] = 'views DESC'; break;
    }
  }
  }

  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_pages' );
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT id, user, name, text, visible, url_title, date FROM " . DB_TABLE_PREFIX . "pages" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $user, $name, $text, $visible, $url_title, $date );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $name;

    $data[] = (object)array( 'ID' => $id, 'user' => $user, 'name' => htmlspecialchars( $name ), 'text' => \site\smilies::BBcode( $text, $usebb ), 'visible' => (boolean) $visible, 'date' => $date, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_page, $url_tit, $id ) : $GLOBALS['siteURL'] . '?p=' . $id ) );

  }

  $stmt->close();

  return $data;

}

/*

NUMBER OF ITEMS - COUPONS

*/

public static function have_items( $category = array(), $place = '', $special = array() ) {

global $db, $GET;

  $categories = \site\utils::validate_user_data( $category );

  $where = array();

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['categories'] ) && strcasecmp( $categories['categories'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['categories'] ) ));
    if( !empty( $arr ) )
    $where[] = 'c.category IN(' . \site\utils::dbp ( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['update'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['update'] ) );
    $where[] = 'c.lastupdate >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'c.lastupdate <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'c.date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'c.date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  /*

  */

  switch( $place ) {

  case 'category':

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT id FROM " . DB_TABLE_PREFIX . "categories WHERE subcategory = ?" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->bind_param( "i", $GET['id'] );
  $stmt->execute();
  $stmt->bind_result( $id );

  $ids[] = (int) $GET['id'];
  while( $stmt->fetch() ) {
    $ids[] = $id;
  }

  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "coupons c LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (c.store = s.id) WHERE c.category IN(" . implode( ',', $ids ) . ") AND c.visible > 0 AND s.visible > 0" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();

  break;

  case 'search':

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "coupons c LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = c.store) WHERE CONCAT(c.title, c.tags, s.name, s.tags) REGEXP ? AND c.visible > 0 AND s.visible > 0" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );

  if( gettype( $GET['id'] ) === 'string' ) {
  $search = implode( '.*', explode( ' ', trim( $GET['id'] ) ) );
  } else {
  $search = '';
  }

  $stmt->bind_param( "s", $search  );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();

  break;

  default:

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['ids'] ) && strcasecmp( $categories['ids'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['ids'] ) ));
    if( !empty( $arr ) )
    $where[] = 'c.id IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['store'] ) && strcasecmp( $categories['store'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['store'] ) ));
    if( !empty( $arr ) )
    $where[] = 'c.store IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['user'] ) ) {
    $where[] = 'c.user = "' . (int) $categories['user'] . '"';
  }

  if( !empty( $categories['store_owner'] ) ) {
    $where[] = 's.user = "' . (int) $categories['store_owner'] . '"';
  }

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(c.title, c.tags) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
  $show = array_map( 'trim', explode( ',', strtolower( $categories['show'] ) ) );
  foreach( $show as $v ) {
    switch( $v ) {
      case 'all': break;
      case 'expired': $where[] = 'c.expiration <= NOW()'; break;
      case 'active':  $where[] = 'c.expiration > NOW()'; break;
      case 'popular':  $where[] = 'c.popular > 0'; break;
      case 'exclusive':  $where[] = 'c.exclusive > 0'; break;
      case 'feed':  $where[] = 'c.feedID > 0'; break;
      case 'visible':  $where[] = 'c.visible > 0 AND s.visible > 0'; break;
      case 'notvisible': $where[] = 'c.visible = 0'; break;
      default: $where[] = 'c.visible > 0 AND s.visible > 0'; break;
    }
  }
  } else {
    $where[] = 'c.visible > 0 AND s.visible > 0';
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "coupons c LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = c.store)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();

  break;

  }

  $stmt->close();

  if( isset( $special['only_count'] ) ) {
    return $count;
  }


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

}

/*

FETCH THE ITEMS - COUPONS

*/

public static function while_items( $category = array(), $place = '', $special = array() ) {

global $db, $GET;

  /** make or not seo links */
  $seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;
  list( $seo_link_coupon, $seo_link_store, $seo_link_reviews, $extension ) = array( \query\main::get_option( 'seo_link_coupon' ), \query\main::get_option( 'seo_link_store' ), \query\main::get_option( 'seo_link_reviews' ), \query\main::get_option( 'extension' ) );

  $categories = \site\utils::validate_user_data( $category );

  $where = $orderby = $limit = array();

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = ( isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0 );

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['categories'] ) && strcasecmp( $categories['categories'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['categories'] ) ));
    if( !empty( $arr ) )
    $where[] = 'c.category IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['update'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['update'] ) );
    $where[] = 'c.lastupdate >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'c.lastupdate <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'c.date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'c.date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( isset( $categories['orderby'] ) ) {
  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );
  foreach( $order as $v ) {
    switch( $v ) {
      case 'rand': $orderby[] = 'RAND()'; break;
      case 'name': $orderby[] = 'c.title'; break;
      case 'name desc': $orderby[] = 'c.title DESC'; break;
      case 'update': $orderby[] = 'c.lastupdate'; break;
      case 'update desc': $orderby[] = 'c.lastupdate DESC'; break;
      case 'rating': $orderby[] = 'rating'; break;
      case 'rating desc': $orderby[] = 'rating DESC'; break;
      case 'votes': $orderby[] = 'votes'; break;
      case 'votes desc': $orderby[] = 'votes DESC'; break;
      case 'cvotes': $orderby[] = 'c.votes'; break;
      case 'cvotes desc': $orderby[] = 'c.votes DESC'; break;
      case 'views': $orderby[] = 'c.views'; break;
      case 'views desc': $orderby[] = 'c.views DESC'; break;
      case 'clicks': $orderby[] = 'c.clicks'; break;
      case 'clicks desc': $orderby[] = 'c.clicks DESC'; break;
      case 'date': $orderby[] = 'c.date'; break;
      case 'date desc': $orderby[] = 'c.date DESC'; break;
      case 'active': $orderby[] = 'c.expiration'; break;
      case 'active desc': $orderby[] = 'c.expiration DESC'; break;
    }
  }
  }

  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_coupons' );
  }

  /*

  */

  switch( $place ) {

  case 'category':

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT id FROM " . DB_TABLE_PREFIX . "categories WHERE subcategory = ?" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->bind_param( "i", $GET['id'] );
  $stmt->execute();
  $stmt->bind_result( $id );

  $ids[] = (int) $GET['id'];
  while( $stmt->fetch() ) {
    $ids[] = $id;
  }

  $stmt->prepare( "SELECT c.id, c.feedID, c.user, c.store, c.category, c.popular, c.exclusive, c.printable, c.available_online, c.title, c.link, c.description, c.tags, c.image, c.code, c.source, c.visible, c.views, c.clicks, c.start, c.expiration, c.cashback, c.url_title, c.votes, c.votes_percent, c.verified, c.last_verif, c.paid_until, c.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as votes, (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as rating, s.physical, s.category, s.name, s.link, s.image, s.phoneno, s.sellonline, s.url_title FROM " . DB_TABLE_PREFIX . "coupons c LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = c.store) WHERE c.category IN(" . implode( ',', $ids ) . ") AND c.visible > 0 AND s.visible > 0" . ( empty( $where ) ? '' : implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $store, $cat, $popular, $exclusive, $printable, $avab_online, $title, $link, $description, $tags, $image, $code, $source, $visible, $views, $clicks, $start, $expiration, $cashback, $url_title, $votes, $votes_percent, $verified, $last_verif, $paid_until, $date, $reviews, $stars, $store_type, $store_cat, $store_name, $store_link, $store_img, $store_phone, $store_sellonline, $store_url_title );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $title;
    $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;

    $data[] = (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'storeID' => $store, 'catID' => $cat, 'code' => htmlspecialchars( $code ), 'title' => htmlspecialchars( $title ), 'url' => ( preg_match( '/^http(s)?/i', $link ) ? htmlspecialchars( $link ) : htmlspecialchars( $store_link ) ), 'original_url' => $link, 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'image2' => ( !empty( $image ) ? ( !filter_var( $image, FILTER_VALIDATE_URL ) ? $GLOBALS['siteURL'] . htmlspecialchars( $image ) : htmlspecialchars( $image ) ) : '' ), 'source' => ( empty( $source ) ? '' : ( filter_var( $source, FILTER_VALIDATE_URL ) ? htmlspecialchars( $source ) : $GLOBALS['siteURL'] . htmlspecialchars( $source ) ) ), 'visible' => (boolean) $visible, 'views' => $views, 'clicks' => $clicks, 'start_date' => $start, 'is_coupon' => ( !empty( $code ) ? true : false ), 'is_deal' => ( empty( $code ) ? true : false ), 'is_running' => ( strtotime( $start ) < time() && strtotime( $expiration ) > time() ? true : false ), 'expiration_date' => $expiration, 'cashback' => $cashback, 'is_printable' => ( (boolean) $store_type ? (boolean) $printable : false ), 'is_available_online' => ( ! (boolean) $store_type || (boolean) $avab_online ? true : false ), 'is_local_source' => ( empty( $source ) || filter_var( $source, FILTER_VALIDATE_URL ) ? false : true ), 'is_started' => ( strtotime( $start ) > time() ? false : true ), 'is_expired' => ( strtotime( $expiration ) > time() ? false : true ), 'is_popular' => (boolean) $popular, 'is_exclusive' => (boolean) $exclusive, 'is_verified' => (boolean) $verified, 'last_check' => $last_verif, 'votes' => $votes, 'votes_percent' => $votes_percent, 'paid_until' => $paid_until, 'date' => $date, 'reviews' => $reviews, 'stars' => $stars, 'store_is_physical' => (boolean) $store_type, 'store_img' => htmlspecialchars( $store_img ), 'store_catID' => $store_cat, 'store_name' => htmlspecialchars( $store_name ), 'store_url' => htmlspecialchars( $store_link ), 'store_phone_no' => htmlspecialchars( $store_phone ), 'store_sellonline' => (boolean) $store_sellonline, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_coupon, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?id=' . $id ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store ), 'store_reviews_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_reviews, $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $store ) );
  }

  $stmt->close();

  return $data;

  break;

  case 'search':

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT c.id, c.feedID, c.user, c.store, c.category, c.popular, c.exclusive, c.printable, c.available_online, c.title, c.link, c.description, c.tags, c.image, c.code, c.source, c.visible, c.views, c.clicks, c.start, c.expiration, c.cashback, c.url_title, c.votes, c.votes_percent, c.verified, c.last_verif, c.paid_until, c.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as votes, (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as rating, s.physical, s.category, s.name, s.link, s.image, s.phoneno, s.sellonline, s.url_title FROM " . DB_TABLE_PREFIX . "coupons c LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = c.store) WHERE CONCAT(c.title, c.tags, s.name, s.tags) REGEXP ? AND c.visible > 0 AND s.visible > 0" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );

  if( gettype( $GET['id'] ) === 'string' ) {
  $search = implode( '.*', explode( ' ', trim( $GET['id'] ) ) );
  $search = substr( $search, 0, 50 );
  } else {
  $search = '';
  }

  $stmt->bind_param( "s", $search );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $store, $cat, $popular, $exclusive, $printable, $avab_online, $title, $link, $description, $tags, $image, $code, $source, $visible, $views, $clicks, $start, $expiration, $cashback, $url_title, $votes, $votes_percent, $verified, $last_verif, $paid_until, $date, $reviews, $stars, $store_type, $store_cat, $store_name, $store_link, $store_img, $store_phone, $store_sellonline, $store_url_title );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $title;
    $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;

    $data[] = (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'storeID' => $store, 'catID' => $cat, 'code' => htmlspecialchars( $code ), 'title' => htmlspecialchars( $title ), 'url' => ( preg_match( '/^http(s)?/i', $link ) ? htmlspecialchars( $link ) : htmlspecialchars( $store_link ) ), 'original_url' => $link, 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'image2' => ( !empty( $image ) ? ( !filter_var( $image, FILTER_VALIDATE_URL ) ? $GLOBALS['siteURL'] . htmlspecialchars( $image ) : htmlspecialchars( $image ) ) : '' ), 'source' => ( empty( $source ) ? '' : ( filter_var( $source, FILTER_VALIDATE_URL ) ? htmlspecialchars( $source ) : $GLOBALS['siteURL'] . htmlspecialchars( $source ) ) ), 'visible' => (boolean) $visible, 'views' => $views, 'clicks' => $clicks, 'start_date' => $start, 'is_coupon' => ( !empty( $code ) ? true : false ), 'is_deal' => ( empty( $code ) ? true : false ), 'is_running' => ( strtotime( $start ) < time() && strtotime( $expiration ) > time() ? true : false ), 'expiration_date' => $expiration, 'cashback' => $cashback, 'is_printable' => ( (boolean) $store_type ? (boolean) $printable : false ), 'is_available_online' => ( ! (boolean) $store_type || (boolean) $avab_online ? true : false ), 'is_local_source' => ( empty( $source ) || filter_var( $source, FILTER_VALIDATE_URL ) ? false : true ), 'is_started' => ( strtotime( $start ) > time() ? false : true ), 'is_expired' => ( strtotime( $expiration ) > time() ? false : true ), 'is_popular' => (boolean) $popular, 'is_exclusive' => (boolean) $exclusive, 'is_verified' => (boolean) $verified, 'last_check' => $last_verif, 'votes' => $votes, 'votes_percent' => $votes_percent, 'paid_until' => $paid_until, 'date' => $date, 'reviews' => $reviews, 'stars' => $stars, 'store_is_physical' => (boolean) $store_type, 'store_img' => htmlspecialchars( $store_img ), 'store_catID' => $store_cat, 'store_name' => htmlspecialchars( $store_name ), 'store_url' => htmlspecialchars( $store_link ), 'store_phone_no' => htmlspecialchars( $store_phone ), 'store_sellonline' => (boolean) $store_sellonline, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_coupon, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?id=' . $id ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store ), 'store_reviews_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_reviews, $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $store ) );
  }

  $stmt->close();

  return $data;

  break;

  default:

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['ids'] ) && strcasecmp( $categories['ids'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['ids'] ) ));
    if( !empty( $arr ) )
    $where[] = 'c.id IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
    if( !isset( $categories['orderby'] ) ) {
      $orderby[] = 'field(c.id,' . \site\utils::dbp( implode(',', $arr) ) . ')';
    }
  }

  if( !empty( $categories['store'] ) && strcasecmp( $categories['store'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['store'] ) ));
    if( !empty( $arr ) )
    $where[] = 'c.store IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['user'] ) ) {
    $where[] = 'c.user = "' . (int) $categories['user'] . '"';
  }

  if( !empty( $categories['store_owner'] ) ) {
    $where[] = 's.user = "' . (int) $categories['store_owner'] . '"';
  }

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(c.title, c.tags) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
  $show = array_map( 'trim', explode( ',', strtolower( $categories['show'] ) ) );
  foreach( $show as $v ) {
    switch( $v ) {
      case 'all': break;
      case 'expired': $where[] = 'c.expiration <= NOW()'; break;
      case 'active':  $where[] = 'c.expiration > NOW()'; break;
      case 'popular':  $where[] = 'c.popular > 0'; break;
      case 'exclusive':  $where[] = 'c.exclusive > 0'; break;
      case 'cashback': $where[] = 'c.cashback > 0'; break;
      case 'verified': $where[] = 'c.verified > 0'; break;
      case 'feed':  $where[] = 'c.feedID > 0'; break;
      case 'visible':  $where[] = 'c.visible > 0 AND s.visible > 0'; break;
      case 'notvisible': $where[] = 'c.visible = 0'; break;
      default: $where[] = 'c.visible > 0 AND s.visible > 0'; break;
    }
  }
  } else {
    $where[] = 'c.visible > 0 AND s.visible > 0';
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT c.id, c.feedID, c.user, c.store, c.category, c.popular, c.exclusive, c.printable, c.available_online, c.title, c.link, c.description, c.tags, c.image, c.code, c.source, c.visible, c.views, c.clicks, c.start, c.expiration, c.cashback, c.url_title, c.votes, c.votes_percent, c.verified, c.last_verif, c.paid_until, c.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as votes, (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as rating, s.physical, s.category, s.name, s.link, s.image, s.phoneno, s.sellonline, s.url_title FROM " . DB_TABLE_PREFIX . "coupons c LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = c.store)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $store, $cat, $popular, $exclusive, $printable, $avab_online, $title, $link, $description, $tags, $image, $code, $source, $visible, $views, $clicks, $start, $expiration, $cashback, $url_title, $votes, $votes_percent, $verified, $last_verif, $paid_until, $date, $reviews, $stars, $store_type, $store_cat, $store_name, $store_link, $store_img, $store_phone, $store_sellonline, $store_url_title );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $title;
    $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;

    $data[] = (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'storeID' => $store, 'catID' => $cat, 'code' => htmlspecialchars( $code ), 'title' => htmlspecialchars( $title ), 'url' => ( preg_match( '/^http(s)?/i', $link ) ? htmlspecialchars( $link ) : htmlspecialchars( $store_link ) ), 'original_url' => $link, 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'image2' => ( !empty( $image ) ? ( !filter_var( $image, FILTER_VALIDATE_URL ) ? $GLOBALS['siteURL'] . htmlspecialchars( $image ) : htmlspecialchars( $image ) ) : '' ), 'source' => ( empty( $source ) ? '' : ( filter_var( $source, FILTER_VALIDATE_URL ) ? htmlspecialchars( $source ) : $GLOBALS['siteURL'] . htmlspecialchars( $source ) ) ), 'visible' => (boolean) $visible, 'views' => $views, 'clicks' => $clicks, 'start_date' => $start, 'is_coupon' => ( !empty( $code ) ? true : false ), 'is_deal' => ( empty( $code ) ? true : false ), 'is_running' => ( strtotime( $start ) < time() && strtotime( $expiration ) > time() ? true : false ), 'expiration_date' => $expiration, 'cashback' => $cashback, 'is_printable' => ( (boolean) $store_type ? (boolean) $printable : false ), 'is_available_online' => ( ! (boolean) $store_type || (boolean) $avab_online ? true : false ), 'is_local_source' => ( empty( $source ) || filter_var( $source, FILTER_VALIDATE_URL ) ? false : true ), 'is_started' => ( strtotime( $start ) > time() ? false : true ), 'is_expired' => ( strtotime( $expiration ) > time() ? false : true ), 'is_popular' => (boolean) $popular, 'is_exclusive' => (boolean) $exclusive, 'is_verified' => (boolean) $verified, 'last_check' => $last_verif, 'votes' => $votes, 'votes_percent' => $votes_percent, 'paid_until' => $paid_until, 'date' => $date, 'reviews' => $reviews, 'stars' => $stars, 'store_is_physical' => (boolean) $store_type, 'store_img' => htmlspecialchars( $store_img ), 'store_catID' => $store_cat, 'store_name' => htmlspecialchars( $store_name ), 'store_url' => htmlspecialchars( $store_link ), 'store_phone_no' => htmlspecialchars( $store_phone ), 'store_sellonline' => (boolean) $store_sellonline, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_coupon, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?id=' . $id ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store ), 'store_reviews_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_reviews, $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $store ) );
  }

  $stmt->close();

  return $data;

  break;

  }

}

/*

NUMBER OF PRODUCTS

*/

public static function have_products( $category = array(), $place = '', $special = array() ) {

global $db, $GET;

  $categories = \site\utils::validate_user_data( $category );

  $where = array();

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['categories'] ) && strcasecmp( $categories['categories'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['categories'] ) ));
    if( !empty( $arr ) )
    $where[] = 'p.category IN(' . \site\utils::dbp ( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['update'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['update'] ) );
    $where[] = 'p.lastupdate >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'p.lastupdate <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'p.date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'p.date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  /*

  */

  switch( $place ) {

  case 'category':

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT id FROM " . DB_TABLE_PREFIX . "categories WHERE subcategory = ?" );
  $stmt->bind_param( "i", $GET['id'] );
  $stmt->execute();
  $stmt->bind_result( $id );

  $ids[] = (int) $GET['id'];
  while( $stmt->fetch() ) {
    $ids[] = $id;
  }

  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "products p LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (p.store = s.id) WHERE p.category IN(" . implode( ',', $ids ) . ") AND p.visible > 0 AND s.visible > 0" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();

  break;

  case 'search':

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "products p LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = p.store) WHERE CONCAT(p.title, p.tags, s.name, s.tags) REGEXP ? AND p.visible > 0 AND s.visible > 0" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) );

  if( gettype( $GET['id'] ) === 'string' ) {
  $search = implode( '.*', explode( ' ', trim( $GET['id'] ) ) );
  } else {
  $search = '';
  }

  $stmt->bind_param( "s", $search  );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();

  break;

  default:

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['ids'] ) && strcasecmp( $categories['ids'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['ids'] ) ));
    if( !empty( $arr ) )
    $where[] = 'p.id IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['store'] ) && strcasecmp( $categories['store'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['store'] ) ));
    if( !empty( $arr ) )
    $where[] = 'p.store IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['user'] ) ) {
    $where[] = 'p.user = "' . (int) $categories['user'] . '"';
  }

  if( !empty( $categories['store_owner'] ) ) {
    $where[] = 's.user = "' . (int) $categories['store_owner'] . '"';
  }

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(p.title, p.tags) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
  $show = array_map( 'trim', explode( ',', strtolower( $categories['show'] ) ) );
  foreach( $show as $v ) {
    switch( $v ) {
      case 'all': break;
      case 'expired': $where[] = 'p.expiration <= NOW()'; break;
      case 'active':  $where[] = 'p.expiration > NOW()'; break;
      case 'popular':  $where[] = 'p.popular > 0'; break;
      case 'exclusive':  $where[] = 'p.exclusive > 0'; break;
      case 'feed':  $where[] = 'p.feedID > 0'; break;
      case 'visible':  $where[] = 'p.visible > 0 AND s.visible > 0'; break;
      case 'notvisible': $where[] = 'p.visible = 0'; break;
      default: $where[] = 'p.visible > 0 AND s.visible > 0'; break;
    }
  }
  } else {
    $where[] = 'p.visible > 0 AND s.visible > 0';
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "products p LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = p.store)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();

  break;

  }

  $stmt->close();

  if( isset( $special['only_count'] ) ) {
    return $count;
  }


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

}

/*

FETCH THE PRODUCTS

*/

public static function while_products( $category = array(), $place = '', $special = array() ) {

global $db, $GET;

  /** make or not seo links */
  $seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;
  list( $seo_link_product, $seo_link_store, $seo_link_reviews, $extension ) = array( \query\main::get_option( 'seo_link_product' ), \query\main::get_option( 'seo_link_store' ), \query\main::get_option( 'seo_link_reviews' ), \query\main::get_option( 'extension' ) );

  $categories = \site\utils::validate_user_data( $category );

  $where = $orderby = $limit = array();

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = ( isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0 );

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['categories'] ) && strcasecmp( $categories['categories'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['categories'] ) ));
    if( !empty( $arr ) )
    $where[] = 'p.category IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['update'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['update'] ) );
    $where[] = 'p.lastupdate >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'p.lastupdate <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'p.date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'p.date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( isset( $categories['orderby'] ) ) {
  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );
  foreach( $order as $v ) {
    switch( $v ) {
      case 'rand': $orderby[] = 'RAND()'; break;
      case 'name': $orderby[] = 'p.title'; break;
      case 'name desc': $orderby[] = 'p.title DESC'; break;
      case 'update': $orderby[] = 'p.lastupdate'; break;
      case 'update desc': $orderby[] = 'p.lastupdate DESC'; break;
      case 'rating': $orderby[] = 'rating'; break;
      case 'rating desc': $orderby[] = 'rating DESC'; break;
      case 'votes': $orderby[] = 'votes'; break;
      case 'votes desc': $orderby[] = 'votes DESC'; break;
      case 'views': $orderby[] = 'p.views'; break;
      case 'views desc': $orderby[] = 'p.views DESC'; break;
      case 'date': $orderby[] = 'p.date'; break;
      case 'date desc': $orderby[] = 'p.date DESC'; break;
      case 'active': $orderby[] = 'p.expiration'; break;
      case 'active desc': $orderby[] = 'p.expiration DESC'; break;
    }
  }
  }

  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_products' );
  }

  /*

  */

  switch( $place ) {

  case 'category':

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT id FROM " . DB_TABLE_PREFIX . "categories WHERE subcategory = ?" );
  $stmt->bind_param( "i", $GET['id'] );
  $stmt->execute();
  $stmt->bind_result( $id );

  $ids[] = (int) $GET['id'];
  while( $stmt->fetch() ) {
    $ids[] = $id;
  }

  $stmt->prepare( "SELECT p.id, p.feedID, p.user, p.store, p.category, p.popular, p.title, p.link, p.description, p.tags, p.image, p.price, p.old_price, p.currency, p.visible, p.views, p.start, p.expiration, p.cashback, p.url_title, p.paid_until, p.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as votes, (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as rating, s.id, s.category, s.physical, s.name, s.image, s.link, s.sellonline, s.url_title FROM " . DB_TABLE_PREFIX . "products p LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = p.store) WHERE p.category IN(" . implode( ',', $ids ) . ") AND p.visible > 0 AND s.visible > 0" . ( empty( $where ) ? '' : implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $store, $cat, $popular, $title, $link, $description, $tags, $image, $price, $old_price, $currency, $visible, $views, $start, $expiration, $cashback, $url_title, $paid_until, $date, $reviews, $stars, $store_id, $store_cat, $store_type, $store_name, $store_img, $store_link, $store_sellonline, $store_url_title );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $title;
    $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;

    $data[] = (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'storeID' => $store, 'catID' => $cat, 'title' => htmlspecialchars( $title ), 'url' => ( preg_match( '/^http(s)?/i', $link ) ? htmlspecialchars( $link ) : htmlspecialchars( $store_link ) ), 'original_url' => $link, 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'price' => $price, 'old_price' => ( $old_price > 0 && $old_price > $price ? $old_price : 0 ), 'currency' => htmlspecialchars( $currency ), 'visible' => (boolean) $visible, 'views' => $views, 'start_date' => $start, 'is_running' => ( strtotime( $start ) < time() && strtotime( $expiration ) > time() ? true : false ), 'expiration_date' => $expiration, 'cashback' => $cashback, 'is_available_online' => ( ! (boolean) $store_type || $store_sellonline ? true : false ), 'is_started' => ( strtotime( $start ) > time() ? false : true ), 'is_expired' => ( strtotime( $expiration ) > time() ? false : true ), 'paid_until' => $paid_until, 'date' => $date, 'reviews' => $reviews, 'stars' => $stars, 'store_is_physical' => (boolean) $store_type, 'store_img' => htmlspecialchars( $store_img ), 'storeID' => $store_id, 'store_catID' => $store_cat, 'store_name' => htmlspecialchars( $store_name ), 'store_url' => htmlspecialchars( $store_link ), 'store_sellonline' => (boolean) $store_sellonline, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_product, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?product=' . $id ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $store_url_tit, $store_id, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store_id ), 'store_reviews_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_reviews, $store_url_tit, $store_id, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $store_id ) );

  }

  $stmt->close();

  return $data;

  break;

  case 'search':

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT p.id, p.feedID, p.user, p.store, p.category, p.popular, p.title, p.link, p.description, p.tags, p.image, p.price, p.old_price, p.currency, p.visible, p.views, p.start, p.expiration, p.cashback, p.url_title, p.paid_until, p.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as votes, (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as rating, s.id, s.category, s.physical, s.name, s.image, s.link, s.sellonline, s.url_title FROM " . DB_TABLE_PREFIX . "products p LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = p.store) WHERE CONCAT(p.title, p.tags, s.name, s.tags) REGEXP ? AND p.visible > 0 AND s.visible > 0" . ( empty( $where ) ? '' : ' AND ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );

  if( gettype( $GET['id'] ) === 'string' ) {
  $search = implode( '.*', explode( ' ', trim( $GET['id'] ) ) );
  $search = substr( $search, 0, 50 );
  } else {
  $search = '';
  }

  $stmt->bind_param( "s", $search );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $store, $cat, $popular, $title, $link, $description, $tags, $image, $price, $old_price, $currency, $visible, $views, $start, $expiration, $cashback, $url_title, $paid_until, $date, $reviews, $stars, $store_id, $store_cat, $store_type, $store_name, $store_img, $store_link, $store_sellonline, $store_url_title );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $title;
    $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;

    $data[] = (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'storeID' => $store, 'catID' => $cat, 'title' => htmlspecialchars( $title ), 'url' => ( preg_match( '/^http(s)?/i', $link ) ? htmlspecialchars( $link ) : htmlspecialchars( $store_link ) ), 'original_url' => $link, 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'price' => $price, 'old_price' => ( $old_price > 0 && $old_price > $price ? $old_price : 0 ), 'currency' => htmlspecialchars( $currency ), 'visible' => (boolean) $visible, 'views' => $views, 'start_date' => $start, 'is_running' => ( strtotime( $start ) < time() && strtotime( $expiration ) > time() ? true : false ), 'expiration_date' => $expiration, 'cashback' => $cashback, 'is_available_online' => ( ! (boolean) $store_type || $store_sellonline ? true : false ), 'is_started' => ( strtotime( $start ) > time() ? false : true ), 'is_expired' => ( strtotime( $expiration ) > time() ? false : true ), 'paid_until' => $paid_until, 'date' => $date, 'reviews' => $reviews, 'stars' => $stars, 'store_is_physical' => (boolean) $store_type, 'store_img' => htmlspecialchars( $store_img ), 'storeID' => $store_id, 'store_catID' => $store_cat, 'store_name' => htmlspecialchars( $store_name ), 'store_url' => htmlspecialchars( $store_link ), 'store_sellonline' => (boolean) $store_sellonline, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_product, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?product=' . $id ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $store_url_tit, $store_id, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store_id ), 'store_reviews_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_reviews, $store_url_tit, $store_id, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $store_id ) );

  }

  $stmt->close();

  return $data;

  break;

  default:

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['ids'] ) && strcasecmp( $categories['ids'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['ids'] ) ));
    if( !empty( $arr ) )
    $where[] = 'p.id IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
    if( !isset( $categories['orderby'] ) ) {
      $orderby[] = 'field(p.id,' . \site\utils::dbp( implode(',', $arr) ) . ')';
    }
  }

  if( !empty( $categories['store'] ) && strcasecmp( $categories['store'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['store'] ) ));
    if( !empty( $arr ) )
    $where[] = 'p.store IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['user'] ) ) {
    $where[] = 'p.user = "' . (int) $categories['user'] . '"';
  }

  if( !empty( $categories['store_owner'] ) ) {
    $where[] = 's.user = "' . (int) $categories['store_owner'] . '"';
  }

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(p.title, p.tags) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
  $show = array_map( 'trim', explode( ',', strtolower( $categories['show'] ) ) );
  foreach( $show as $v ) {
    switch( $v ) {
      case 'all': break;
      case 'expired': $where[] = 'p.expiration <= NOW()'; break;
      case 'active':  $where[] = 'p.expiration > NOW()'; break;
      case 'popular':  $where[] = 'p.popular > 0'; break;
      case 'exclusive':  $where[] = 'p.exclusive > 0'; break;
      case 'cashback': $where[] = 'p.cashback > 0'; break;
      case 'feed':  $where[] = 'p.feedID > 0'; break;
      case 'visible':  $where[] = 'p.visible > 0 AND s.visible > 0'; break;
      case 'notvisible': $where[] = 'p.visible = 0'; break;
      default: $where[] = 'p.visible > 0 AND s.visible > 0'; break;
    }
  }
  } else {
    $where[] = 'p.visible > 0 AND s.visible > 0';
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT p.id, p.feedID, p.user, p.store, p.category, p.popular, p.title, p.link, p.description, p.tags, p.image, p.price, p.old_price, p.currency, p.visible, p.views, p.start, p.expiration, p.cashback, p.url_title, p.paid_until, p.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as votes, (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as rating, s.id, s.category, s.physical, s.name, s.image, s.link, s.sellonline, s.url_title FROM " . DB_TABLE_PREFIX . "products p LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = p.store)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $store, $cat, $popular, $title, $link, $description, $tags, $image, $price, $old_price, $currency, $visible, $views, $start, $expiration, $cashback, $url_title, $paid_until, $date, $reviews, $stars, $store_id, $store_cat, $store_type, $store_name, $store_img, $store_link, $store_sellonline, $store_url_title );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $title;
    $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;

    $data[] = (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'storeID' => $store, 'catID' => $cat, 'title' => htmlspecialchars( $title ), 'url' => ( preg_match( '/^http(s)?/i', $link ) ? htmlspecialchars( $link ) : htmlspecialchars( $store_link ) ), 'original_url' => $link, 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'price' => $price, 'old_price' => ( $old_price > 0 && $old_price > $price ? $old_price : 0 ), 'currency' => htmlspecialchars( $currency ), 'visible' => (boolean) $visible, 'views' => $views, 'start_date' => $start, 'is_running' => ( strtotime( $start ) < time() && strtotime( $expiration ) > time() ? true : false ), 'expiration_date' => $expiration, 'cashback' => $cashback, 'is_available_online' => ( ! (boolean) $store_type || $store_sellonline ? true : false ), 'is_started' => ( strtotime( $start ) > time() ? false : true ), 'is_expired' => ( strtotime( $expiration ) > time() ? false : true ), 'paid_until' => $paid_until, 'date' => $date, 'reviews' => $reviews, 'stars' => $stars, 'store_is_physical' => (boolean) $store_type, 'store_img' => htmlspecialchars( $store_img ), 'storeID' => $store_id, 'store_catID' => $store_cat, 'store_name' => htmlspecialchars( $store_name ), 'store_url' => htmlspecialchars( $store_link ), 'store_sellonline' => (boolean) $store_sellonline, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_product, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?product=' . $id ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $store_url_tit, $store_id, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store_id ), 'store_reviews_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_reviews, $store_url_tit, $store_id, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $store_id ) );

  }

  $stmt->close();

  return $data;

  break;

  }

}

/*

NUMBER OF REVIEWS

*/

public static function have_reviews( $category = array(), $place = '', $special = array() ) {

global $db, $GET;

  $categories = \site\utils::validate_user_data( $category ); 

  $where = array();

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  /*

  */

  switch( $place ) {

  case 'store':

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = ? AND valid > 0");
  $stmt->bind_param( "i", $GET['id'] );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();

  break;

  default:

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['store'] ) && strcasecmp( $categories['store'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['store'] ) ));
    if( !empty( $arr ) )
    $where[] = 'store IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['user'] ) ) {
    $where[] = 'user = "' . (int) $categories['user'] . '"';
  }

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'text REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
    $show = strtolower( $categories['show'] );
    switch( $show ) {
      case 'all': break;
      case 'notvalid': $where[] = 'valid = 0'; break;
      default: $where[] = 'valid > 0'; break;
    }
  } else {
    $where[] = 'valid > 0';
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();

  break;

  }

  $stmt->close();

  if( isset( $special['only_count'] ) ) {
    return $count;
  }


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

}

/*

FETCH THE REVIEWS

*/

public static function while_reviews( $category = array(), $place = '', $special = array() ) {

global $db, $GET;

  /** make or not seo links */
  $seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;
  list( $seo_link_store, $extension ) = array( \query\main::get_option( 'seo_link_store' ), \query\main::get_option( 'extension' ) );

  $categories = \site\utils::validate_user_data( $category ); 

  $where = $orderby = $limit = array();

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0;

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'r.date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'r.date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( isset( $categories['orderby'] ) ) {
  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );
  foreach( $order as $v ) {
    switch( $v ) {
      case 'rand': $orderby[] = 'RAND()'; break;
      case 'date': $orderby[] = 'r.date'; break;
      case 'date desc': $orderby[] = 'r.date DESC'; break;
    }
  }
  }

  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_reviews' );
  }

  /*

  */

  switch( $place ) {

  case 'store':

  $stmt = $db->stmt_init();
  $stmt->prepare("SELECT r.id, r.user, r.store, r.text, r.stars, r.valid, r.date, u.name, u.avatar FROM " . DB_TABLE_PREFIX . "reviews r LEFT JOIN " . DB_TABLE_PREFIX . "users u ON (u.id = r.user) WHERE r.store = ? AND r.valid > 0" . ( empty( $where ) ? '' : implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->bind_param( "i", $GET['id'] );
  $stmt->execute();
  $stmt->bind_result( $id, $user, $store, $text, $stars, $valid, $date, $user_name, $user_avatar );

  $data = array();
  while( $stmt->fetch() ) {
    $data[] = (object) array( 'ID' => $id, 'userID' => $user, 'storeID' => $store, 'user_name' => htmlspecialchars( $user_name ), 'text' => \site\smilies::BBcode( $text, $usebb ), 'stars' => $stars, 'valid' => (boolean) $valid, 'date' => $date, 'user_avatar' => htmlspecialchars( $user_avatar ) );
  }

  $stmt->close();

  return $data;

  break;

  default:

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['store'] ) && strcasecmp( $categories['store'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['store'] ) ));
    if( !empty( $arr ) )
    $where[] = 'r.store IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['user'] ) ) {
    $where[] = 'r.user = "' . (int) $categories['user'] . '"';
  }


  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'text REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
    $show = strtolower( $categories['show'] );
    switch( $show ) {
      case 'all': break;
      case 'notvalid': $where[] = 'r.valid = 0'; break;
      default: $where[] = 'r.valid > 0'; break;
    }
  } else {
    $where[] = 'r.valid > 0';
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT r.id, r.user, r.store, r.text, r.stars, r.valid, r.date, u.name, u.avatar, s.name, s.link, s.url_title FROM " . DB_TABLE_PREFIX . "reviews r LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = r.store) LEFT JOIN " . DB_TABLE_PREFIX . "users u ON (u.id = r.user)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $user, $store, $text, $stars, $valid, $date, $user_name, $user_avatar, $store_name, $store_url, $store_url_title );

  $data = array();
  while( $stmt->fetch() ) {

    $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;

    $data[] = (object)array( 'ID' => $id, 'userID' => $user, 'storeID' => $store, 'user_name' => htmlspecialchars( $user_name ), 'store_url' => $store_url, 'text' => \site\smilies::BBcode( $text, $usebb ), 'stars' => $stars, 'valid' => (boolean) $valid, 'date' => $date, 'user_avatar' => htmlspecialchars( $user_avatar ), 'store_name' => htmlspecialchars( $store_name ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store ) );

  }

  $stmt->close();

  return $data;

  break;

  }

}

/*

NUMBER OF STORES

*/

public static function have_stores( $category = array(), $special = array() ) {

global $db;

  $categories = \site\utils::validate_user_data( $category ); 

  $where = array();

  /*

  WHERE / ORDER BY

  */

  if( isset( $categories['firstchar'] ) && preg_match( '/(^[\p{L}]$|^0-9$)/u', $categories['firstchar'] ) ) {
    $where[] = 'name REGEXP "^' . ( is_numeric( $categories['firstchar'][0] ) ? '[0-9]' : \site\utils::dbp( $categories['firstchar'] ) ) . '"';
  }

  if( !empty( $categories['user'] ) ) {
    $where[] = 'user = "' . (int) $categories['user'] . '"';
  }

  if( !empty( $categories['ids'] ) && strcasecmp( $categories['ids'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['ids'] ) ));
    if( !empty( $arr ) )
    $where[] = 'id IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['categories'] ) && strcasecmp( $categories['categories'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['categories'] ) ));
    if( !empty( $arr ) )
    $where[] = 'category IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
  }

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(name, tags) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
  $show = array_map( 'trim', explode( ',', strtolower( $categories['show'] ) ) );
  foreach( $show as $v ) {
    switch( $v ) {
      case 'all': break;
      case 'physical':  $where[] = 'physical > 0'; break;
      case 'online':  $where[] = 'physical = 0'; break;
      case 'popular':  $where[] = 'popular > 0'; break;
      case 'exclusive':  $where[] = 'exclusive > 0'; break;
      case 'feed':  $where[] = 'feedID > 0'; break;
      case 'notvisible': $where[] = 'visible = 0'; break;
      default: $where[] = 'visible > 0'; break;
    }
  }
  } else {
    $where[] = 'visible > 0';
  }

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "stores" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();

  $stmt->close();

  if( isset( $special['only_count'] ) ) {
    return $count;
  }


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

}

/*

FETCH THE STORES

*/

public static function while_stores( $category = array(), $special = array() ) {

global $db;

  /** make or not seo links */
  $seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;
  list( $seo_link_store, $seo_link_reviews, $extension ) = array( \query\main::get_option( 'seo_link_store' ), \query\main::get_option( 'seo_link_reviews' ), \query\main::get_option( 'extension' ) );

  $categories = \site\utils::validate_user_data( $category ); 

  $where = $orderby = $limit = array();

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0;

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  if( isset( $categories['firstchar'] ) && preg_match( '/(^[\p{L}]$|^0-9$)/u', $categories['firstchar'] ) ) {
    $where[] = 'name REGEXP "^' . ( is_numeric( $categories['firstchar'][0] ) ? '[0-9]' : \site\utils::dbp( $categories['firstchar'] ) ) . '"';
  }

  if( !empty( $categories['user'] ) ) {
    $where[] = 'user = "' . (int) $categories['user'] . '"';
  }

  if( !empty( $categories['ids'] ) && strcasecmp( $categories['ids'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['ids'] ) ));
    if( !empty( $arr ) )
    $where[] = 'id IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
    if( !isset( $categories['orderby'] ) ) {
      $orderby[] = 'field(id,' . \site\utils::dbp( implode(',', $arr) ) . ')';
    }
  }

  if( !empty( $categories['categories'] ) && strcasecmp( $categories['categories'], 'all' ) != 0 ) {
    $arr = array_filter( array_map( function( $w ){
        return (int) $w;
    }, explode( ',', $categories['categories'] ) ));
    if( !empty( $arr ) )
    $where[] = 'category IN(' . \site\utils::dbp( implode(',', $arr) ) . ')';
    if( !isset( $categories['orderby'] ) ) {
      $orderby[] = 'field(id,' . \site\utils::dbp( implode(',', $arr) ) . ')';
    }
  }

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(name, tags) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
  $show = array_map( 'trim', explode( ',', strtolower( $categories['show'] ) ) );
  foreach( $show as $v ) {
    switch( $v ) {
      case 'all': break;
      case 'physical':  $where[] = 'physical > 0'; break;
      case 'online':  $where[] = 'physical = 0'; break;
      case 'popular':  $where[] = 'popular > 0'; break;
      case 'feed':  $where[] = 'feedID > 0'; break;
      case 'notvisible': $where[] = 'visible = 0'; break;
      default: $where[] = 'visible > 0'; break;
    }
  }
  } else {
    $where[] = 'visible > 0';
  }

  if( !empty( $categories['date'] ) ) {
    $date = array_map( 'trim', explode( ',', $categories['date'] ) );
    $where[] = 'date >= FROM_UNIXTIME(' . \site\utils::dbp( $date[0] ) . ')';
    if( isset( $date[1] ) ) {
      $where[] = 'date <= FROM_UNIXTIME(' . \site\utils::dbp( $date[1] ) . ')';
    }
  }

  if( isset( $categories['orderby'] ) ) {
  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );
  foreach( $order as $v ) {
    switch( $v ) {
      case 'rand': $orderby[] = 'RAND()'; break;
      case 'name': $orderby[] = 'name'; break;
      case 'name desc': $orderby[] = 'name DESC'; break;
      case 'update': $orderby[] = 'lastupdate'; break;
      case 'update desc': $orderby[] = 'lastupdate DESC'; break;
      case 'rating': $orderby[] = 'rating'; break;
      case 'rating desc': $orderby[] = 'rating DESC'; break;
      case 'votes': $orderby[] = 'votes'; break;
      case 'votes desc': $orderby[] = 'votes DESC'; break;
      case 'views': $orderby[] = 'views'; break;
      case 'views desc': $orderby[] = 'views DESC'; break;
      case 'date': $orderby[] = 'date'; break;
      case 'date desc': $orderby[] = 'date DESC'; break;
    }
  }
  }

  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_stores' );
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT id, feedID, user, category, popular, physical, name, link, description, tags, image, hours, phoneno, sellonline, visible, views, url_title, date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as votes, (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as rating, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "coupons WHERE store = s.id AND visible > 0), (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "products WHERE store = s.id AND visible > 0) FROM " . DB_TABLE_PREFIX . "stores s" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $cat, $popular, $physical, $name, $link, $description, $tags, $image, $hours, $phone, $sellonline, $visible, $views, $url_title, $date, $reviews, $stars, $coupons, $products );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $name;

    $data[] = (object)array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'catID' => $cat, 'name' => htmlspecialchars( $name ), 'url' => htmlspecialchars( $link ), 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'hours' => @unserialize( $hours ), 'phone_no' => htmlspecialchars( $phone ), 'sellonline' => (boolean) ( !$physical ? 1 : $sellonline ), 'sellonline2' => (boolean) $sellonline, 'date' => $date, 'visible' => (boolean) $visible, 'views' => $views, 'reviews' => $reviews, 'stars' => $stars, 'coupons' => $coupons, 'products' => $products, 'is_popular' => (boolean) $popular, 'is_physical' => (boolean) $physical, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?store=' . $id ), 'reviews_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_reviews, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $id ) );

  }

  $stmt->close();

  return $data;

}

/*

NUMBER OF FAVORITES

*/

public static function have_favorites( $category = array(), $special = array() ) {

if( $GLOBALS['me'] ) {

global $db;

  $categories = \site\utils::validate_user_data( $category );

  $where = array();

  $where[] = 'f.user = "' . (int) $GLOBALS['me']->ID . '" AND s.visible > 0';

  if( isset( $categories['firstchar'] ) && preg_match( '/(^[\p{L}]{1}$|^0-9$)/', $categories['firstchar'] ) ) {
    $where[] = 's.name REGEXP "^' . ( is_numeric( $categories['firstchar'][0] ) ? '[0-9]' : \site\utils::dbp( $categories['firstchar'] ) ) . '"';
  }

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "favorite f LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = f.store)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( isset( $special['only_count'] ) ) {
    return $count;
  }


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

} else {

  return false;

}

}

/*

FETCH THE FAVORITES

*/

public static function while_favorites( $category = array(), $special = array() ) {

if( $GLOBALS['me'] ) {

global $db;

  /** make or not seo links */
  $seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;
  list( $seo_link_store, $seo_link_reviews, $extension ) = array( \query\main::get_option( 'seo_link_store' ), \query\main::get_option( 'seo_link_reviews' ), \query\main::get_option( 'extension' ) );

  $categories = \site\utils::validate_user_data( $category ); 

  $where = $orderby = $limit = array();

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categoriesry['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0;

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  $where[] = 'f.user = "' . (int) $GLOBALS['me']->ID . '" AND s.visible > 0';

  if( isset( $categories['firstchar'] ) && preg_match( '/(^[\p{L}]{1}$|^0-9$)/', $categories['firstchar'] ) ) {
    $where[] = 's.name REGEXP "^' . ( is_numeric( $categories['firstchar'][0] ) ? '[0-9]' : \site\utils::dbp( $categories['firstchar'] ) ) . '"';
  }

  if( isset( $categories['orderby'] ) ) {
  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );
  foreach( $order as $v ) {
    switch( $v ) {
      case 'rand': $orderby[] = 'RAND()'; break;
      case 'date': $orderby[] = 's.date'; break;
      case 'date desc': $orderby[] = 's.date DESC'; break;
    }
  }
  }


  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_stores' );
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT s.id, s.feedID, s.user, s.category, s.popular, s.physical, s.name, s.link, s.description, s.tags, s.image, s.hours, s.phoneno, s.sellonline, s.visible, s.views, s.url_title, s.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as votes, (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as rating, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "coupons WHERE store = s.id AND visible > 0), (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "products WHERE store = s.id AND visible > 0) FROM " . DB_TABLE_PREFIX . "favorite f LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (f.store = s.id)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $cat, $popular, $physical, $name, $link, $description, $tags, $image, $hours, $phone, $sellonline, $visible, $views, $url_title, $date, $reviews, $stars, $coupons, $products );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $name;

    $data[] = (object)array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'catID' => $cat, 'name' => htmlspecialchars( $name ), 'url' => htmlspecialchars( $link ), 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'hours' => @unserialize( $hours ), 'phone_no' => htmlspecialchars( $phone ), 'sellonline' => (boolean) ( !$physical ? 1 : $sellonline ), 'sellonline2' => (boolean) $sellonline, 'date' => $date, 'visible' => (boolean) $visible, 'views' => $views, 'reviews' => $reviews, 'stars' => $stars, 'coupons' => $coupons, 'products' => $products, 'is_popular' => (boolean) $popular, 'is_physical' => (boolean) $physical, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?store=' . $id ), 'reviews_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_reviews, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $id ) );

  }

  $stmt->close();

  return $data;

} else {

  return array();

}

}

/*

NUMBER OF ITEMS - COUPONS ON WALL

*/

public static function have_wall( $category = array() ) {

if( $GLOBALS['me'] ) {

global $db;

  $categories = \site\utils::validate_user_data( $category ); 

  $where = array();

  /*

  WHERE / ORDER BY

  */

  $where[] = 'f.user = "' . (int) $GLOBALS['me']->ID . '" AND c.visible > 0 AND s.visible > 0';

  if( isset( $categories['firstchar'] ) && preg_match( '/(^[\p{L}]{1}$|^0-9$)/', $categories['firstchar'] ) ) {
    $where[] = 's.name REGEXP "^' . ( is_numeric( $categories['firstchar'][0] ) ? '[0-9]' : \site\utils::dbp( $categories['firstchar'] ) ) . '"';
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "coupons c LEFT JOIN " . DB_TABLE_PREFIX . "favorite f ON (f.store = c.store) LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = f.store)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

} else {

  return false;

}

}

/*

FETCH THE WALL - COUPONS

*/

public static function while_wall( $category = array(), $special = array() ) {

if( $GLOBALS['me'] ) {

global $db;

  $categories = \site\utils::validate_user_data( $category );

  $where = $limit = $orderby = array();

  /** make or not seo links */
  $seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;
  list( $seo_link_coupon, $seo_link_store, $seo_link_reviews, $extension ) = array( \query\main::get_option( 'seo_link_coupon' ), \query\main::get_option( 'seo_link_store' ), \query\main::get_option( 'seo_link_reviews' ), \query\main::get_option( 'extension' ) );

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0;

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  $where[] = 'f.user = "' . (int) $GLOBALS['me']->ID . '" AND c.visible > 0 AND s.visible > 0';

  if( isset( $categories['firstchar'] ) && preg_match( '/(^[\p{L}]{1}$|^0-9$)/', $categories['firstchar'] ) ) {
    $where[] = 's.name REGEXP "^' . ( is_numeric( $categories['firstchar'][0] ) ? '[0-9]' : \site\utils::dbp( $categories['firstchar'] ) ) . '"';
  }

  if( isset( $categories['orderby'] ) ) {

  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );

  foreach( $order as $v ) {
    switch( $v ) {
        case 'rand': $orderby[] = 'RAND()'; break;
        case 'date': $orderby[] = 'c.date'; break;
        case 'date desc': $orderby[] = 'c.date DESC'; break;
    }
  }

  }

  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_coupons' );
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT c.id, c.feedID, c.user, c.store, c.category, c.popular, c.exclusive, c.printable, c.available_online, c.title, c.link, c.description, c.tags, c.image, c.code, c.source, c.visible, c.views, c.clicks, c.start, c.expiration, c.cashback, c.url_title, c.votes, c.votes_percent, c.verified, c.last_verif, c.paid_until, c.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as votes, (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as rating, s.physical, s.category, s.name, s.link, s.image, s.sellonline, s.url_title FROM " . DB_TABLE_PREFIX . "coupons c LEFT JOIN " . DB_TABLE_PREFIX . "favorite f ON (f.store = c.store) LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = f.store)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $store, $cat, $popular, $exclusive, $printable, $avab_online, $title, $link, $description, $tags, $image, $code, $source, $visible, $views, $clicks, $start, $expiration, $cashback, $url_title, $votes, $votes_percent, $verified, $last_verif, $paid_until, $date, $reviews, $stars, $store_type, $store_cat, $store_name, $store_link, $store_img, $store_sellonline, $store_url_title );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $title;
    $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;

    $data[] = (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'storeID' => $store, 'catID' => $cat, 'code' => htmlspecialchars( $code ), 'title' => htmlspecialchars( $title ), 'url' => ( filter_var( $link, FILTER_VALIDATE_URL ) ? htmlspecialchars( $link ) : htmlspecialchars( $store_link ) ), 'original_url' => $link, 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'image2' => ( !empty( $image ) ? ( !filter_var( $image, FILTER_VALIDATE_URL ) ? $GLOBALS['siteURL'] . htmlspecialchars( $image ) : htmlspecialchars( $image ) ) : '' ), 'source' => ( empty( $source ) ? '' : ( filter_var( $source, FILTER_VALIDATE_URL ) ? htmlspecialchars( $source ) : $GLOBALS['siteURL'] . htmlspecialchars( $source ) ) ), 'visible' => (boolean) $visible, 'views' => $views, 'clicks' => $clicks, 'start_date' => $start, 'is_coupon' => ( !empty( $code ) ? true : false ), 'is_deal' => ( empty( $code ) ? true : false ), 'is_running' => ( strtotime( $start ) < time() && strtotime( $expiration ) > time() ? true : false ), 'expiration_date' => $expiration, 'cashback' => $cashback, 'is_printable' => ( (boolean) $store_type ? (boolean) $printable : false ), 'is_available_online' => ( ! (boolean) $store_type || (boolean) $avab_online ? true : false ), 'is_local_source' => ( empty( $source ) || filter_var( $source, FILTER_VALIDATE_URL ) ? false : true ), 'is_started' => ( strtotime( $start ) > time() ? false : true ), 'is_expired' => ( strtotime( $expiration ) > time() ? false : true ), 'is_popular' => (boolean) $popular, 'is_exclusive' => (boolean) $exclusive, 'is_verified' => (boolean) $verified, 'last_check' => $last_verif, 'votes' => $votes, 'votes_percent' => $votes_percent, 'paid_until' => $paid_until, 'date' => $date, 'reviews' => $reviews, 'stars' => $stars, 'store_is_physical' => (boolean) $store_type, 'store_img' => htmlspecialchars( $store_img ), 'store_catID' => $store_cat, 'store_name' => htmlspecialchars( $store_name ), 'store_url' => htmlspecialchars( $store_link ), 'store_sellonline' => (boolean) $store_sellonline, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_coupon, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?id=' . $id ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store ), 'store_reviews_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_reviews, $store_url_tit, $store, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $store ) );

  }

  $stmt->close();

  return $data;

} else {

  return array();

}

}

/*

NUMBER OF ITEMS - PRODUCTS ON WALL

*/

public static function have_wall_products( $category = array() ) {

if( $GLOBALS['me'] ) {

global $db;

  $categories = \site\utils::validate_user_data( $category );

  $where = array();

  /*

  WHERE / ORDER BY

  */

  $where[] = 'f.user = "' . (int) $GLOBALS['me']->ID . '" AND p.visible > 0 AND s.visible > 0';

  if( isset( $categories['firstchar'] ) && preg_match( '/(^[\p{L}]{1}$|^0-9$)/', $categories['firstchar'] ) ) {
    $where[] = 's.name REGEXP "^' . ( is_numeric( $categories['firstchar'][0] ) ? '[0-9]' : \site\utils::dbp( $categories['firstchar'] ) ) . '"';
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "products p LEFT JOIN " . DB_TABLE_PREFIX . "favorite f ON (f.store = p.store) LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = f.store)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

} else {

  return false;

}

}

/*

FETCH THE WALL - PRODUCTS

*/

public static function while_wall_products( $category = array(), $special = array() ) {

if( $GLOBALS['me'] ) {

global $db;

  $categories = \site\utils::validate_user_data( $category );

  $where = $limit = $orderby = array();

  /** make or not seo links */
  $seo_link = defined( 'SEO_LINKS' ) && SEO_LINKS ? true : false;
  list( $seo_link_product, $seo_link_store, $seo_link_reviews, $extension ) = array( \query\main::get_option( 'seo_link_product' ), \query\main::get_option( 'seo_link_store' ), \query\main::get_option( 'seo_link_reviews' ), \query\main::get_option( 'extension' ) );

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0;

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  $where[] = 'f.user = "' . (int) $GLOBALS['me']->ID . '" AND p.visible > 0 AND s.visible > 0';

  if( isset( $categories['firstchar'] ) && preg_match( '/(^[\p{L}]{1}$|^0-9$)/', $categories['firstchar'] ) ) {
    $where[] = 's.name REGEXP "^' . ( is_numeric( $categories['firstchar'][0] ) ? '[0-9]' : \site\utils::dbp( $categories['firstchar'] ) ) . '"';
  }

  if( isset( $categories['orderby'] ) ) {

  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );

  foreach( $order as $v ) {
    switch( $v ) {
        case 'rand': $orderby[] = 'RAND()'; break;
        case 'date': $orderby[] = 'p.date'; break;
        case 'date desc': $orderby[] = 'p.date DESC'; break;
    }
  }

  }

  if( isset( $special['nobb'] ) && $special['nobb'] ) {
    $usebb = false;
  } else {
    $usebb = (int) \query\main::get_option( 'smilies_products' );
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT p.id, p.feedID, p.user, p.store, p.category, p.popular, p.title, p.link, p.description, p.tags, p.image, p.price, p.old_price, p.currency, p.visible, p.views, p.start, p.expiration, p.cashback, p.url_title, p.paid_until, p.date, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as votes, (SELECT AVG(stars) FROM " . DB_TABLE_PREFIX . "reviews WHERE store = s.id AND valid > 0) as rating, s.id, s.category, s.physical, s.name, s.image, s.link, s.sellonline, s.url_title FROM " . DB_TABLE_PREFIX . "products p LEFT JOIN " . DB_TABLE_PREFIX . "favorite f ON (f.store = p.store) LEFT JOIN " . DB_TABLE_PREFIX . "stores s ON (s.id = f.store)" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $feed_id, $user, $store, $cat, $popular, $title, $link, $description, $tags, $image, $price, $old_price, $currency, $visible, $views, $start, $expiration, $cashback, $url_title, $paid_until, $date, $reviews, $stars, $store_id, $store_cat, $store_type, $store_name, $store_img, $store_link, $store_sellonline, $store_url_title );

  $data = array();
  while( $stmt->fetch() ) {

    $url_tit = !empty( $url_title ) ? $url_title : $title;
    $store_url_tit = !empty( $store_url_title ) ? $store_url_title : $store_name;

    $data[] = (object) array( 'ID' => $id, 'feedID' => $feed_id, 'userID' => $user, 'storeID' => $store, 'catID' => $cat, 'title' => htmlspecialchars( $title ), 'url' => ( filter_var( $link, FILTER_VALIDATE_URL ) ? htmlspecialchars( $link ) : htmlspecialchars( $store_link ) ), 'original_url' => $link, 'description' => \site\smilies::BBcode( $description, $usebb ), 'tags' => htmlspecialchars( $tags ), 'image' => htmlspecialchars( $image ), 'price' => $price, 'old_price' => ( $old_price > 0 && $old_price > $price ? $old_price : 0 ), 'currency' => htmlspecialchars( $currency ), 'visible' => (boolean) $visible, 'views' => $views, 'start_date' => $start, 'is_running' => ( strtotime( $start ) < time() && strtotime( $expiration ) > time() ? true : false ), 'expiration_date' => $expiration, 'cashback' => $cashback, 'is_available_online' => ( ! (boolean) $store_type || $store_sellonline ? true : false ), 'is_started' => ( strtotime( $start ) > time() ? false : true ), 'is_expired' => ( strtotime( $expiration ) > time() ? false : true ), 'paid_until' => $paid_until, 'date' => $date, 'reviews' => $reviews, 'stars' => $stars, 'store_is_physical' => (boolean) $store_type, 'store_img' => htmlspecialchars( $store_img ), 'storeID' => $store_id, 'store_catID' => $store_cat, 'store_name' => htmlspecialchars( $store_name ), 'store_url' => htmlspecialchars( $store_link ), 'store_sellonline' => (boolean) $store_sellonline, 'url_title' => htmlspecialchars( $url_tit ), 'link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_product, $url_tit, $id, $extension ) : $GLOBALS['siteURL'] . '?product=' . $id ), 'store_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_store, $store_url_tit, $store_id, $extension ) : $GLOBALS['siteURL'] . '?store=' . $store_id ), 'store_reviews_link' => ( $seo_link ? \site\utils::make_seo_link( $seo_link_reviews, $store_url_tit, $store_id, $extension ) : $GLOBALS['siteURL'] . '?reviews=' . $store_id ) );

  }

  $stmt->close();

  return $data;

} else {

  return array();

}

}

/*

NUMBER OF REWARDS

*/

public static function have_rewards( $category = array(), $special = array() ) {

global $db;

  $categories = \site\utils::validate_user_data( $category );

  $where = array();

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(title, description) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
    $show = strtolower( $categories['show'] );
    switch( $show ) {
      case 'active':  $where[] = 'visible > 0'; break;
    }
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "rewards" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( isset( $special['only_count'] ) ) {
    return $count;
  }


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

}

/*

FETCH THE REWARDS

*/

public static function while_rewards( $category = array() ) {

global $db;

  $categories = \site\utils::validate_user_data( $category ); 

  $where = $orderby = $limit = array();

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0;

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'CONCAT(title, description) REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
    $show = strtolower( $categories['show'] );
    switch( $show ) {
      case 'active':  $where[] = 'visible > 0'; break;
    }
  }

  if( isset( $categories['orderby'] ) ) {
  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );
  foreach( $order as $v ) {
    switch( $v ) {
      case 'rand': $orderby[] = 'RAND()'; break;
      case 'name': $orderby[] = 'title'; break;
      case 'name desc': $orderby[] = 'title DESC'; break;
      case 'date': $orderby[] = 'date'; break;
      case 'date desc': $orderby[] = 'date DESC'; break;
      case 'points': $orderby[] = 'points'; break;
      case 'points desc': $orderby[] = 'points DESC'; break;
    }
  }
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT id, user, points, title, description, image, fields, visible, date FROM " . DB_TABLE_PREFIX . "rewards" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $user, $points, $title, $description, $image, $fields, $visible, $date );

  $data = array();
  while( $stmt->fetch() ) {
    $data[] = (object)array( 'ID' => $id, 'user' => $user, 'points' => $points, 'title' => htmlspecialchars( $title ), 'description' => htmlspecialchars( $description ), 'image' => htmlspecialchars( $image ), 'fields' => @unserialize( $fields ), 'visible' => (boolean) $visible, 'date' => $date );
  }

  $stmt->close();

  return $data;

}

/*

NUMBER OF REWARD REQUESTS

*/

public static function have_rewards_reqs( $category = array(), $special = array() ) {

global $db;

  $categories = \site\utils::validate_user_data( $category ); 

  $where = array();

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['user'] ) ) {
    $where[] = 'user = "' . (int) $categories['user'] . '"';
  }

  if( !empty( $categories['reward'] ) ) {
    $where[] = 'reward = "' . (int) $categories['reward'] . '"';
  }

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'fields REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
    $show = strtolower( $categories['show'] );
    switch( $show ) {
      case 'valid': $where[] = 'claimed = 1'; break;
      case 'notvalid': $where[] = 'claimed = 0'; break;
    }
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "rewards_reqs" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) );
  $stmt->execute();
  $stmt->bind_result( $count );
  $stmt->fetch();
  $stmt->close();

  if( isset( $special['only_count'] ) ) {
    return $count;
  }


  $pags = array();
  $pags['results'] = $count;
  $pags['per_page'] = ( !empty( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
  $pags['pages'] = ceil( $pags['results'] / $pags['per_page'] );
  $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
  if( $page < 1 ) $page = 1;
  if( $page > $pags['pages'] ) $page = $_GET['page'] = $pags['pages'];
  $pags['page'] =  $page;
  if( $pags['pages'] > $pags['page'] ) $pags['next_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']+1) ) );
  if( $pags['pages'] > 1 && $pags['page'] > 1 ) $pags['prev_page'] = \site\utils::update_uri( '', array( 'page' => ($pags['page']-1) ) );

  return $pags;

}

/*

FETCH THE REWARDS REQUESTS

*/

public static function while_rewards_reqs( $category = array() ) {

global $db;

  $categories = \site\utils::validate_user_data( $category ); 

  $where = $orderby = $limit = array();

  if( isset( $categories['max'] ) ) {
    if( !empty( $categories['max'] ) ) {
      $limit[] = $categories['max'];
    }
  } else {
    $page = ( !empty( $_GET['page'] ) ? (int) $_GET['page'] : 1 );
    $per_page = ( isset( $categories['per_page'] ) ? (int) $categories['per_page'] : \query\main::get_option( 'items_per_page' ) );
    $offset = isset( $page ) && $page > 1 ? ( $page - 1 ) * $per_page : 0;

    $limit[] = $offset;
    $limit[] = $per_page;
  }

  /*

  WHERE / ORDER BY

  */

  if( !empty( $categories['user'] ) ) {
    $where[] = 'user = "' . (int) $categories['user'] . '"';
  }

  if( !empty( $categories['reward'] ) ) {
    $where[] = 'reward = "' . (int) $categories['reward'] . '"';
  }

  if( !empty( $categories['search'] ) ) {
    $search = implode( '.*', explode( ' ', trim( $categories['search'] ) ) );
    $where[] = 'fields REGEXP "' . \site\utils::dbp( $search ) . '"';
  }

  if( isset( $categories['show'] ) ) {
    $show = strtolower( $categories['show'] );
    switch( $show ) {
      case 'valid': $where[] = 'claimed = 1'; break;
      case 'notvalid': $where[] = 'claimed = 0'; break;
    }

  }

  if( isset( $categories['orderby'] ) ) {
  $order = array_map( 'trim', explode( ',', strtolower( $categories['orderby'] ) ) );
  foreach( $order as $v ) {
    switch( $v ) {
      case 'rand': $orderby[] = 'RAND()'; break;
      case 'date': $orderby[] = 'date'; break;
      case 'date desc': $orderby[] = 'date DESC'; break;
      case 'points': $orderby[] = 'points'; break;
      case 'points desc': $orderby[] = 'points DESC'; break;
    }
  }
  }

  /*

  */

  $stmt = $db->stmt_init();
  $stmt->prepare( "SELECT id, name, user, points, reward, (SELECT COUNT(*) FROM " . DB_TABLE_PREFIX . "rewards WHERE id = r.reward), fields, claimed, date FROM " . DB_TABLE_PREFIX . "rewards_reqs r" . ( empty( $where ) ? '' : ' WHERE ' . implode( ' AND ', array_filter( $where ) ) ) . ( empty( $orderby ) ? '' : ' ORDER BY ' . implode( ', ', array_filter( $orderby ) ) ) . ( empty( $limit ) ? '' : ' LIMIT ' . implode( ',', $limit ) ) );
  $stmt->execute();
  $stmt->bind_result( $id, $name, $user, $points, $reward, $reward_exists, $fields, $claimed, $date );

  $data = array();
  while( $stmt->fetch() ) {
    $data[] = (object)array( 'ID' => $id, 'name' => htmlspecialchars( $name ), 'user' => $user, 'points' => $points, 'reward' => $reward, 'reward_exists' => ( $reward_exists > 0 ? true : false ), 'fields' => @unserialize( $fields ), 'claimed' => (boolean) $claimed, 'date' => $date );
  }

  $stmt->close();

  return $data;

}

}