(function ( $ ) {

// SHOW/HIDE FUNCTION - USED FOR MENU SLIDE DOWN/UP

$.fn.show_next = function( options ) {

var option = $.extend({
  element: '',
  type: 'next',
  animate_before: '',
  animate_duration: 200,
  animate: 'slideDown',
  animate_hide: 'slideUp',
  animate_hide_duration: 200,
  close_on_click: false
}, options );

var $this = this, target;

if( option.type == 'next' ) {

  target = this.nextAll( option.element );

} else {

  target = this.find( option.element );

}

function animate( animate, duration, utarget, cb ) {

  if( utarget == '' ) {
    utarget = target;
  }

  switch( animate ) {

    case 'slideUp':

       utarget.slideUp( duration, function(){

        if( cb ) {
          if ( $.isFunction( options.cb_notvisible ) ) {
            options.cb_notvisible.call(this);
          }
        }

      } );

    break;

    case 'fadeOut':

       utarget.fadeOut( duration, function(){

        if( cb ) {
          if ( $.isFunction( options.cb_notvisible ) ) {
            options.cb_notvisible.call(this);
          }
        }

      } );

    break;

    case 'slideDown':

       target.slideDown( duration, function(){

       if ( $.isFunction( options.cb_visible ) ) {
         options.cb_visible.call(this);
       }

      } );

    break;

    case 'fadeIn':

       target.fadeIn( duration, function(){

       if ( $.isFunction( options.cb_visible ) ) {
         options.cb_visible.call(this);
       }

      } );

    break;

    case 'toggle':

       target.toggle( duration, function(){

       if ( $.isFunction( options.cb_visible ) ) {
         options.cb_visible.call(this);
       }

      } );

    break;

  }

}


// the app may require to all other visible elements

if( option.animate_before == 'hide' ) {

  animate( option.animate_hide, option.animate_hide_duration, $( option.element + ':visible' ), false );

}

if( target.is(':visible') ) {

  animate( option.animate_hide, option.animate_hide_duration, '', true );

} else {

  animate( option.animate, option.animate_duration, '', true );

}

if( option.close_on_click ) {

$('html').click(function(e){

  if( $( e.target ).closest( option.element ).length === 0 ) {
    animate( option.animate_hide, option.animate_hide_duration, '', true );
  }

});

}

};

// ON SELECT FUNCTION - USED TO CREATE EVENTS ON DEFINED OPTION IS SELECTED

$.fn.on_selected = function( options ) {

var option = $.extend({
  selected: 1
}, options );

var $this = this;

function show() {

if( $this.val() == option.selected || ( option.selected == 'checked' && $this.is(':checked') ) ) {

  if ( $.isFunction( options.cb_true ) ) {
    option.cb_true.call(this, $this);
  }

} else {

  if ( $.isFunction( options.cb_false ) ) {
    option.cb_false.call(this, $this);
  }

}

}

this.on('change keyup',function() {
  show();
});

};

// SEARCH DATA FUNCTION - USED TO SEARCH USERS OR STORES

$.fn.data_search = function( options ) {

var option = $.extend({
  search: '../?ajax=search_store'
}, options );

var $this = this;
var input = $this.find( 'input' ),
a = $this.find( 'a' );
var idinfo = a.nextAll( '#idinfo' );
var cclas = $this.attr('data-set-class') != undefined ? ' ' + $this.attr( 'data-set-class' ) : '';

function search() {

  $this.find( '.search_box' ).html( '<div style="min-height: 40px; margin-top: 17px; text-align: center;"><img src="theme/ajax.gif" alt="Wait ..." /></div>' );

  $.post( option.search, {search: input.val()}, function( data ) {

    var text, ajaxoptions;

    if( data.length === 0 ) {
      text = '<div style="padding: 5px;">Nothing found.</div>';
    } else {

    text = '<ul>';

    $.each(data, function(id, ajax) {

    ajaxoptions = '';
    $.each(ajax, function(avalue) {
      ajaxoptions += 'data-' + avalue + '="' + ajax[avalue] + '"';
    });

    text += '<li data-id="' + id + '"' + ajaxoptions + '>' + ajax.name + '</li>';

    });

    text += '</ul>';

    }

    $this.find( '.search_box' ).html(text);

    /*

    click on li event

    */

    $this.find('li').click(function() {

    // set the new value into input after click
    input.val($(this).attr( 'data-id' ));

    // set the new name and id to the info
    idinfo.text($(this).attr( 'data-name' ) + ' (ID: ' + $(this).attr('data-id') + ')');

    // set arrow orientation down
    a.removeClass( 'uparr' ).addClass( 'downarr' );

    // remove the box
    $this.find( '.search_box' ).remove();

    });

  }, "json" );

}

/*

input on foucus event

*/

input.focus(function(){

  $(this).select();

});

/*

click on arrow event

*/

a.click(function() {

if( $this.find( '.search_box' ).length > 0 ) {

  // set arrow orientation up
  a.removeClass( 'uparr' ).addClass( 'downarr' );

  // remove the box
  $this.find( '.search_box' ).remove();

} else {

  // set arrow orientation down
  a.removeClass( 'downarr' ).addClass( 'uparr' );

  // add the box
  $this.append( '<div class="search_box' + cclas + '"></div>' );

  search();

}

});

/*

input value change event

*/

input.keyup(function() {

if( $(this).val() == '' ) {

  // remove name and id from the info
  idinfo.text('');

  // set arrow orientation down
  a.removeClass( 'uparr' ).addClass( 'downarr' );

  // remove the box
  $this.find( '.search_box' ).remove();
    return false;

}

if( $this.find( '.search_box' ).length > 0 ) {

  search();

} else {

  if( $.isNumeric( $(this).val() ) ) {

  // remove name and id from the info
  idinfo.text('');

  return false;

  }

  // set arrow orientation up
  a.removeClass( 'downarr' ).addClass( 'uparr' );

  // add the box
  $this.append( '<div class="search_box' + cclas + '"></div>' );

  search();

}

});

};

}( jQuery ));