<?php

switch( $_GET['action'] ) {

/** ADD COUNTRY */

case 'country_add':

if( !ab_to( array( 'locations' => 'add' ) ) ) die;

echo '<div class="title">

<h2>' . $LANG['loc_cou_add_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">
<a href="?route=locations.php&amp;action=countries" class="btn">' . $LANG['locations_country_view'] . '</a>
</div>';

if( !empty( $LANG['loc_cou_add_subtitle'] ) ) {
  echo '<span>' . $LANG['loc_cou_add_subtitle'] . '</span>';
}

echo '</div>';

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'locations_csrf' ) ) {

  if( isset( $_POST['name'] ) && isset( $_POST['mapmarker'] ) )
  if( actions::add_country(
  array(
  'name' => $_POST['name'],
  'marker' => $_POST['mapmarker'],
  'publish' => ( isset( $_POST['publish'] ) ? 1 : 0 )
  ) ) )

  echo '<div class="a-success">' . $LANG['msg_added'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

$csrf = $_SESSION['locations_csrf'] = \site\utils::str_random(10);

echo '<div class="form-table">

<form action="#" method="POST" autocomplete="off">

<div class="row"><span>' . $LANG['loc_form_country'] . ':</span><div><input type="text" name="name" value="" required /></div></div>';
if( ( $mapskey = \query\main::get_option( 'google_maps_key' ) ) && !empty( $mapskey ) ) {
  echo '<div class="row"><span>' . $LANG['form_map'] . ':</span><div id="map" style="height: 400px;"></div></div>';
}
echo '<div class="row"><span>' . $LANG['form_publish'] . ':</span><div><input type="checkbox" name="publish" id="publish" checked /> <label for="publish"><span></span> ' . $LANG['msg_publoc'] . '</label></div></div>

<input type="hidden" name="mapmarker" value="39.82,-101.47" />
<input type="hidden" name="csrf" value="' . $csrf . '" />
<button class="btn">' . $LANG['loc_cou_add_button'] . '</button>

</form>

</div>';

if( !empty( $mapskey ) ) {

?>

<script>

var marker, map, deflat, deflng;

deflat = 39.82;
deflng = -101.47;

function initMap() {
  map = new google.maps.Map(document.getElementById('map'), {
    zoom: 6,
    center: {lat: deflat, lng: deflng}
  });

  marker = new google.maps.Marker({
    map: map,
    draggable: true,
    position: {lat: deflat, lng: deflng}
  });
  marker.addListener('dragend', toggleBounce);
}

function toggleBounce(){
  $('input[name="mapmarker"]').val(this.getPosition());
}

</script>

<script async defer src="https://maps.googleapis.com/maps/api/js?key=<?php echo htmlspecialchars( $mapskey ); ?>&signed_in=true&callback=initMap"></script>

<?php

}

break;

/** EDIT COUNTRY */

case 'edit_country':

if( !ab_to( array( 'locations' => 'edit' ) ) ) die;

$csrf = \site\utils::str_random(10);

echo '<div class="title">

<h2>' . $LANG['loc_cou_edit_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">';

if( isset( $_GET['id'] ) && ( $page_exists = \query\locations::country_exists() ) ) {

$info = \query\locations::country_infos();

echo '<div class="options">
<a href="#" class="btn">' . $LANG['options'] . '</a>
<ul>';
if( ab_to( array( 'locations' => 'delete' ) ) ) echo '<li><a href="?route=locations.php&amp;action=countries&amp;type=delete&amp;id=' . $_GET['id'] . '&amp;token=' . $csrf . '" data-delete-msg="' . $LANG['delete_msg'] . '">' . $LANG['delete'] . '</a></li>';
if( $info->visible ) {
  echo '<li><a href="?route=locations.php&amp;action=countries&amp;type=unpublish&amp;id=' . $_GET['id'] . '&amp;token=' . $csrf . '">' . $LANG['unpublish'] . '</a></li>';
} else {
  echo '<li><a href="?route=locations.php&amp;action=countries&amp;type=publish&amp;id=' . $_GET['id'] . '&amp;token=' . $csrf . '">' . $LANG['publish'] . '</a></li>';
}
echo '</ul>
</div>';

}

echo '<a href="?route=locations.php&amp;action=countries" class="btn">' . $LANG['locations_country_view'] . '</a>
</div>';

if( !empty( $LANG['loc_cou_edit_subtitle'] ) ) {
  echo '<span>' . $LANG['loc_cou_edit_subtitle'] . '</span>';
}

echo '</div>';

if( $page_exists ) {

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'locations_csrf' ) ) {

  if( isset( $_POST['name'] ) && isset( $_POST['mapmarker'] ) )
  if( actions::edit_country( $_GET['id'],
  array(
  'name' => $_POST['name'],
  'marker' => $_POST['mapmarker'],
  'publish' => ( isset( $_POST['publish'] ) ? 1 : 0 )
  ) ) ) {

  $info = \query\locations::country_infos( $_GET['id'] );

  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  } else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

$_SESSION['locations_csrf'] = $csrf;

echo '<div class="form-table">

<form action="#" method="POST">

<div class="row"><span>' . $LANG['loc_form_country'] . ':</span><div><input type="text" name="name" value="' . $info->name . '" required /></div></div>';
if( ( $mapskey = \query\main::get_option( 'google_maps_key' ) ) && !empty( $mapskey ) ) {
  echo '<div class="row"><span>' . $LANG['form_map'] . ':</span><div id="map" style="height: 400px;"></div></div>';
}
echo '<div class="row"><span>' . $LANG['form_publish'] . ':</span><div><input type="checkbox" name="publish" id="publish"' . ( $info->visible ? ' checked' : '' ) . ' /> <label for="publish"><span></span> ' . $LANG['msg_publoc'] . '</label></div></div>

<input type="hidden" name="mapmarker" value="' . $info->lat . ',' . $info->lng . '" data-lat="' . $info->lat . '" data-lng="' . $info->lng . '" />
<input type="hidden" name="csrf" value="' . $csrf . '" />
<button class="btn">' . $LANG['loc_cou_edit_button'] . '</button>

</form>

</div>';

echo '<div class="title" style="margin-top: 40px;">

<h2>' . $LANG['loc_cou_infos_title'] . '</h2>

</div>';

$lastupdate_by = \query\main::user_infos( $info->lastupdate_by );
$added_by = \query\main::user_infos( $info->user );

echo '<div class="infos-table" style="padding-bottom: 20px;">

<div class="row"><span>ID:</span> <div>' . $info->ID . '</div></div>
<div class="row"><span>' . $LANG['last_update_by'] . ':</span> <div>' . ( empty( $lastupdate_by->name ) ? '-' : ( ab_to( array( 'users' => 'edit' ) ) ? '<a href="?route=users.php&amp;action=edit&amp;id=' . $lastupdate_by->ID . '">' . $lastupdate_by->name . '</a>' : $lastupdate_by->name ) ) . '</div></div>
<div class="row"><span>' . $LANG['last_update_on'] . ':</span> <div>' . $info->last_update . '</div></div>
<div class="row"><span>' . $LANG['added_by'] . ':</span> <div>' . ( empty( $added_by->name ) ? '-' : ( ab_to( array( 'users' => 'edit' ) ) ? '<a href="?route=users.php&amp;action=edit&amp;id=' . $added_by->ID . '">' . $added_by->name . '</a>' : $added_by->name ) ) . '</div></div>
<div class="row"><span>' . $LANG['added_on'] . ':</span> <div>' . $info->date . '</div></div>

</div>';

if( !empty( $mapskey ) ) {

?>

<script>

var marker, map, deflat, deflng;

deflat = parseFloat( $('[name="mapmarker"]').attr('data-lat') );
deflng = parseFloat( $('[name="mapmarker"]').attr('data-lng') );

function initMap() {
  map = new google.maps.Map(document.getElementById('map'), {
    zoom: 6,
    center: {lat: deflat, lng: deflng}
  });

  marker = new google.maps.Marker({
    map: map,
    draggable: true,
    position: {lat: deflat, lng: deflng}
  });
  marker.addListener('dragend', toggleBounce);
}

function toggleBounce(){
  $('input[name="mapmarker"]').val(this.getPosition());
}

</script>

<script async defer src="https://maps.googleapis.com/maps/api/js?key=<?php echo htmlspecialchars( $mapskey ); ?>&signed_in=true&callback=initMap"></script>

<?php

}

} else echo '<div class="a-error">' . $LANG['invalid_id'] . '</div>';

break;

/** LIST OF COUNTRIES */

case 'countries':

if( !ab_to( array( 'locations' => 'view' ) ) ) die;

echo '<div class="title">

<h2>' . $LANG['loc_cou_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">';
if( ab_to( array( 'locations' => 'add' ) ) ) echo '<a href="?route=locations.php&amp;action=country_add" class="btn">' . $LANG['locations_country_add'] . '</a>';
echo '</div>';

if( !empty( $LANG['loc_cou_subtitle'] ) ) {
  echo '<span>' . $LANG['loc_cou_subtitle'] . '</span>';
}

echo '</div>';

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'locations_csrf' ) ) {

if( isset( $_POST['delete'] ) ) {

  if( isset( $_POST['id'] ) )
  if( actions::delete_country( array_keys( $_POST['id'] ) ) )
  echo '<div class="a-success">' . $LANG['msg_deleted'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

} else if( isset( $_POST['set_action'] ) ) {

  if( isset( $_POST['id'] ) && isset( $_POST['action'] ) )
  if( actions::action_country( $_POST['action'], array_keys( $_POST['id'] ) ) )
  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

} else if( isset( $_GET['type'] ) && isset( $_GET['token'] ) && check_csrf( $_GET['token'], 'locations_csrf' ) ) {

if( $_GET['type'] == 'delete' ) {

  if( isset( $_GET['id'] ) )
  if( actions::delete_country( $_GET['id'] ) )
  echo '<div class="a-success">' . $LANG['msg_deleted'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

} else if( $_GET['type'] == 'publish' || $_GET['type'] == 'unpublish' ) {

  if( isset( $_GET['id'] ) )
  if( actions::action_country( $_GET['type'], $_GET['id'] ) )
  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

}

$csrf = $_SESSION['locations_csrf'] = \site\utils::str_random(10);

echo '<div class="page-toolbar">

<form action="#" method="GET" autocomplete="off">
<input type="hidden" name="route" value="locations.php" />
<input type="hidden" name="action" value="countries" />

' . $LANG['order_by'] . ':
<select name="orderby">';
foreach( array( 'date' => $LANG['order_date'], 'date desc' => $LANG['order_date_desc'], 'update' => $LANG['order_last_update'], 'update desc' => $LANG['order_last_update_desc'], 'name' => $LANG['order_name'], 'name desc' => $LANG['order_name_desc'] ) as $k => $v )echo '<option value="' . $k . '"' . (isset( $_GET['orderby'] ) && urldecode( $_GET['orderby'] ) == $k || !isset( $_GET['orderby'] ) && $k == 'name' ? ' selected' : '') . '>' . $v . '</option>';
echo '</select>';

if( isset( $_GET['search'] ) ) {
echo '<input type="hidden" name="search" value="' . htmlspecialchars( $_GET['search'] ) . '" />';
}

echo ' <button class="btn">' . $LANG['view'] . '</button>

</form>

<form action="#" method="GET" autocomplete="off">
<input type="hidden" name="route" value="locations.php" />
<input type="hidden" name="action" value="countries" />';

if( isset( $_GET['orderby'] ) ) {
echo '<input type="hidden" name="orderby" value="' . htmlspecialchars( $_GET['orderby'] ) . '" />';
}

echo '<input type="search" name="search" value="' . (isset( $_GET['search'] ) ? htmlspecialchars( $_GET['search'] ) : '') . '" placeholder="' . $LANG['loc_cou_search_input'] . '" />
<button class="btn">' . $LANG['search'] . '</button>
</form>

</div>';

$p = \query\locations::have_countries( $options = array( 'per_page' => 10, 'show' => 'all', 'search' => (isset( $_GET['search'] ) ? urldecode( $_GET['search'] ) : '') ) );

echo '<div class="results">' . ( (int) $p['results'] === 1 ? sprintf( $LANG['result'], $p['results'] ) : sprintf( $LANG['results'], $p['results'] ) );
if( !empty( $_GET['search'] ) ) echo ' / <a href="?route=locations.php&amp;action=countries">' . $LANG['reset_view'] . '</a>';
echo '</div>';

if( $p['results'] ) {

echo '<form action="?route=locations.php&amp;action=countries" method="POST">

<ul class="elements-list">

<li class="head"><input type="checkbox" id="selectall" data-checkall /> <label for="selectall"><span></span></label> ' . $LANG['name'] . '</li>';

$ab_edt  = ab_to( array( 'locations' => 'edit' ) );
$ab_del  = ab_to( array( 'locations' => 'delete' ) );

if( $ab_edt || $ab_del ) {

echo '<div class="bulk_options">';

  if( $ab_del ) echo '<button class="btn" name="delete" data-delete-msg="' . $LANG['delete_msg'] . '">' . $LANG['delete_all'] . '</button> ';

  if( $ab_edt ) {
    echo $LANG['action'] . ':
    <select name="action">';
    foreach( array( 'publish' => $LANG['publish'], 'unpublish' => $LANG['unpublish'] ) as $k => $v )echo '<option value="' . $k . '">' . $v . '</option>';
    echo '</select>
    <button class="btn" name="set_action">' . $LANG['set_all'] . '</button>';
  }

echo '</div>';

}

foreach( \query\locations::while_countries( array_merge( array( 'orderby' => (isset( $_GET['orderby'] ) ? urldecode( $_GET['orderby'] ) : 'date desc') ), $options ) ) as $item ) {

  echo '<li>
  <div>

  <input type="checkbox" name="id[' . $item->ID . ']" id="id[' . $item->ID . ']" /> <label for="id[' . $item->ID . ']"><span></span></label>
  <div class="info-div"><h2>' . ( $item->visible ? '<span class="msg-success">' . $LANG['published'] . '</span> ' : '<span class="msg-error">' . $LANG['notpublished'] . '</span> ' ) . $item->name . '</h2></div>

  </div>

  <div style="clear:both;"></div>

  <div class="options">
  <a href="?route=locations.php&amp;action=states&amp;country=' . $item->ID . '">' . $LANG['locations_state_view'] . '</a>';
  if( $ab_edt ) {
  echo '<a href="?route=locations.php&amp;action=edit_country&amp;id=' . $item->ID . '">' . $LANG['edit'] . '</a>';
  echo '<a href="' . \site\utils::update_uri( '', array( 'type' => ( !$item->visible ? 'publish' : 'unpublish' ), 'id' => $item->ID, 'token' => $csrf ) ) . '">' . ( !$item->visible ? $LANG['publish'] : $LANG['unpublish'] ) . '</a>';
  }
  if( $ab_del ) echo '<a href="' . \site\utils::update_uri( '', array( 'type' => 'delete', 'id' => $item->ID, 'token' => $csrf ) ) . '" data-delete-msg="' . $LANG['delete_msg'] . '">' . $LANG['delete'] . '</a>';

  echo '</div>
  </li>';

}

echo '</ul>

<input type="hidden" name="csrf" value="' . $csrf . '" />

</form>';

if( isset( $p['prev_page'] ) || isset( $p['next_page'] ) ) {
  echo '<div class="pagination">';

  if( isset( $p['prev_page'] ) ) echo '<a href="' . $p['prev_page'] . '" class="btn">' . $LANG['prev_page'] . '</a>';
  if( isset( $p['next_page'] ) ) echo '<a href="' . $p['next_page'] . '" class="btn">' . $LANG['next_page'] . '</a>';

  if( $p['pages'] > 1 ) {
  echo '<div class="pag_goto">' . sprintf( $LANG['pageofpages'], $page = $p['page'], $pages = $p['pages'] ) . '
  <form action="#" method="GET">';
  foreach( $_GET as $gk => $gv ) if( $gk !== 'page' ) echo '<input type="hidden" name="' . htmlspecialchars( $gk ) . '" value="' . htmlspecialchars( $gv ) . '" />';
  echo '<input type="number" name="page" min="1" max="' . $pages . '" size="5" value="' . $page . '" />
  <button class="btn">' . $LANG['go'] . '</button>
  </form>
  </div>';
  }

  echo '</div>';
}

} else {

  echo '<div class="a-alert">' . $LANG['no_countries_yet'] . '</div>';

}

break;

/** ADD STATE */

case 'state_add':

if( !ab_to( array( 'locations' => 'add' ) ) ) die;

echo '<div class="title">

<h2>' . $LANG['loc_state_add_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">
<a href="?route=locations.php&amp;action=states" class="btn">' . $LANG['locations_state_view'] . '</a>
</div>';

if( !empty( $LANG['loc_state_add_subtitle'] ) ) {
  echo '<span>' . $LANG['loc_state_add_subtitle'] . '</span>';
}

echo '</div>';

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'locations_csrf' ) ) {

  if( isset( $_POST['name'] ) && isset( $_POST['country'] ) && isset( $_POST['mapmarker'] ) )
  if( actions::add_state( array(
  'name' => $_POST['name'],
  'country' => $_POST['country'],
  'marker' => $_POST['mapmarker'],
  'publish' => ( isset( $_POST['publish'] ) ? 1 : 0 )
  ) ) )

  echo '<div class="a-success">' . $LANG['msg_added'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

$csrf = $_SESSION['locations_csrf'] = \site\utils::str_random(10);

echo '<div class="form-table">

<form action="#" method="POST" autocomplete="off">

<div class="row"><span>' . $LANG['loc_form_state'] . ':</span><div><input type="text" name="name" value="" required /></div></div>
<div class="row"><span>' . $LANG['loc_form_country'] . ':</span><div><select name="country">';
foreach( \query\locations::while_countries( array( 'max' => 0, 'show' => 'all' ) ) as $k => $v ) {
  echo '<option value="' . $v->ID . '" data-lat="' . $v->lat . '" data-lng="' . $v->lng . '"' . ( $k == 0 ? ' selected' : '' ) . '>' . $v->name . '</option>';
}
echo '</select></div></div>';
if( ( $mapskey = \query\main::get_option( 'google_maps_key' ) ) && !empty( $mapskey ) ) {
  echo '<div class="row"><span>' . $LANG['form_map'] . ':</span><div id="map" style="height: 400px;"></div></div>';
}
echo '<div class="row"><span>' . $LANG['form_publish'] . ':</span><div><input type="checkbox" name="publish" id="publish" checked /> <label for="publish"><span></span> ' . $LANG['msg_publoc'] . '</label></div></div>

<input type="hidden" name="mapmarker" value="39.82,-101.47" />
<input type="hidden" name="csrf" value="' . $csrf . '" />
<button class="btn">' . $LANG['loc_state_add_button'] . '</button>

</form>

</div>';

if( !empty( $mapskey ) ) {

?>

<script>

var marker, map, newlatlng, deflat, deflng;

deflat = 39.82;
deflng = -101.47;

function initMap() {
  map = new google.maps.Map(document.getElementById('map'), {
    zoom: 7,
    center: {lat: deflat, lng: deflng}
  });

  marker = new google.maps.Marker({
    map: map,
    draggable: true,
    position: {lat: deflat, lng: deflng}
  });
  marker.addListener('dragend', toggleBounce);
}

function toggleBounce(){
  $('input[name="mapmarker"]').val(this.getPosition());
}

function updateMarker(){
  var lat = $('select[name="country"]').find('option:selected').attr('data-lat');
  var lng = $('select[name="country"]').find('option:selected').attr('data-lng');
  newlatlng = new google.maps.LatLng(lat,lng);
  marker.setPosition(newlatlng);
  map.setCenter(newlatlng);
}

$( document ).ready(function() {

$(document).on('change', 'select[name="country"]', function(){
  updateMarker();
});

});

</script>

<script async defer src="https://maps.googleapis.com/maps/api/js?key=<?php echo htmlspecialchars( $mapskey ); ?>&signed_in=true&callback=initMap"></script>

<?php

}

break;

/** EDIT STATE */

case 'edit_state':

if( !ab_to( array( 'locations' => 'edit' ) ) ) die;

$csrf = \site\utils::str_random(10);

echo '<div class="title">

<h2>' . $LANG['loc_state_edit_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">';

if( isset( $_GET['id'] ) && ( $page_exists = \query\locations::state_exists() ) ) {

$info = \query\locations::state_infos();

echo '<div class="options">
<a href="#" class="btn">' . $LANG['options'] . '</a>
<ul>';
if( ab_to( array( 'locations' => 'delete' ) ) ) echo '<li><a href="?route=locations.php&amp;action=states&amp;type=delete&amp;id=' . $_GET['id'] . '&amp;token=' . $csrf . '" data-delete-msg="' . $LANG['delete_msg'] . '">' . $LANG['delete'] . '</a></li>';
if( $info->visible ) {
  echo '<li><a href="?route=locations.php&amp;action=states&amp;type=unpublish&amp;id=' . $_GET['id'] . '&amp;token=' . $csrf . '">' . $LANG['unpublish'] . '</a></li>';
} else {
  echo '<li><a href="?route=locations.php&amp;action=states&amp;type=publish&amp;id=' . $_GET['id'] . '&amp;token=' . $csrf . '">' . $LANG['publish'] . '</a></li>';
}
echo '</ul>
</div>';

}

echo '<a href="?route=locations.php&amp;action=states" class="btn">' . $LANG['locations_state_view'] . '</a>
</div>';

if( !empty( $LANG['loc_state_edit_subtitle'] ) ) {
  echo '<span>' . $LANG['loc_state_edit_subtitle'] . '</span>';
}

echo '</div>';

if( $page_exists ) {

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'locations_csrf' ) ) {

  if( isset( $_POST['name'] ) && isset( $_POST['country'] ) && isset( $_POST['mapmarker'] ) )
  if( actions::edit_state( $_GET['id'],
  array(
  'name' => $_POST['name'],
  'country' => $_POST['country'],
  'marker' => $_POST['mapmarker'],
  'publish' => ( isset( $_POST['publish'] ) ? 1 : 0 )
  ) ) ) {

  $info = \query\locations::state_infos( $_GET['id'] );

  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  } else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

$_SESSION['locations_csrf'] = $csrf;

echo '<div class="form-table">

<form action="#" method="POST">

<div class="row"><span>' . $LANG['loc_form_state'] . ':</span><div><input type="text" name="name" value="' . $info->name . '" required /></div></div>
<div class="row"><span>' . $LANG['loc_form_country'] . ':</span><div><select name="country">';
foreach( \query\locations::while_countries( array( 'max' => 0, 'show' => 'all' ) ) as $v ) {
  echo '<option value="' . $v->ID . '" data-lat="' . $v->lat . '" data-lng="' . $v->lng . '"' . ( $info->country == $v->ID ? ' selected' : '' ) . '>' . $v->name . '</option>';
}
echo '</select></div></div>';
if( ( $mapskey = \query\main::get_option( 'google_maps_key' ) ) && !empty( $mapskey ) ) {
  echo '<div class="row"><span>' . $LANG['form_map'] . ':</span><div id="map" style="height: 400px;"></div></div>';
}
echo '<div class="row"><span>' . $LANG['form_publish'] . ':</span><div><input type="checkbox" name="publish" id="publish"' . ( $info->visible ? ' checked' : '' ) . ' /> <label for="publish"><span></span> ' . $LANG['msg_publoc'] . '</label></div></div>

<input type="hidden" name="mapmarker" value="' . $info->lat . ',' . $info->lng . '" data-lat="' . $info->lat . '" data-lng="' . $info->lng . '" />
<input type="hidden" name="csrf" value="' . $csrf . '" />
<button class="btn">' . $LANG['loc_state_edit_button'] . '</button>

</form>

</div>';

echo '<div class="title" style="margin-top: 40px;">

<h2>' . $LANG['loc_state_infos_title'] . '</h2>

</div>';

$lastupdate_by = \query\main::user_infos( $info->lastupdate_by );
$added_by = \query\main::user_infos( $info->user );

echo '<div class="infos-table" style="padding-bottom: 20px;">

<div class="row"><span>ID:</span> <div>' . $info->ID . '</div></div>
<div class="row"><span>' . $LANG['last_update_by'] . ':</span> <div>' . ( empty( $lastupdate_by->name ) ? '-' : ( ab_to( array( 'users' => 'edit' ) ) ? '<a href="?route=users.php&amp;action=edit&amp;id=' . $lastupdate_by->ID . '">' . $lastupdate_by->name . '</a>' : $lastupdate_by->name ) ) . '</div></div>
<div class="row"><span>' . $LANG['last_update_on'] . ':</span> <div>' . $info->last_update . '</div></div>
<div class="row"><span>' . $LANG['added_by'] . ':</span> <div>' . ( empty( $added_by->name ) ? '-' : ( ab_to( array( 'users' => 'edit' ) ) ? '<a href="?route=users.php&amp;action=edit&amp;id=' . $added_by->ID . '">' . $added_by->name . '</a>' : $added_by->name ) ) . '</div></div>
<div class="row"><span>' . $LANG['added_on'] . ':</span> <div>' . $info->date . '</div></div>

</div>';

if( !empty( $mapskey ) ) {

?>

<script>

var marker, map, newlatlng, deflat, deflng;

deflat = parseFloat( $('[name="mapmarker"]').attr('data-lat') );
deflng = parseFloat( $('[name="mapmarker"]').attr('data-lng') );

function initMap() {
  map = new google.maps.Map(document.getElementById('map'), {
    zoom: 6,
    center: {lat: deflat, lng: deflng}
  });

  marker = new google.maps.Marker({
    map: map,
    draggable: true,
    position: {lat: deflat, lng: deflng}
  });
  marker.addListener('dragend', toggleBounce);
}

function toggleBounce(){
  $('input[name="mapmarker"]').val(this.getPosition());
}

function updateMarker(){
  var lat = $('select[name="country"]').find('option:selected').attr('data-lat');
  var lng = $('select[name="country"]').find('option:selected').attr('data-lng');
  newlatlng = new google.maps.LatLng(lat,lng);
  marker.setPosition(newlatlng);
  map.setCenter(newlatlng);
}

$( document ).ready(function() {

$(document).on('change', 'select[name="country"]', function(){
  updateMarker();
});

});

</script>

<script async defer src="https://maps.googleapis.com/maps/api/js?key=<?php echo htmlspecialchars( $mapskey ); ?>&signed_in=true&callback=initMap"></script>

<?php

}

} else echo '<div class="a-error">' . $LANG['invalid_id'] . '</div>';

break;

/** LIST OF STATES */

case 'states':

if( !ab_to( array( 'locations' => 'view' ) ) ) die;

echo '<div class="title">

<h2>' . $LANG['loc_state_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">';
if( ab_to( array( 'locations' => 'add' ) ) ) echo '<a href="?route=locations.php&amp;action=state_add" class="btn">' . $LANG['locations_state_add'] . '</a>';
echo '</div>';

if( !empty( $LANG['loc_state_subtitle'] ) ) {
  echo '<span>' . $LANG['loc_state_subtitle'] . '</span>';
}

echo '</div>';

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'locations_csrf' ) ) {

if( isset( $_POST['delete'] ) ) {

  if( isset( $_POST['id'] ) )
  if( actions::delete_state( array_keys( $_POST['id'] ) ) )
  echo '<div class="a-success">' . $LANG['msg_deleted'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

} else if( isset( $_POST['set_action'] ) ) {

  if( isset( $_POST['id'] ) && isset( $_POST['action'] ) )
  if( actions::action_state( $_POST['action'], array_keys( $_POST['id'] ) ) )
  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

} else if( isset( $_GET['type'] ) && isset( $_GET['token'] ) && check_csrf( $_GET['token'], 'locations_csrf' ) ) {

if( $_GET['type'] == 'delete' ) {

  if( isset( $_GET['id'] ) )
  if( actions::delete_state( $_GET['id'] ) )
  echo '<div class="a-success">' . $LANG['msg_deleted'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

} else if( $_GET['type'] == 'publish' || $_GET['type'] == 'unpublish' ) {

  if( isset( $_GET['id'] ) )
  if( actions::action_state( $_GET['type'], $_GET['id'] ) )
  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

}

$csrf = $_SESSION['locations_csrf'] = \site\utils::str_random(10);

echo '<div class="page-toolbar">

<form action="#" method="GET" autocomplete="off">
<input type="hidden" name="route" value="locations.php" />
<input type="hidden" name="action" value="states" />

' . $LANG['order_by'] . ':
<select name="orderby">';
foreach( array( 'date' => $LANG['order_date'], 'date desc' => $LANG['order_date_desc'], 'update' => $LANG['order_last_update'], 'update desc' => $LANG['order_last_update_desc'], 'name' => $LANG['order_name'], 'name desc' => $LANG['order_name_desc'] ) as $k => $v )echo '<option value="' . $k . '"' . (isset( $_GET['orderby'] ) && urldecode( $_GET['orderby'] ) == $k || !isset( $_GET['orderby'] ) && $k == 'name' ? ' selected' : '') . '>' . $v . '</option>';
echo '</select>';

if( isset( $_GET['search'] ) ) {
echo '<input type="hidden" name="search" value="' . htmlspecialchars( $_GET['search'] ) . '" />';
}

echo ' <button class="btn">' . $LANG['view'] . '</button>

</form>

<form action="#" method="GET" autocomplete="off">
<input type="hidden" name="route" value="locations.php" />
<input type="hidden" name="action" value="states" />';

if( isset( $_GET['orderby'] ) ) {
echo '<input type="hidden" name="orderby" value="' . htmlspecialchars( $_GET['orderby'] ) . '" />';
}

echo '<input type="search" name="search" value="' . (isset( $_GET['search'] ) ? htmlspecialchars( $_GET['search'] ) : '') . '" placeholder="' . $LANG['loc_state_search_input'] . '" />
<button class="btn">' . $LANG['search'] . '</button>
</form>

</div>';

$p = \query\locations::have_states( $options = array( 'per_page' => 10, 'country' => (isset( $_GET['country'] ) ? $_GET['country'] : ''), 'show' => 'all', 'search' => (isset( $_GET['search'] ) ? urldecode( $_GET['search'] ) : '') ) );

echo '<div class="results">' . ( (int) $p['results'] === 1 ? sprintf( $LANG['result'], $p['results'] ) : sprintf( $LANG['results'], $p['results'] ) );
if( !empty( $_GET['search'] ) ) echo ' / <a href="?route=locations.php&amp;action=states">' . $LANG['reset_view'] . '</a>';
echo '</div>';

if( $p['results'] ) {

echo '<form action="?route=locations.php&amp;action=states" method="POST">

<ul class="elements-list">

<li class="head"><input type="checkbox" id="selectall" data-checkall /> <label for="selectall"><span></span></label> ' . $LANG['name'] . '</li>';

$ab_edt  = ab_to( array( 'locations' => 'edit' ) );
$ab_del  = ab_to( array( 'locations' => 'delete' ) );

if( $ab_edt || $ab_del ) {

echo '<div class="bulk_options">';

  if( $ab_del ) echo '<button class="btn" name="delete" data-delete-msg="' . $LANG['delete_msg'] . '">' . $LANG['delete_all'] . '</button> ';

  if( $ab_edt ) {
    echo $LANG['action'] . ':
    <select name="action">';
    foreach( array( 'publish' => $LANG['publish'], 'unpublish' => $LANG['unpublish'] ) as $k => $v )echo '<option value="' . $k . '">' . $v . '</option>';
    echo '</select>
    <button class="btn" name="set_action">' . $LANG['set_all'] . '</button>';
  }

echo '</div>';

}

foreach( \query\locations::while_states( array_merge( array( 'orderby' => (isset( $_GET['orderby'] ) ? urldecode( $_GET['orderby'] ) : 'date desc') ), $options ) ) as $item ) {
  echo '<li>
  <div>

  <input type="checkbox" name="id[' . $item->ID . ']" id="id[' . $item->ID . ']" /> <label for="id[' . $item->ID . ']"><span></span></label>
  <div class="info-div"><h2>' . ( $item->visible ? '<span class="msg-success">' . $LANG['published'] . '</span> ' : '<span class="msg-error">' . $LANG['notpublished'] . '</span> ' ) . $item->name . '</h2></div>

  </div>

  <div style="clear:both;"></div>

  <div class="options">
  <a href="?route=locations.php&amp;action=cities&amp;state=' . $item->ID . '">' . $LANG['locations_city_view'] . '</a>';
  if( $ab_edt ) {
  echo '<a href="?route=locations.php&amp;action=edit_state&amp;id=' . $item->ID . '">' . $LANG['edit'] . '</a>';
  echo '<a href="' . \site\utils::update_uri( '', array( 'type' => ( !$item->visible ? 'publish' : 'unpublish' ), 'id' => $item->ID, 'token' => $csrf ) ) . '">' . ( !$item->visible ? $LANG['publish'] : $LANG['unpublish'] ) . '</a>';
  }
  if( $ab_del ) echo '<a href="' . \site\utils::update_uri( '', array( 'type' => 'delete', 'id' => $item->ID, 'token' => $csrf ) ) . '" data-delete-msg="' . $LANG['delete_msg'] . '">' . $LANG['delete'] . '</a>';

  echo '</div>
  </li>';

}

echo '</ul>

<input type="hidden" name="csrf" value="' . $csrf . '" />

</form>';

if( isset( $p['prev_page'] ) || isset( $p['next_page'] ) ) {
  echo '<div class="pagination">';

  if( isset( $p['prev_page'] ) ) echo '<a href="' . $p['prev_page'] . '" class="btn">' . $LANG['prev_page'] . '</a>';
  if( isset( $p['next_page'] ) ) echo '<a href="' . $p['next_page'] . '" class="btn">' . $LANG['next_page'] . '</a>';

  if( $p['pages'] > 1 ) {
  echo '<div class="pag_goto">' . sprintf( $LANG['pageofpages'], $page = $p['page'], $pages = $p['pages'] ) . '
  <form action="#" method="GET">';
  foreach( $_GET as $gk => $gv ) if( $gk !== 'page' ) echo '<input type="hidden" name="' . htmlspecialchars( $gk ) . '" value="' . htmlspecialchars( $gv ) . '" />';
  echo '<input type="number" name="page" min="1" max="' . $pages . '" size="5" value="' . $page . '" />
  <button class="btn">' . $LANG['go'] . '</button>
  </form>
  </div>';
  }

  echo '</div>';
}

} else echo '<div class="a-alert">' . $LANG['no_states_yet'] . '</div>';

break;

/** ADD CITY */

case 'city_add':

if( !ab_to( array( 'locations' => 'add' ) ) ) die;

echo '<div class="title">

<h2>' . $LANG['loc_city_add_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">
<a href="?route=locations.php&amp;action=cities" class="btn">' . $LANG['locations_city_view'] . '</a>
</div>';

if( !empty( $LANG['loc_city_add_subtitle'] ) ) {
  echo '<span>' . $LANG['loc_city_add_subtitle'] . '</span>';
}

echo '</div>';

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'locations_csrf' ) ) {

  if( isset( $_POST['name'] ) && isset( $_POST['country'] ) && isset( $_POST['state'] ) && isset( $_POST['mapmarker'] ) )
  if( actions::add_city(
  array(
  'name' => $_POST['name'],
  'country' => $_POST['country'],
  'state' => $_POST['state'],
  'marker' => $_POST['mapmarker'],
  'publish' => ( isset( $_POST['publish'] ) ? 1 : 0 )
  ) ) )

  echo '<div class="a-success">' . $LANG['msg_added'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

$csrf = $_SESSION['locations_csrf'] = \site\utils::str_random(10);

echo '<div class="form-table">

<form action="#" method="POST" autocomplete="off">

<div class="row"><span>' . $LANG['loc_form_city'] . ':</span><div><input type="text" name="name" value="" required /></div></div>
<div class="row"><span>' . $LANG['loc_form_country'] . ':</span><div><select name="country">';
$country = 0;
foreach( \query\locations::while_countries( array( 'max' => 0, 'show' => 'all' ) ) as $k => $v ) {
  if( $k === 0 ) {
    $country = $v->ID;
  }
  echo '<option value="' . $v->ID . '">' . $v->name . '</option>';
}
echo '</select></div></div>
<div class="row"><span>' . $LANG['loc_form_state'] . ':</span><div><select name="state">';
foreach( \query\locations::while_states( array( 'max' => 0, 'country' => $country, 'show' => 'all' ) ) as $k => $v ) {
  echo '<option value="' . $v->ID . '" data-lat="' . $v->lat . '" data-lng="' . $v->lng . '"' . ( $k == 0 ? ' selected' : '' ) . '>' . $v->name . '</option>';
}
echo '</select></div></div>';
if( ( $mapskey = \query\main::get_option( 'google_maps_key' ) ) && !empty( $mapskey ) ) {
  echo '<div class="row"><span>' . $LANG['form_map'] . ':</span><div id="map" style="height: 400px;"></div></div>';
}
echo '<div class="row"><span>' . $LANG['form_publish'] . ':</span><div><input type="checkbox" name="publish" id="publish" checked /> <label for="publish"><span></span> ' . $LANG['msg_publoc'] . '</label></div></div>

<input type="hidden" name="mapmarker" value="39.82,-101.47" />
<input type="hidden" name="csrf" value="' . $csrf . '" />
<button class="btn">' . $LANG['loc_city_add_button'] . '</button>

</form>

</div>';

if( !empty( $mapskey ) ) {

?>

<script>

var marker, map, newlatlng, deflat, deflng;

deflat = 39.82;
deflng = -101.47;

function initMap() {
  map = new google.maps.Map(document.getElementById('map'), {
    zoom: 8,
    center: {lat: deflat, lng: deflng}
  });

  marker = new google.maps.Marker({
    map: map,
    draggable: true,
    position: {lat: deflat, lng: deflng}
  });
  marker.addListener('dragend', toggleBounce);
}

function toggleBounce(){
  $('input[name="mapmarker"]').val(marker.getPosition());
}

function updateMarker(){
  var lat = $('select[name="state"]').find('option:selected').attr('data-lat');
  var lng = $('select[name="state"]').find('option:selected').attr('data-lng');
  newlatlng = new google.maps.LatLng(lat,lng);
  marker.setPosition(newlatlng);
  map.setCenter(newlatlng);
}

</script>

<script async defer src="https://maps.googleapis.com/maps/api/js?key=<?php echo htmlspecialchars( $mapskey ); ?>&signed_in=true&callback=initMap"></script>

<?php } ?>


<script>

$( document ).ready(function() {

$( 'select[name="country"]' ).search_store_location( {}, "country", function(){
  updateMarker();
} );

$(document).on('change', 'select[name="state"]', function(){
  updateMarker();
});

});

</script>

<script src="js/search_location.js"></script>

<?php

break;

/** EDIT CITY */

case 'edit_city':

if( !ab_to( array( 'locations' => 'edit' ) ) ) die;

$csrf = \site\utils::str_random(10);

echo '<div class="title">

<h2>' . $LANG['loc_city_edit_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">';

if( isset( $_GET['id'] ) && ( $page_exists = \query\locations::city_exists() ) ) {

$info = \query\locations::city_infos();

echo '<div class="options">
<a href="#" class="btn">' . $LANG['options'] . '</a>
<ul>';
if( ab_to( array( 'locations' => 'delete' ) ) ) echo '<li><a href="?route=locations.php&amp;action=cities&amp;type=delete&amp;id=' . $_GET['id'] . '&amp;token=' . $csrf . '" data-delete-msg="' . $LANG['delete_msg'] . '">' . $LANG['delete'] . '</a></li>';
if( $info->visible ) {
  echo '<li><a href="?route=locations.php&amp;action=cities&amp;type=unpublish&amp;id=' . $_GET['id'] . '&amp;token=' . $csrf . '">' . $LANG['unpublish'] . '</a></li>';
} else {
  echo '<li><a href="?route=locations.php&amp;action=cities&amp;type=publish&amp;id=' . $_GET['id'] . '&amp;token=' . $csrf . '">' . $LANG['publish'] . '</a></li>';
}
echo '</ul>
</div>';

}

echo '<a href="?route=locations.php&amp;action=cities" class="btn">' . $LANG['locations_city_view'] . '</a>
</div>';

if( !empty( $LANG['loc_city_edit_subtitle'] ) ) {
  echo '<span>' . $LANG['loc_city_edit_subtitle'] . '</span>';
}

echo '</div>';

if( $page_exists ) {

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'locations_csrf' ) ) {

  if( isset( $_POST['name'] ) && isset( $_POST['country'] ) && isset( $_POST['state'] ) && isset( $_POST['mapmarker'] ) )
  if( actions::edit_city( $_GET['id'],
  array(
  'name' => $_POST['name'],
  'country' => $_POST['country'],
  'state' => $_POST['state'],
  'marker' => $_POST['mapmarker'],
  'publish' => ( isset( $_POST['publish'] ) ? 1 : 0 )
  ) ) ) {

  $info = \query\locations::city_infos( $_GET['id'] );

  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  } else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

$_SESSION['locations_csrf'] = $csrf;

echo '<div class="form-table">

<form action="#" method="POST">

<div class="row"><span>' . $LANG['loc_form_city'] . ':</span><div><input type="text" name="name" value="' . $info->name . '" required /></div></div>
<div class="row"><span>' . $LANG['loc_form_country'] . ':</span><div><select name="country">';
foreach( \query\locations::while_countries( array( 'max' => 0, 'show' => 'all' ) ) as $v ) {
  echo '<option value="' . $v->ID . '"' . ( $info->country == $v->ID ? ' selected' : '' ) . '>' . $v->name . '</option>';
}
echo '</select></div></div>
<div class="row"><span>' . $LANG['loc_form_state'] . ':</span><div><select name="state">';
foreach( \query\locations::while_states( array( 'max' => 0, 'country' => $info->country, 'show' => 'all' ) ) as $v ) {
  echo '<option value="' . $v->ID . '" data-lat="' . $v->lat . '" data-lng="' . $v->lng . '"' . ( $info->state == $v->ID ? ' selected' : '' ) . '>' . $v->name . '</option>';
}
echo '</select></div></div>';
if( ( $mapskey = \query\main::get_option( 'google_maps_key' ) ) && !empty( $mapskey ) ) {
  echo '<div class="row"><span>' . $LANG['form_map'] . ':</span><div id="map" style="height: 400px;"></div></div>';
}
echo '<div class="row"><span>' . $LANG['form_publish'] . ':</span><div><input type="checkbox" name="publish" id="publish"' . ( $info->visible ? ' checked' : '' ) . ' /> <label for="publish"><span></span> ' . $LANG['msg_publoc'] . '</label></div></div>

<input type="hidden" name="mapmarker" value="' . $info->lat . ',' . $info->lng . '" data-lat="' . $info->lat . '" data-lng="' . $info->lng . '" />
<input type="hidden" name="csrf" value="' . $csrf . '" />
<button class="btn">' . $LANG['loc_city_edit_button'] . '</button>

</form>

</div>';

echo '<div class="title" style="margin-top: 40px;">

<h2>' . $LANG['loc_city_infos_title'] . '</h2>

</div>';

$lastupdate_by = \query\main::user_infos( $info->lastupdate_by );
$added_by = \query\main::user_infos( $info->user );

echo '<div class="infos-table" style="padding-bottom: 20px;">

<div class="row"><span>ID:</span> <div>' . $info->ID . '</div></div>
<div class="row"><span>' . $LANG['last_update_by'] . ':</span> <div>' . ( empty( $lastupdate_by->name ) ? '-' : ( ab_to( array( 'users' => 'edit' ) ) ? '<a href="?route=users.php&amp;action=edit&amp;id=' . $lastupdate_by->ID . '">' . $lastupdate_by->name . '</a>' : $lastupdate_by->name ) ) . '</div></div>
<div class="row"><span>' . $LANG['last_update_on'] . ':</span> <div>' . $info->last_update . '</div></div>
<div class="row"><span>' . $LANG['added_by'] . ':</span> <div>' . ( empty( $added_by->name ) ? '-' : ( ab_to( array( 'users' => 'edit' ) ) ? '<a href="?route=users.php&amp;action=edit&amp;id=' . $added_by->ID . '">' . $added_by->name . '</a>' : $added_by->name ) ) . '</div></div>
<div class="row"><span>' . $LANG['added_on'] . ':</span> <div>' . $info->date . '</div></div>

</div>';

if( !empty( $mapskey ) ) {

?>

<script>

var marker, map, newlatlng, deflat, deflng;

deflat = parseFloat( $('[name="mapmarker"]').attr('data-lat') );
deflng = parseFloat( $('[name="mapmarker"]').attr('data-lng') );

function initMap() {
  map = new google.maps.Map(document.getElementById('map'), {
    zoom: 8,
    center: {lat: deflat, lng: deflng}
  });

  marker = new google.maps.Marker({
    map: map,
    draggable: true,
    position: {lat: deflat, lng: deflng}
  });
  marker.addListener('dragend', toggleBounce);
}

function toggleBounce(){
  $('input[name="mapmarker"]').val(this.getPosition());
}

function updateMarker(){
  var lat = $('select[name="state"]').find('option:selected').attr('data-lat');
  var lng = $('select[name="state"]').find('option:selected').attr('data-lng');
  newlatlng = new google.maps.LatLng(lat,lng);
  marker.setPosition(newlatlng);
  map.setCenter(newlatlng);
}

</script>

<script async defer src="https://maps.googleapis.com/maps/api/js?key=<?php echo htmlspecialchars( $mapskey ); ?>&signed_in=true&callback=initMap"></script>

<?php } ?>

<script>

$( document ).ready(function() {

$( 'select[name="country"]' ).search_store_location( {}, "country", function(){
  updateMarker();
} );

$(document).on('change', 'select[name="state"]', function(){
  updateMarker();
});

});

</script>

<script src="js/search_location.js"></script>

<?php

} else echo '<div class="a-error">' . $LANG['invalid_id'] . '</div>';

break;

/** LIST OF CITIES */

case 'cities':

if( !ab_to( array( 'locations' => 'view' ) ) ) die;

echo '<div class="title">

<h2>' . $LANG['loc_city_title'] . '</h2>

<div style="float:right; margin: 0 2px 0 0;">';
if( ab_to( array( 'locations' => 'add' ) ) ) echo '<a href="?route=locations.php&amp;action=city_add" class="btn">' . $LANG['locations_city_add'] . '</a>';
echo '</div>';

if( !empty( $LANG['loc_city_subtitle'] ) ) {
  echo '<span>' . $LANG['loc_city_subtitle'] . '</span>';
}

echo '</div>';

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'locations_csrf' ) ) {

if( isset( $_POST['delete'] ) ) {

  if( isset( $_POST['id'] ) )
  if( actions::delete_city( array_keys( $_POST['id'] ) ) )
  echo '<div class="a-success">' . $LANG['msg_deleted'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

} else if( isset( $_POST['set_action'] ) ) {

  if( isset( $_POST['id'] ) && isset( $_POST['action'] ) )
  if( actions::action_city( $_POST['action'], array_keys( $_POST['id'] ) ) )
  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

} else if( isset( $_GET['type'] ) && isset( $_GET['token'] ) && check_csrf( $_GET['token'], 'locations_csrf' ) ) {

if( $_GET['type'] == 'delete' ) {

  if( isset( $_GET['id'] ) )
  if( actions::delete_city( $_GET['id'] ) )
  echo '<div class="a-success">' . $LANG['msg_deleted'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

} else if( $_GET['type'] == 'publish' || $_GET['type'] == 'unpublish' ) {

  if( isset( $_GET['id'] ) )
  if( actions::action_city( $_GET['type'], $_GET['id'] ) )
  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

}

$csrf = $_SESSION['locations_csrf'] = \site\utils::str_random(10);

echo '<div class="page-toolbar">

<form action="#" method="GET" autocomplete="off">
<input type="hidden" name="route" value="locations.php" />
<input type="hidden" name="action" value="cities" />

' . $LANG['order_by'] . ':
<select name="orderby">';
foreach( array( 'date' => $LANG['order_date'], 'date desc' => $LANG['order_date_desc'], 'update' => $LANG['order_last_update'], 'update desc' => $LANG['order_last_update_desc'], 'name' => $LANG['order_name'], 'name desc' => $LANG['order_name_desc'] ) as $k => $v )echo '<option value="' . $k . '"' . (isset( $_GET['orderby'] ) && urldecode( $_GET['orderby'] ) == $k || !isset( $_GET['orderby'] ) && $k == 'name' ? ' selected' : '') . '>' . $v . '</option>';
echo '</select>';

if( isset( $_GET['search'] ) ) {
echo '<input type="hidden" name="search" value="' . htmlspecialchars( $_GET['search'] ) . '" />';
}

echo ' <button class="btn">' . $LANG['view'] . '</button>

</form>

<form action="#" method="GET" autocomplete="off">
<input type="hidden" name="route" value="locations.php" />
<input type="hidden" name="action" value="cities" />';

if( isset( $_GET['orderby'] ) ) {
echo '<input type="hidden" name="orderby" value="' . htmlspecialchars( $_GET['orderby'] ) . '" />';
}

echo '<input type="search" name="search" value="' . (isset( $_GET['search'] ) ? htmlspecialchars( $_GET['search'] ) : '') . '" placeholder="' . $LANG['loc_city_search_input'] . '" />
<button class="btn">' . $LANG['search'] . '</button>
</form>

</div>';

$p = \query\locations::have_cities( $options = array( 'per_page' => 10,  'state' => (isset( $_GET['state'] ) ? $_GET['state'] : ''), 'show' => 'all', 'search' => (isset( $_GET['search'] ) ? urldecode( $_GET['search'] ) : '') ) );

echo '<div class="results">' . ( (int) $p['results'] === 1 ? sprintf( $LANG['result'], $p['results'] ) : sprintf( $LANG['results'], $p['results'] ) );
if( !empty( $_GET['search'] ) ) echo ' / <a href="?route=locations.php&amp;action=cities">' . $LANG['reset_view'] . '</a>';
echo '</div>';

if( $p['results'] ) {

echo '<form action="?route=locations.php&amp;action=cities" method="POST">

<ul class="elements-list">

<li class="head"><input type="checkbox" id="selectall" data-checkall /> <label for="selectall"><span></span></label> ' . $LANG['name'] . '</li>';

$ab_edt  = ab_to( array( 'locations' => 'edit' ) );
$ab_del  = ab_to( array( 'locations' => 'delete' ) );

if( $ab_edt || $ab_del ) {

echo '<div class="bulk_options">';

  if( $ab_del ) echo '<button class="btn" name="delete" data-delete-msg="' . $LANG['delete_msg'] . '">' . $LANG['delete_all'] . '</button> ';

  if( $ab_edt ) {
    echo $LANG['action'] . ':
    <select name="action">';
    foreach( array( 'publish' => $LANG['publish'], 'unpublish' => $LANG['unpublish'] ) as $k => $v )echo '<option value="' . $k . '">' . $v . '</option>';
    echo '</select>
    <button class="btn" name="set_action">' . $LANG['set_all'] . '</button>';
  }

echo '</div>';

}

foreach( \query\locations::while_cities( array_merge( array( 'orderby' => (isset( $_GET['orderby'] ) ? urldecode( $_GET['orderby'] ) : 'date desc') ), $options ) ) as $item ) {

  echo '<li>
  <div>

  <input type="checkbox" name="id[' . $item->ID . ']" id="id[' . $item->ID . ']" /> <label for="id[' . $item->ID . ']"><span></span></label>
  <div class="info-div"><h2>' . ( $item->visible ? '<span class="msg-success">' . $LANG['published'] . '</span> ' : '<span class="msg-error">' . $LANG['notpublished'] . '</span> ' ) . $item->name . '</h2></div>

  </div>

  <div style="clear:both;"></div>

  <div class="options">';
  if( $ab_edt ) {
  echo '<a href="?route=locations.php&amp;action=edit_city&amp;id=' . $item->ID . '">' . $LANG['edit'] . '</a>';
  echo '<a href="' . \site\utils::update_uri( '', array( 'type' => ( !$item->visible ? 'publish' : 'unpublish' ), 'id' => $item->ID, 'token' => $csrf ) ) . '">' . ( !$item->visible ? $LANG['publish'] : $LANG['unpublish'] ) . '</a>';
  }
  if( $ab_del ) echo '<a href="' . \site\utils::update_uri( '', array( 'type' => 'delete', 'id' => $item->ID, 'token' => $csrf ) ) . '" data-delete-msg="' . $LANG['delete_msg'] . '">' . $LANG['delete'] . '</a>';

  echo '</div>
  </li>';

}

echo '</ul>

<input type="hidden" name="csrf" value="' . $csrf . '" />

</form>';

if( isset( $p['prev_page'] ) || isset( $p['next_page'] ) ) {
  echo '<div class="pagination">';

  if( isset( $p['prev_page'] ) ) echo '<a href="' . $p['prev_page'] . '" class="btn">' . $LANG['prev_page'] . '</a>';
  if( isset( $p['next_page'] ) ) echo '<a href="' . $p['next_page'] . '" class="btn">' . $LANG['next_page'] . '</a>';

  if( $p['pages'] > 1 ) {
  echo '<div class="pag_goto">' . sprintf( $LANG['pageofpages'], $page = $p['page'], $pages = $p['pages'] ) . '
  <form action="#" method="GET">';
  foreach( $_GET as $gk => $gv ) if( $gk !== 'page' ) echo '<input type="hidden" name="' . htmlspecialchars( $gk ) . '" value="' . htmlspecialchars( $gv ) . '" />';
  echo '<input type="number" name="page" min="1" max="' . $pages . '" size="5" value="' . $page . '" />
  <button class="btn">' . $LANG['go'] . '</button>
  </form>
  </div>';
  }

  echo '</div>';
}

} else echo '<div class="a-alert">' . $LANG['no_cities_yet'] . '</div>';

break;

/** ADD STORE LOCATION */

case 'add_store_location':

if( !ab_to( array( 'stores' => 'edit' ) ) ) die;

$csrf = \site\utils::str_random(10);

echo '<div class="title">

<h2>' . $LANG['store_loc_add_title'] . '</h2>';

if( isset( $_GET['id'] ) && ( $store_exists = \query\main::store_exists( $_GET['id'] ) ) && ( $info = \query\main::store_infos( $_GET['id'] ) ) && $info->is_physical ) {

echo '<div style="float:right; margin: 0 2px 0 0;">

<a href="?route=stores.php&amp;action=edit&amp;id=' . $_GET['id'] . '" class="btn">' . $LANG['back'] . '</a>

</div>';

}

if( !empty( $LANG['store_loc_add_subtitle'] ) ) {
  echo '<span>' . $LANG['store_loc_add_subtitle'] . '</span>';
}

echo '</div>';

if( isset( $store_exists ) && $store_exists && $info->is_physical ) {

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'stores_csrf' ) ) {

  if( isset( $_POST['address'] ) && isset( $_POST['zip'] ) && isset( $_POST['country'] ) && isset( $_POST['state'] ) && isset( $_POST['city'] ) && isset( $_POST['mapmarker'] ) )
  if( actions::add_store_location(
  array(
  'Store' => $_GET['id'],
  'Address' => $_POST['address'],
  'Zip' => $_POST['zip'],
  'Country' => $_POST['country'],
  'State' => $_POST['state'],
  'City' => $_POST['city'],
  'Marker' => $_POST['mapmarker']
  ) ) ) {

  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  } else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

$_SESSION['stores_csrf'] = $csrf;

echo '<div class="form-table">

<form action="#" method="POST">

<div class="row"><span>' . $LANG['form_address'] . ':</span><div><input type="text" name="address" value="" required /></div></div>
<div class="row"><span>' . $LANG['loc_form_zip'] . ':</span><div><input type="text" name="zip" value="" /></div></div>

<div class="row"><span>' . $LANG['loc_form_country'] . ':</span><div><select name="country">';
$country = $state = 0;
foreach( \query\locations::while_countries( array( 'max' => 0, 'show' => 'all' ) ) as $k => $v ) {
  if( $k === 0 ) {
    $country = $v->ID;
  }
  echo '<option value="' . $v->ID . '">' . $v->name . '</option>';
}
echo '</select></div></div>

<div class="row"><span>' . $LANG['loc_form_state'] . ':</span><div><select name="state">';
foreach( \query\locations::while_states( array( 'max' => 0, 'country' => $country, 'show' => 'all' ) ) as $k => $v ) {
  if( $k === 0 ) {
    $state = $v->ID;
  }
  echo '<option value="' . $v->ID . '">' . $v->name . '</option>';
}
echo '</select></div></div>';

echo '<div class="row"><span>' . $LANG['loc_form_city'] . ':</span><div><select name="city">';
foreach( \query\locations::while_cities( array( 'max' => 0, 'state' => $state, 'show' => 'all' ) ) as $v ) {
  echo '<option value="' . $v->ID . '" data-lat="' . $v->lat . '" data-lng="' . $v->lng . '">' . $v->name . '</option>';
}
echo '</select></div></div>';

if( ( $mapskey = \query\main::get_option( 'google_maps_key' ) ) && !empty( $mapskey ) ) {
  echo '<div class="row"><span>' . $LANG['form_map'] . ':</span><div id="map" style="height: 400px;"></div></div>';
}

echo '<input type="hidden" name="mapmarker" value="39.82,-101.47" />
<input type="hidden" name="csrf" value="' . $csrf . '" />
<button class="btn">' . $LANG['store_loc_add_button'] . '</button>

</form>

</div>';

if( !empty( $mapskey ) ) {

?>

<script>

var marker, map, newlatlng, deflat, deflng;

deflat = 39.82;
deflng = -101.47;

function initMap() {
  map = new google.maps.Map(document.getElementById('map'), {
    zoom: 14,
    center: {lat: deflat, lng: deflng}
  });

  marker = new google.maps.Marker({
    map: map,
    draggable: true,
    position: {lat: deflat, lng: deflng}
  });
  marker.addListener('dragend', toggleBounce);
}

function toggleBounce(){
  $('input[name="mapmarker"]').val(this.getPosition());
}

function updateMarker(){
  var lat = $('select[name="city"]').find('option:selected').attr('data-lat');
  var lng = $('select[name="city"]').find('option:selected').attr('data-lng');
  newlatlng = new google.maps.LatLng(lat,lng);
  marker.setPosition(newlatlng);
  map.setCenter(newlatlng);
}

</script>

<script async defer src="https://maps.googleapis.com/maps/api/js?key=<?php echo htmlspecialchars( $mapskey ); ?>&signed_in=true&callback=initMap"></script>

<?php } ?>

<script>

$( document ).ready(function() {

$( 'select[name="country"]' ).search_store_location( {autoLoadCity: true}, "country", function(){
  updateMarker();
} );

$( 'select[name="state"]' ).search_store_location( {autoLoadCity: true}, "state", function(){
  updateMarker();
} );

$( 'select[name="city"]' ).search_store_location( {}, "city", function(){
  updateMarker();
} );

});

</script>

<script src="js/search_location.js"></script>

<?php

} else echo '<div class="a-error">' . $LANG['invalid_id'] . '</div>';

break;

/** EDIT STORE LOCATION */

case 'edit_store_location':

if( !ab_to( array( 'stores' => 'edit' ) ) ) die;

$csrf = \site\utils::str_random(10);

echo '<div class="title">

<h2>' . $LANG['store_loc_edit_title'] . '</h2>';

if( isset( $_GET['id'] ) && ( $store_exists = \query\locations::store_location_exists() ) ) {

$info = \query\locations::store_location_infos( $_GET['id'] );

echo '<div style="float:right; margin: 0 2px 0 0;">

<div class="options">
<a href="#" class="btn">' . $LANG['options'] . '</a>
<ul>';
echo '<li><a href="?route=stores.php&amp;action=edit&amp;id=' . $info->storeID . '&amp;type=delete_location&amp;locID=' . $_GET['id'] . '&amp;token=' . $csrf . '" data-delete-msg="' . $LANG['delete_msg'] . '">' . $LANG['delete'] . '</a></li>';
echo '</ul>
</div>

<a href="?route=stores.php&amp;action=edit&amp;id=' . $info->storeID . '" class="btn">' . $LANG['back'] . '</a>
</div>';

}

if( !empty( $LANG['store_loc_edit_subtitle'] ) ) {
  echo '<span>' . $LANG['store_loc_edit_subtitle'] . '</span>';
}

echo '</div>';

if( $store_exists ) {

if( $_SERVER['REQUEST_METHOD'] == 'POST' && isset( $_POST['csrf'] ) && check_csrf( $_POST['csrf'], 'stores_csrf' ) ) {

  if( isset( $_POST['address'] ) && isset( $_POST['zip'] ) && isset( $_POST['country'] ) && isset( $_POST['state'] ) && isset( $_POST['city'] ) && isset( $_POST['mapmarker'] ) )
  if( actions::edit_store_location( $_GET['id'],
  array(
  'Address' => $_POST['address'],
  'Zip' => $_POST['zip'],
  'Country' => $_POST['country'],
  'State' => $_POST['state'],
  'City' => $_POST['city'],
  'Marker' => $_POST['mapmarker']
  ) ) ) {

  $info = \query\locations::store_location_infos( $_GET['id'] );

  echo '<div class="a-success">' . $LANG['msg_saved'] . '</div>';
  } else
  echo '<div class="a-error">' . $LANG['msg_error'] . '</div>';

}

$_SESSION['stores_csrf'] = $csrf;

echo '<div class="form-table">

<form action="#" method="POST">

<div class="row"><span>' . $LANG['form_address'] . ':</span><div><input type="text" name="address" value="' . $info->address . '" required /></div></div>
<div class="row"><span>' . $LANG['loc_form_zip'] . ':</span><div><input type="text" name="zip" value="' . $info->zip . '" /></div></div>

<div class="row"><span>' . $LANG['loc_form_country'] . ':</span><div><select name="country">';
foreach( \query\locations::while_countries( array( 'max' => 0, 'show' => 'all' ) ) as $v ) {
  echo '<option value="' . $v->ID . '"' . ( $info->countryID == $v->ID ? ' selected' : '' ) . '>' . $v->name . '</option>';
}
echo '</select></div></div>

<div class="row"><span>' . $LANG['loc_form_state'] . ':</span><div><select name="state">';
foreach( \query\locations::while_states( array( 'max' => 0, 'country' => $info->countryID, 'show' => 'all' ) ) as $v ) {
  echo '<option value="' . $v->ID . '"' . ( $info->stateID == $v->ID ? ' selected' : '' ) . '>' . $v->name . '</option>';
}
echo '</select></div></div>';

echo '<div class="row"><span>' . $LANG['loc_form_city'] . ':</span><div><select name="city">';
foreach( \query\locations::while_cities( array( 'max' => 0, 'state' => $info->stateID, 'show' => 'all' ) ) as $v ) {
  echo '<option value="' . $v->ID . '" data-lat="' . $v->lat . '" data-lng="' . $v->lng . '"' . ( $info->cityID == $v->ID ? ' selected' : '' ) . '>' . $v->name . '</option>';
}
echo '</select></div></div>';

if( ( $mapskey = \query\main::get_option( 'google_maps_key' ) ) && !empty( $mapskey ) ) {
  echo '<div class="row"><span>' . $LANG['form_map'] . ':</span><div id="map" style="height: 400px;"></div></div>';
}

echo '<input type="hidden" name="mapmarker" value="' . $info->lat . ',' . $info->lng . '" data-lat="' . $info->lat . '" data-lng="' . $info->lng . '" />
<input type="hidden" name="csrf" value="' . $csrf . '" />
<button class="btn">' . $LANG['store_loc_edit_button'] . '</button>

</form>

</div>';

echo '<div class="title" style="margin-top: 40px;">

<h2>' . $LANG['store_loc_edit_infos_title'] . '</h2>

</div>';

$lastupdate_by = \query\main::user_infos( $info->lastupdate_by );
$added_by = \query\main::user_infos( $info->userID );

echo '<div class="infos-table" style="padding-bottom: 20px;">

<div class="row"><span>ID:</span> <div>' . $info->ID . '</div></div>
<div class="row"><span>' . $LANG['last_update_by'] . ':</span> <div>' . ( empty( $lastupdate_by->name ) ? '-' : ( ab_to( array( 'users' => 'edit' ) ) ? '<a href="?route=users.php&amp;action=edit&amp;id=' . $lastupdate_by->ID . '">' . $lastupdate_by->name . '</a>' : $lastupdate_by->name ) ) . '</div></div>
<div class="row"><span>' . $LANG['last_update_on'] . ':</span> <div>' . $info->last_update . '</div></div>
<div class="row"><span>' . $LANG['added_by'] . ':</span> <div>' . ( empty( $added_by->name ) ? '-' : ( ab_to( array( 'users' => 'edit' ) ) ? '<a href="?route=users.php&amp;action=edit&amp;id=' . $added_by->ID . '">' . $added_by->name . '</a>' : $added_by->name ) ) . '</div></div>
<div class="row"><span>' . $LANG['added_on'] . ':</span> <div>' . $info->date . '</div></div>

</div>';

if( !empty( $mapskey ) ) {

?>

<script>

var marker, map, newlatlng, deflat, deflng;

deflat = parseFloat( $('[name="mapmarker"]').attr('data-lat') );
deflng = parseFloat( $('[name="mapmarker"]').attr('data-lng') );

function initMap() {
  map = new google.maps.Map(document.getElementById('map'), {
    zoom: 14,
    center: {lat: deflat, lng: deflng}
  });

  marker = new google.maps.Marker({
    map: map,
    draggable: true,
    position: {lat: deflat, lng: deflng}
  });
  marker.addListener('dragend', toggleBounce);
}

function toggleBounce(){
  $('input[name="mapmarker"]').val(this.getPosition());
}

function updateMarker(){
  var lat = $('select[name="city"]').find('option:selected').attr('data-lat');
  var lng = $('select[name="city"]').find('option:selected').attr('data-lng');
  newlatlng = new google.maps.LatLng(lat,lng);
  marker.setPosition(newlatlng);
  map.setCenter(newlatlng);
}

</script>

<script async defer src="https://maps.googleapis.com/maps/api/js?key=<?php echo htmlspecialchars( $mapskey ); ?>&signed_in=true&callback=initMap"></script>

<?php } ?>

<script>

$( document ).ready(function() {

$( 'select[name="country"]' ).search_store_location( {autoLoadCity: true}, "country", function(){
  updateMarker();
} );

$( 'select[name="state"]' ).search_store_location( {autoLoadCity: true}, "state", function(){
  updateMarker();
} );

$( 'select[name="city"]' ).search_store_location( {}, "city", function(){
  updateMarker();
} );

});

</script>

<script src="js/search_location.js"></script>

<?php

} else echo '<div class="a-error">' . $LANG['invalid_id'] . '</div>';

break;

}