<?php

/** START SESSION */

session_start();

/** REPORT ALL PHP ERRORS */

error_reporting( E_ALL );

/** REQUIRE SETTINGS */

include 'settings.php';

/** CONNECT TO DB */

include IDIR . '/site/db.php';

if( ( $db_conn = $db->connect_errno ) && is_dir( 'install' ) ) {

  include 'install/index.php';
  die;

} else if( $db_conn ) {

  die('Failed to connect to MySQL (' . $db->connect_errno . ') ' . $db->connect_error);

}

$db->set_charset( DB_CHARSET );

/** */

spl_autoload_register(function ( $cn ) {

  $type = strstr( $cn, '\\', true );

  if( $type == 'plugin' ) {
    $cn = str_replace( '\\', '/', $cn );
    if( file_exists( ( $file = DIR . '/' . UPDIR . '/' . substr( $cn, strpos( $cn, '/' )+1 ) . '.php' ) ) )
    include $file;
  } else {
    if( file_exists( ( $file = DIR . '/' . IDIR . '/' . str_replace( '\\', '/', $cn ) . '.php' ) ) )
    include $file;
  }

});

/** */

if( !empty( $_GET ) ) {

$k = key( $_GET );
$v = current( $_GET );

if( defined( 'SEO_LINKS' ) && SEO_LINKS && isset( $_GET['hta'] ) ) {

$sp = array(
'ajax' => array( 'ajax' => strstr( $k, '/' ) ),
'cron' => array( 'cron' => strstr( $k, '/' ) ),
'whf' => array( 'whf' => strstr( $k, '/' ) ),
\query\main::get_option( 'seo_link_coupon' ) => array( 'id' => $v ),
\query\main::get_option( 'seo_link_product' ) => array( 'product' => $v ),
\query\main::get_option( 'seo_link_category' ) => array( 'cat' => $v ),
\query\main::get_option( 'seo_link_search' ) => array( 's' => isset( $_GET['s'] ) ? $_GET['s'] : '' ),
\query\main::get_option( 'seo_link_store' ) => array( 'store' => $v ),
\query\main::get_option( 'seo_link_stores' ) => array( 'stores' => $v ),
\query\main::get_option( 'seo_link_reviews' ) => array( 'reviews' => $v ),
\query\main::get_option( 'seo_link_user' ) => array( 'user' => strstr( $k, '/' ) ),
\query\main::get_option( 'seo_link_plugin' ) => array( 'plugin' => strstr( $k, '/' ) )
);

$k1 = strstr( key( $_GET ) . '/', '/', true );

if( in_array( $k1, array_keys( $sp ) ) ) {

  $k = key( $sp[$k1] );
  $v = current( $sp[$k1] );

} else if( !empty( $v ) ) {

  $k = 'p';

} else {

  $k = 'tpage';
  $v = key( $_GET );

}

}

switch( $k ) {

   case 'p':
   $GET['loc'] = 'page';
   $GET['id'] = $v;
   break;

   case 'id':
   $GET['loc'] = 'single';
   $GET['id'] = $v;
   break;

   case 'product':
   $GET['loc'] = 'product';
   $GET['id'] = $v;
   break;

   case 'cat':
   $GET['loc'] = 'category';
   $GET['id'] = $v;
   break;

   case 's':
   $GET['loc'] = 'search';
   $GET['id'] = $v;
   break;

   case 'store':
   $GET['loc'] = 'store';
   $GET['id'] = $v;
   break;

   case 'stores':
   $GET['loc'] = 'stores';
   break;

   case 'reviews':
   $GET['loc'] = 'reviews';
   $GET['id'] = $v;
   break;

   case 'user':
   $GET['loc'] = 'user';
   $GET['id'] = $v;
   break;

   case 'tpage':
   $GET['loc'] = 'tpage';
   $GET['id'] = $v;
   break;

   case 'ajax':
   $GET['loc'] = 'ajax';
   $GET['id'] = $v;
   break;

   case 'cron':
   $GET['loc'] = 'cron';
   $GET['id'] = $v;
   break;

   case 'plugin':
   $GET['loc'] = 'plugin';
   $GET['id'] = $v;
   break;

   case 'whf':
   $GET['loc'] = 'whf';
   $GET['id'] = $v;
   break;

}

}

$load = new \main\load;
$LANG = $load->get_language();
$load->execute();

$db->close();