<?php

if( !isset( $_GET['id'] ) || !\query\main::item_exists( $_GET['id'] ) ) {
  header( 'Location: ' . $GLOBALS['siteURL'] );
  die;
}

$info = \query\main::item_infos( $_GET['id'] );

if( !$info->is_printable ) {
  header( 'Location: ' . $GLOBALS['siteURL'] );
  die;
}

if( !empty( $info->source ) ) {
  if( !\site\utils::file_has_extension( $info->source, '.jpg,.jpeg,.png,.gif' ) ) {
  header( 'Location: ' . $info->source );
  die;
  }
}

echo '<!DOCTYPE html>

<html>

  <head>

    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <meta name="robots" content="noindex, nofollow">
    <title>' . $info->title . '</title>
    <link href="//fonts.googleapis.com/css?family=Raleway:100,200,300,400,500,600,700,800,900" rel="stylesheet" />
    <link href="' . MISCDIR . '/print.css" media="all" rel="stylesheet" />

  </head>

<body>

<div class="smalldev">
' . $LANG['msg_cant_print_sd'] . '<br />
<a href="' . $info->link . '">← ' . $LANG['back'] . '</a>
</div>

<div class="container">

<a href="#" class="btn margin-bottom-10" id="print">' . $LANG['print_coupon'] . '</a>';

if( empty( $info->source ) ) {

  echo '<div class="gen-container">

  <div class="sp">
  <img src="' . \query\main::store_avatar( $info->store_img ) . '" style="width:50%;max-height:100px;" alt="" />

  <h3>' . $info->store_name . '</h3>

  <ul>';
  if( !empty( $info->store_phone_no ) ) {
    echo '<li><span>' . $LANG['phone_no'] . ':</span> ' . $info->store_phone_no . '</li>';
  }
  echo '<li class="tbl"><span>' . $LANG['form_address'] . ':</span>';
  if( \query\locations::store_locations( array( 'store' => $info->storeID ) ) ) {
  echo '<ul>';
  foreach( \query\locations::while_store_locations( array( 'max' => 0, 'store' => $info->storeID ) ) as $loc ) {
    echo '<li>' . implode( array_filter( array( $loc->zip, $loc->country, $loc->state, $loc->city, $loc->address ) ), ', ' ) . '</li>';
  }
  echo '</ul>';
  } else {
    echo '-';
  }
  echo '</li>
  </ul>
  </div>

  <div class="cp">

  <h2>' . $info->title . '</h2>

  <ul>';
  if( !$info->is_started ) {
    echo '<li><span>' . $LANG['form_start_date'] . ':</span> ' . date( 'Y-m-d, H:i', strtotime( $info->start_date ) ) . ' (GMT ' . date( 'P' ) . ')</li>';
  }
  echo '<li><span>' . $LANG['form_expiration_date'] . ':</span> ' . date( 'Y-m-d, H:i', strtotime( $info->expiration_date ) ) . ' (GMT ' . date( 'P' ) . ')</li>
  <li><span>' . $LANG['form_description'] . ':</span> ' . ( !empty( $info->description ) ? $info->description : '-' ) . '</li>
  </ul>
  </div>

  </div>';

} else {

  echo '<div class="pic-container">
  <img src="' . $info->source . '" alt="coupon" />
  </div>';

}

echo '<div class="margin-top-10">
<a href="' . $info->link . '">← ' . $LANG['back'] . '</a> <br />
<a href="' . $info->store_link . '">← ' . $info->store_name . '</a>
</div>

</div>

<script>

document.getElementById("print").onclick = function(){
  window.print();
};

</script>

</body>

</html>';