<?php

namespace plugin\Popup\inc;

class actions {

/* ADD */

public static function add( $opt = array() ) {

global $db;

  $image = '';

  if( isset( $_FILES['image'] ) ) {

  $write_dir = DIR . '/' . UPDIR . '/Popup/pictures';

  if( !is_writable( $write_dir ) ) {
    if( !chmod( $write_dir, 0777 ) ) {
      throw new \Exception ( "The directory '{$write_dir}' isn't writable." );
    }
  }

  if( !empty( $_FILES['image']['name'] ) && ! \site\utils::file_has_extension( $opt['image']['name'], '.jpg,.jpeg,.png,.gif' ) ) {
    throw new \Exception( "This is not a valid extension, please use only jpg, png or gif files." );
  }

  $image = \site\images::upload( $opt['image'], 'popup_', array(  'path' => DIR . '/', 'location' => UPDIR . '/Popup/pictures', 'current' => '' ) );

  }

  $opt = \site\utils::array_map_recursive( 'trim', $opt );

  $stmt = $db->stmt_init();
  $stmt->prepare( "INSERT INTO " . DB_TABLE_PREFIX . "popups (type, height, width, title, text, image, href, effect, style, view, live, date) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, NOW())" );
  $stmt->bind_param( "sssssssssii", $opt['type'], $opt['height'], $opt['width'], $opt['title'], $opt['text'], $image, $opt['href'], $opt['effect'], $opt['style'], $opt['view'], $opt['publish'] );
  $execute = $stmt->execute();
  $stmt->close();

  if( $execute ) {
    return true;
  }

  throw new \Exception( "Error. We couldn't save this in database. :(" );

}

/* EDIT */

public static function edit( $id, $opt = array() ) {

global $db;

  $image = '';

  if( isset( $_FILES['image'] ) ) {

  $write_dir = DIR . '/' . UPDIR . '/Popup/pictures';

  if( !is_writable( $write_dir ) ) {
    if( !chmod( $write_dir, 0777 ) ) {
      throw new \Exception ( "The directory '{$write_dir}' isn't writable." );
    }
  }

  if( !empty( $opt['image']['name'] ) && ! \site\utils::file_has_extension( $opt['image']['name'], '.jpg,.jpeg,.png,.gif' ) ) {
    throw new \Exception( "This is not a valid extension, please use only jpg, png or gif files." );
  }

  $popup = \plugin\Popup\inc\query::popup_infos( $id );

  $image = \site\images::upload( $opt['image'], 'popup_', array(  'path' => DIR . '/', 'location' => UPDIR . '/Popup/pictures', 'current' => $popup->image ) );

  }

  $opt = \site\utils::array_map_recursive( 'trim', $opt );

  $stmt = $db->stmt_init();
  $stmt->prepare( "UPDATE " . DB_TABLE_PREFIX . "popups SET height = ?, width = ?, title = ?, text = ?, image = ?, href = ?, effect = ?, style = ?, view = ?, live = ? WHERE id = ?" );
  $stmt->bind_param( "ssssssssiii", $opt['height'], $opt['width'], $opt['title'], $opt['text'], $image, $opt['href'], $opt['effect'], $opt['style'], $opt['view'], $opt['publish'], $id );
  $execute = $stmt->execute();
  $stmt->close();

  if( $execute ) {
    return true;
  }

  throw new \Exception( "Error. We couldn't save this in database. :(" );

}

/* ACTION */

public static function action( $action, $id ) {

global $db;

  $id = (array) $id;

  $stmt = $db->stmt_init();

  switch( $action ) {
    case 'publish':
      $stmt->prepare( "UPDATE " . DB_TABLE_PREFIX . "popups SET live = 1 WHERE id = ?" );
    break;

    case 'unpublish':
      $stmt->prepare( "UPDATE " . DB_TABLE_PREFIX . "popups SET live = 0 WHERE id = ?" );
    break;

    default:
      return true;
    break;
  }

  foreach( $id as $ID ) {
  $stmt->bind_param( "i", $ID );
  $stmt->execute();
  }

  $stmt->close();

  return true;

}

/* DELETE */

public static function delete( $id ) {

global $db;

  $id = (array) $id;

  $stmt = $db->stmt_init();

  foreach( $id as $ID ) {

  if( \plugin\Popup\inc\query::popup_exists( $ID ) ) {

  $popup = \plugin\Popup\inc\query::popup_infos( $ID );

  // delete the pop-up
  $stmt->prepare( "DELETE FROM " . DB_TABLE_PREFIX . "popups WHERE id = ?" );
  $stmt->bind_param( "i", $ID );
  $stmt->execute();

  if( !empty( $popup->image ) ) {
    @unlink( DIR . '/' . $popup->image );
  }

  }

  }

  @$stmt->close();

  return true;

}

}